/* global Camera, Create3FirmPage, Create3Page */

var Create2Page = new Object();

    Create2Page.el = $('#create2');
    Create2Page.vehicles = [];
    Create2Page.vehiculeNum = 0;
    Create2Page.vehiculeCount = 0;
    Create2Page.vehicleNameAlert = false;
    Create2Page.vehiclePictureAlert = false;
    Create2Page.vehicleDuplicateNameAlert = false;
    Create2Page.vehicleNames = [];
    Create2Page.load = true;
    Create2Page.state;
    
    Create2Page.initialize = function() {
	this.eventHandler();
    };
	
    Create2Page.eventHandler = function () {
        
        this.el.on('click','.fake-menu, .back-menu',function(){
            if (Create2Page.state === "vehi")
                Create2Page.goToQuestion();
        });
        
        this.el.on('click',".add",function(event) {
            if(Create2Page.el.find('.vehicule').length===0){
                Create2Page.el.find('.vehiContainer').html('');
            }
            if(Create2Page.vehiculeCount<5){
                Create2Page.vehiculeCount++;
                Create2Page.vehiculeNum++;
                var html = vehicule_template({num: Create2Page.vehiculeNum, deletable: true});
                Create2Page.el.find(".vehiContainer").append(html);
            } else {
                alert("Vous avez atteint le nombre max de véhicule - 5");
            }
        });
        
        this.el.on('click','.del',function(){
            var object = $(this).parent().parent();
            navigator.notification.confirm(
                "Supprimer ce véhicule ?", 
                 function(index){
                    if (index === 2) {
                        var idBox = object.find('.idVehicule');
                        if(idBox.length===0){
                            object.remove();
                            Create2Page.vehiculeCount--;
                            Create2Page.numberVehi();
                            window.plugins.toast.showShortBottom('Véhicule supprimé');
                        } else {
                            window.plugins.toast.showShortTop('Envoi en cours...');
                            var data = {idVehicle : parseInt(idBox.val())};
                            Create2Page.sendVehicleDelete(data, object);
                        }
                    }
                },
                "Kankaroo",
                ["Annuler","Supprimer"]
            );		
        });
        
        this.el.on('click','.pass',function(){
            localStorage.createStateMemory = 3;
            Create3FirmPage.return ="#create3Special";
            Create3FirmPage.returnObject = Create3Page;
            goToPage("#create3firm");
        });
        
        this.el.on('click','.gotVehi',function(){
            Create2Page.goToVehi();
        });
        
        this.el.on('touchstart','label',function(event){
            $(this).one('touchmove',function (event){
                $(this).off('touchend'); 
            });
            $(this).one('touchend', function (event) {
                radioImg($(this),Create2Page);
                if ($(this).hasClass('radioCar')) {
                    $(this).parent().parent().find('select').val(3);
                }
                else if ($(this).hasClass('radioBike')) {
                    $(this).parent().parent().find('select').val(1);
                }
            });
        });
        
        this.el.on('click','.imageLoaded ,.imageLoadedLandscape',function(event){
            event.stopPropagation();
            var object = $(this);
            navigator.notification.confirm(
                "Supprimer cette photo ?", 
                 function(index){Create2Page.confirmDelCallback(index,object);},
                "Kankaroo",
                "Annuler,Supprimer"
            );		
        });


        var object; //contient la place de l'image à charger
        this.el.on('click','.image', function(event){
            event.stopPropagation();
            showPopUp(Create2Page);
            object = $(this);
        });

        this.el.on('click','.overlay',function(event){
            event.stopPropagation();
            hidePopUp(Create2Page);
        });

        this.el.on('click','.popUp',function(event){
            event.stopPropagation();
        });

        this.el.on('click',".popUpCamera", function(event) {
            event.stopPropagation();
            Create2Page.handleCamera(object.find('.camera'));
            hidePopUp(Create2Page);
        });

        this.el.on('click',".popUpGallery", function(event) {
            event.stopPropagation();
            Create2Page.handleGallery(object.find('.camera'));
            hidePopUp(Create2Page);
        });
        
        this.el.on('click',".valid",function(event) {
            event.preventDefault();
            Create2Page.vehicleNames = [];
            Create2Page.vehicleNameAlert = false;
            Create2Page.vehicleDuplicateNameAlert = false;
            Create2Page.vehiclePictureAlert = false;
            Create2Page.el.find('.vehicule').each(Create2Page.checkVehicleData);
            if (Create2Page.vehicleNameAlert) {
                alert("Précisez le modèle du véhicule");
            } else if (Create2Page.vehicleDuplicateNameAlert) {
                alert("Le modèle de chaqu'un de vos véhicules doit être unique");
            } else if (Create2Page.vehiclePictureAlert) {
                navigator.notification.confirm(
                "Ajoutez une photo de votre véhicule !", 
                function(index){
                    if (index === 1) {
                        Create2Page.readyToSendVehicles();
                    }
                },
                "Kankaroo",
                "Plus tard,Ajouter"
                );
            }
            else {
                Create2Page.readyToSendVehicles();
            }
        });
        
    };
    
    Create2Page.readyToSendVehicles = function() {
        localStorage.createStateMemory = 3;
        Create3FirmPage.return ="#create3Special";
        Create3FirmPage.returnObject = Create3Page;
        goToPage("#create3firm");
        var requestsSynchro = {number : Create2Page.vehiculeCount, success : true};
        Create2Page.el.find('.vehicule').each(function(){Create2Page.validVehicule($(this), requestsSynchro);});
    };
    
    Create2Page.sendVehicleDelete = function(data, object) {
        serverRequest(
            "/vehicles/delete",
            "GET",
            function(data) {
                object.remove();
                Create2Page.vehiculeCount--;
                Create2Page.numberVehi();
                window.plugins.toast.showShortBottom('Véhicule supprimé');
            },
            "send Vehicle Delete",
            function() {Create2Page.sendVehicleDelete(data, object);},
            data 
        );
    };
    
    Create2Page.handleCamera = function(object) {
        event.stopPropagation();
        navigator.camera.getPicture( 
            function (data) {
                Create2Page.cameraSuccess(data,object.parent());
                if(object.parent().hasClass('car'))
                    object.parent().parent().append("<span class='vehicleModified'></span>");
                else object.parent().parent().append("<span class='insuranceModified'></span>");
            }, 
            Create2Page.cameraError, 
            { 	
                    quality : 50, 
                    destinationType : Camera.DestinationType.DATA_URL, 
                    sourceType : Camera.PictureSourceType.CAMERA, 
                    allowEdit : true,
                    encodingType: Camera.EncodingType.JPEG,
                    targetWidth: 300,
                    targetHeight: 300,
                    correctOrientation:1,
                    saveToPhotoAlbum: false 
            }
        );
    };

    Create2Page.handleGallery = function(object) {
        event.stopPropagation();
        navigator.camera.getPicture( 
            function (data) {
                Create2Page.cameraSuccess(data,object.parent());
                if(object.parent().hasClass('car'))
                    object.parent().parent().append("<span class='vehicleModified'></span>");
                else object.parent().parent().append("<span class='insuranceModified'></span>");
            }, 
            Create2Page.cameraError, 
            { 	
                    quality : 50, 
                    destinationType : Camera.DestinationType.DATA_URL, 
                    sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
                    allowEdit : true,
                    encodingType: Camera.EncodingType.JPEG,
                    targetWidth: 300,
                    targetHeight: 300,
                    correctOrientation:1,
                    saveToPhotoAlbum: false 
            }
        );
    };
    
    Create2Page.checkVehicleData = function() {
        var object = $(this);
        var vehicleName = object.find('.name').val();
        if(vehicleName==="Modèle du véhicule"){
            Create2Page.vehicleNameAlert = true;
            return false;
        }
        else if (Create2Page.vehicleNames.indexOf(vehicleName) >= 0) {
            Create2Page.vehicleDuplicateNameAlert = true;
            return false;
        }
        else Create2Page.vehicleNames.push(vehicleName);
        if(object.find('.car').find(".camera").length>0){
            Create2Page.vehiclePictureAlert = true;
        }
    };
    
    Create2Page.validVehicule = function(object, requestsSynchro){
        var formData = {
            'name'			: object.find('.name').val(),
            'smoking'                   : object.find("label[for='"+object.find('input[value="true"]').attr('id')+"']").hasClass('selectedLabel'),
            'seats'			: parseInt(object.find('select').val())
            };
        if (object.find('.radioBike').hasClass('selectedLabel')){
            formData.type = "moto";
        } else {
            formData.type = "car";
        }   
        
        if(object.find('.idVehicule').length===0) {
            if(object.find('.car').find("img").length===1){
                formData.vehiclePicture = object.find('.car').find('img').attr('src').substring(23,object.find('.car').find('img').attr('src').length);
            }
            if(object.find('.insurance').find("img").length===1){
                formData.insurancePicture = object.find('.insurance').find('img').attr('src').substring(23,object.find('.insurance').find('img').attr('src').length);
            }
            Create2Page.sendNewVehicle(formData, object, requestsSynchro);
        } else {
            formData.idVehicle = parseInt(object.find('.idVehicule').val());
            if (object.find('.vehicleModified').length !== 0)
            {
                if(object.find('.car').find("img").length===1){
                    formData.vehiclePicture = object.find('.car').find('img').attr('src').substring(23,object.find('.car').find('img').attr('src').length);
                } else {
                    formData.vehiclePicture = "";
                }
            }
            if (object.find('.insuranceModified').length !== 0)
            {
                if(object.find('.insurance').find("img").length===1){
                    formData.insurancePicture = object.find('.insurance').find('img').attr('src').substring(23,object.find('.insurance').find('img').attr('src').length);
                } else {
                    formData.insurancePicture = "";
                }
            }
            formData = Create2Page.checkModif(formData);
            Create2Page.sendOldVehicle(formData, object, requestsSynchro);
        }
    };
    
    Create2Page.sendNewVehicle = function (formData, object, requestsSynchro) {
        serverRequest(
            "/vehicles/create",
            "POST",
            function(data) {
                object.append('<input type="text" class="idVehicule" name="idVehicule" style="display:none" value="'+data.idVehicle+'">');
            },
            "create or modify vehicle Create2",
            function() {Create2Page.sendNewVehicle(formData, object, requestsSynchro);},
            formData,
            null,
            null,
            null,
            requestsSynchro
        );
    };
    
    Create2Page.sendOldVehicle = function(formData, object, requestsSynchro) {
        serverRequest(
            "/vehicles/modify",
            "POST",
            function(data) {},
            "create or modify vehicle Create2",
            function() {Create2Page.sendOldVehicle(formData, object, requestsSynchro);},
            formData,
            null,
            null,
            null,
            requestsSynchro
        );
    };
    
    Create2Page.checkModif = function (data) {
        var result = $.grep(Create2Page.vehicles, function(e){ return e.idvehicle === data.idVehicle; });
        var object = result[0];
        if(object){
            if(data.name === object.name){
                delete data.name;
            }
            if(data.type === object.type){
                delete data.type;
            }
            if(data.seats === object.freeSeats){
                delete data.seats;
            }
            if(data.smoking === object.smoking){
                delete data.smoking;
            }
        }
        return data;

    };
    
    Create2Page.confirmDelCallback = function(index,object){
            if(index===2){
                if(object.parent().hasClass("car")){
                    object.parent().parent().append("<span class='vehicleModified'></span>");
                    object.parent().html("<img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Photo du véhicule</div>");
                } else {
                    object.parent().parent().append("<span class='insuranceModified'></span>");
                    object.parent().html("<img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Vignette d’assurance</div>");
                }
            }
    };

    //Affiche la page
    Create2Page.render = function () {
        Create2Page.reset();
        this.el.addClass("shown");
        
        if (Create2Page.load) {
            showLoading();
            Create2Page.getMyCars();
        } else {
            Create2Page.numberVehi();
            Create2Page.goToQuestion();
            Create2Page.load = true;
        }
    };
    
    Create2Page.goToQuestion = function() {
        Create2Page.el.find('.question').show();
        Create2Page.el.find('.driver').hide();
        Create2Page.el.find('.fake-menu').show();
        Create2Page.el.find('.back-menu').hide();
        Create2Page.state = "question";
    };
    
    Create2Page.goToVehi = function() {
        Create2Page.el.find('.question').hide();
        Create2Page.el.find('.driver').show();
        Create2Page.el.find('.fake-menu').hide();
        Create2Page.el.find('.back-menu').show();
        Create2Page.el.find('.addPadding').css("height", Create2Page.el.find('.add').outerHeight());
        Create2Page.state = "vehi";
    };
    
    Create2Page.getMyCars = function () {
        //récupère les informations
        serverRequest(
            "/vehicles/list",
            "GET",
            function(data) {
                Create2Page.getMyCarsSuccess(data);
            },
            "get my cars list",
            Create2Page.getMyCars,
            null             
        );        
    };
        
    Create2Page.getMyCarsSuccess = function (data) {
        var list = JSON.parse(data.vehicles);
        Create2Page.vehicles = list;
        Create2Page.el.find('.vehicule').each(function(){
            var object = $(this);
            if (object.find('.idVehicule').length === 0){
                object.remove();
            }
        });
        if(list.length>0){
            Create2Page.vehiculeCount = list.length;
            var requestsSynchro = {number : 2*Create2Page.vehiculeCount, success : true};
            for(var i=0;i<list.length;i++){
                if (Create2Page.el.find("input[value='"+list[i].idvehicle+"']").length === 0){
                    Create2Page.vehiculeNum++;
                    var templateObject = new Object();
                    templateObject.num = Create2Page.vehiculeNum;
                    var idObject = { id : list[i].idvehicle };
                    templateObject.idVehicule = idObject;
                    templateObject.deletable = true;
                    var object = $(vehicule_template(templateObject));
                    Create2Page.el.find(".vehiContainer").append(object);
                } else {
                    var object = Create2Page.el.find("input[value='"+list[i].idvehicle+"']").parent('.vehicule');
                }
                
                if (list[i].type==="moto"){
                    object.find(".radioBike").trigger("touchstart").trigger("touchend");
                } else {
                    object.find(".radioCar").trigger("touchstart").trigger("touchend");
                }
                if (list[i].smoking){
                    object.find(".radioSmoke").trigger("touchstart").trigger("touchend");
                } else {
                    object.find(".radioNSmoke").trigger("touchstart").trigger("touchend");
                }
                object.find('select').val(list[i].freeSeats);
                object.find('.name').val(list[i].name).addClass("focus");
                Create2Page.addImg(object,list[i].idvehicle, requestsSynchro);
            }
            Create2Page.goToVehi();
        } else  {
            endLoading();
            Create2Page.numberVehi();
            Create2Page.goToQuestion();
        }
    };
    
    Create2Page.numberVehi = function() {
        if(this.el.find('.vehicule').length===0){
            Create2Page.vehiculeCount++;
            Create2Page.vehiculeNum++;
            var html = vehicule_template({num: Create2Page.vehiculeNum});
            Create2Page.el.find(".vehiContainer").append(html);
        }
    };
    
    Create2Page.addImg = function(object,idvehicle, requestsSynchro){
        //récupère les informations
        var data =new Object();
        data.idVehicle = idvehicle;
        serverRequest(
            "/vehicles/vehiclePicture",
            "GET",
            function(data) {
                if(typeof data.noPicture !== "undefined"){
                } else {
                    Create2Page.cameraSuccess(data.picture,object.find('.car'));
                }
            },
            "get vehicleImg",
            null,
            data,
            null,
            null,
            null,
            requestsSynchro
        );
        
        serverRequest(
            "/vehicles/insurancePicture",
            "GET",
            function(data) {
                if(typeof data.noPicture !== "undefined"){
                } else {
                    Create2Page.cameraSuccess(data.picture,object.find('.insurance'));
                }
            },
            "get insuranceImg",
            null,
            data,
            null,
            null,
            null,
            requestsSynchro
        );
    };
    
    Create2Page.reset = function (){
        this.el.find('.vehiContainer').html('');
        Create2Page.vehiculeNum = 0;
        Create2Page.vehiculeCount = 0;
        Create2Page.el.find('.fake-menu').show();
        Create2Page.el.find('.back-menu').hide();
        Create2Page.el.find('.question').hide();
        Create2Page.el.find('.driver').hide();
    };
    
    Create2Page.cameraError = function (message) {
    };

    Create2Page.cameraSuccess = function (imageData,object) {
        var image = $('<img>');
        var height = object.height();
        object.css('max-height',height+"px");
        object.css('height',height+"px");
        image.bind('load', function(evt) {
            // The image has been loaded and the data is ready
            var image_width = this.width;
            var image_height = this.height;
            if(image_height===image_width){
                object.html("<img class='imageLoaded' src=data:image/jpeg;base64,"+ imageData+">");
            }else if (image_height>image_width){
                object.html("<img class='imageLoaded' src=data:image/jpeg;base64,"+ imageData+">");
            } else {
                object.html("<img class='imageLoadedLandscape' src=data:image/jpeg;base64,"+ imageData+">");
            }

            // We don't need the image element anymore. Get rid of it.
        image = null;
        });
        // Load the read data into the image source. It's base64 data
        image.attr('src',"data:image/jpeg;base64,"+imageData);
    };