/* global Create3FirmPage, PartirPage, Create2Page, Camera, MyProfilePage, MyTravels */

var Create3Page = new Object();

Create3Page.el = $('#create3');
Create3Page.load = true;
Create3Page.alreadyAPicture = false;
Create3Page.formData;

//Fonction d'initialisation, affecte les evenements.
Create3Page.initialize = function() {
    this.eventHandler();
};

Create3Page.eventHandler = function () {

    this.el.on('click',".valid",function(event) {
        event.preventDefault();
        Create3Page.sendData();
    });

    this.el.on('touchstart','label',function(event){
        $(this).one('touchmove',function (event){
            $(this).off('touchend'); 
        });
        $(this).one('touchend', function (event) {
            radioImg($(this),Create3Page);
        });
    });

    this.el.on('click','.imageLoaded, .imageLoadedLandscape',function(event){
        event.stopPropagation();
        var object = $(this);
        navigator.notification.confirm("Supprimer cette photo ?", function(index){Create3Page.confirmDelCallback(index,object);}, "Kankaroo", "Annuler,Supprimer");		
    });


    var object; //contient la place de l'image à charger
    this.el.on('click','.image', function(event){
        event.stopPropagation();
        Create3Page.el.find('.additionalStuff').hide();
        showPopUp(Create3Page);
        object = $(this);
    });

    this.el.on('click','.overlay',function(event){
        event.stopPropagation();
        hidePopUp(Create3Page);
    });

    this.el.on('click','.popUp',function(event){
        event.stopPropagation();
    });

    this.el.on('click',".popUpCamera", function(event) {
        event.stopPropagation();
        Create3Page.handleCamera(Create3Page.el.find('.camera'));
        hidePopUp(Create3Page);
    });

    this.el.on('click',".popUpGallery", function(event) {
        event.stopPropagation();
        Create3Page.handleGallery(Create3Page.el.find('.camera'));
        hidePopUp(Create3Page);
    });

    this.el.on('click','#firm',function(event){
        Create3Page.load = false;
        Create3FirmPage.return ="#create3";
        Create3FirmPage.returnObject = Create3Page;
        goToPage("#create3firm");
    });

    this.el.on('click','.back-menu',function(event){
        Create3FirmPage.return ="#create3Special";
        Create3FirmPage.returnObject = Create3Page;
        goToPage("#create3firm");
    });

    this.el.on('click',".later", function(event) {
        localStorage.createStateMemory = 0;
        MyTravels.showTuto = true;
        PartirPage.reload = true;
        goToPage("#myTravels");
        Create3Page.endSendData(Create3Page.formData);
        Create3Page.reset();
    });
};

Create3Page.handleCamera = function(object) {
    event.stopPropagation();
    navigator.camera.getPicture( 
        function (data) {
            object.parent().parent().append("<span class='meModified'></span>");
            Create2Page.cameraSuccess(data,object.parent());
        }, 
        Create2Page.cameraError, 
        { 	
                quality : 50, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.CAMERA, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 600,
                targetHeight: 600,
                correctOrientation:1,
                saveToPhotoAlbum: false 
        }
    );
};

Create3Page.handleGallery = function(object) {
    event.stopPropagation();
    navigator.camera.getPicture( 
        function (data) {
            object.parent().parent().append("<span class='meModified'></span>");
            Create2Page.cameraSuccess(data,object.parent());
        }, 
        Create2Page.cameraError, 
        { 	
                quality : 50, 
                destinationType : Camera.DestinationType.DATA_URL, 
                sourceType : Camera.PictureSourceType.PHOTOLIBRARY, 
                allowEdit : true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 600,
                targetHeight: 600,
                correctOrientation:1,
                saveToPhotoAlbum: false 
        }
    );
};

Create3Page.sendData = function(){
    var formData = {
      "comment"     : Create3Page.el.find('textarea').val(),
      "preferences" : Create3Page.el.find('input[name="music"]').val(),
      "workplace"   : Create3Page.el.find('#firm').html(),
      "transport"   : Create3Page.el.find("input[id='"+Create3Page.el.find('.selectedLabel').attr('for')+"']").val()
    };
    if (formData.comment === Create3Page.el.find('textarea[name="comment"]').attr('placeholder')){
        formData.comment = "";
    }
    if (formData.workplace.substring(0,1) === "<"){
        formData.workplace = "";
    } else {
        formData.workplace = restoreXml(formData.workplace);
    }
    if (formData.preferences === Create3Page.el.find('input[name="music"]').attr('placeholder'))
    {
        formData.preferences = "";
    }
    if (Create3Page.el.find('.meModified').length !== 0 | Create3Page.alreadyAPicture === true){
        if (Create3Page.el.find('.meModified').length !== 0)
            formData.picture = Create3Page.el.find('.me').find('img').attr('src').substring(23,Create3Page.el.find('.me').find('img').attr('src').length);
        localStorage.createStateMemory = 0;
        MyTravels.showTuto = true;
        PartirPage.reload = true;
        goToPage("#myTravels");
        Create3Page.endSendData(formData);
        Create3Page.reset();
    }
    else {
        Create3Page.formData = formData;
        Create3Page.el.find('.additionalStuff').show();
        showPopUp(Create3Page);
    }
};

Create3Page.endSendData = function(formData) {
    serverRequest(  
        "/profile/modify",
        "POST",
        function(data){},
        "modify profil create3",
        function() {Create3Page.endSendData(formData);},
        formData                        
    );
};

Create3Page.confirmDelCallback= function(index,object){
    if(index===2){
        if(object.parent().hasClass("me")){
            object.parent().parent().append("<span class='meModified'></span>");
            object.parent().html("<img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Photo de moi</div>");
        }
    }  
};

//Affiche la page
Create3Page.render = function () {
    this.el.addClass("shown");
    if(Create3Page.load){
        Create3Page.getImg();
    } else {
        Create3Page.load=true;
    }
    var width = Create3Page.el.find('.image').width();
    Create3Page.el.find('.image').css('height',width);
    Create3Page.el.find('textarea').css('height',width - 10);
};

Create3Page.getImg = function(){
    serverRequest(
        "/profile/picture",
        "GET",
        Create3Page.gotImg,
        "image profil create3",
        Create3Page.getImg,
        null                        
    );
};

Create3Page.gotImg = function (data) {
    if (typeof data.noPicture !== "undefined"){
        Create3Page.alreadyAPicture = false;
    } else if (typeof data.picture !== "undefined"){
        Create3Page.alreadyAPicture = true;
        Create2Page.cameraSuccess(data.picture,Create3Page.el.find('.image'));
    } else if (typeof data.url !== "undefined") {
        Create3Page.alreadyAPicture = true;
        Create3Page.loadImgFromUrl(data.url,Create3Page.el.find('.image'));
    }
};

Create3Page.loadImgFromUrl = function(url,object) {
    var image = $('<img>');
    var height = object.height();
    object.css('max-height',height+"px");
    object.css('height',height+"px");
    image.bind('load', function(evt) {
        // The image has been loaded and the data is ready
        var image_width = this.width;
        var image_height = this.height;
        if(image_height===image_width){
            object.html("<img class='imageLoaded' src="+ url +">");
        }else if (image_height>image_width){
            object.html("<img class='imageLoaded' src="+url+">");
        } else {
            object.html("<img class='imageLoadedLandscape' src="+url+">");
        }

        // We don't need the image element anymore. Get rid of it.
        image = null;
    });
    // Load the read data into the image source. It's base64 data
    image.attr('src',url);
};

Create3Page.reset = function (){
    Create3Page.alreadyAPicture = false;
    Create3Page.el.find('.comments').html('');
    Create3Page.el.find('.noteBar .rating').html('');
    Create3Page.el.find("textarea").val('');
    Create3Page.el.find("input[name='music']").val('');
    Create3Page.el.find('#firm').html('<span style="color: rgb(140,140,140)">Entreprise ou campus</span>');
    Create3Page.el.find('.me').html("<img class='camera' src='img/add_photo.svg'><div style='margin-left: 3%; margin-right: 3%'>Photo de moi</div>");
    Create3Page.el.find("label[for='"+MyProfilePage.el.find("input[value='car']").attr('id')+"']").trigger("touchstart").trigger("touchend");
};

