/* global cordova, Create2Page, Create3Page */

var CreatePage = new Object();

CreatePage.el = $('#create');
CreatePage.formFill;
CreatePage.continueType;

//Fonction d'initialisation, affecte les evenements.
CreatePage.initialize = function() {
        this.eventHandler();
};

CreatePage.eventHandler = function () {
    this.el.on('touchstart','label',function(event){
        $(this).one('touchmove',function (event){
            $(this).off('touchend'); 
        });
        $(this).one('touchend', function (event) {
            if($(this).hasClass("left") || $(this).hasClass("right")) radioImg($(this),CreatePage);
        });
    });

    this.el.find('form').submit(function (event) {
        event.preventDefault();
        CreatePage.el.find(".create_error").hide();
        CreatePage.formFill = {
            'firstName'			: CreatePage.el.find('input[name=firstName]').val(),
            'name'			        : CreatePage.el.find('input[name=name]').val(),
            'sex'                           : CreatePage.el.find("label[for=femaleC]").hasClass('selectedLabel'),
            'mail' 				: CreatePage.el.find('input[name=mail]').val(),
            'password' 			: CreatePage.el.find('input[name=password]').val()
        };
        var valid = true;
        if(CreatePage.formFill.firstName==="Prénom*"){
            CreatePage.el.find('.firstName').show();
            valid=false;
        }
        if(CreatePage.formFill.name==="Nom* (non divulgué)"){
            CreatePage.el.find('.name').show();
            valid=false;
        }
        if(CreatePage.formFill.password.length<8){
            CreatePage.el.find('.pass').show();
            valid=false;
        }
        if(!CreatePage.formFill.mail||CreatePage.formFill.mail.indexOf("@")===-1){
            CreatePage.el.find('.mail').show();
            valid=false;
        }
        if(CreatePage.el.find('.selectedLabel').length===0){
            CreatePage.el.find('.sex').show();
            valid=false;
        }
        if(valid) {
            CreatePage.continueType = "form";
            CreatePage.showCGUPopUp();
        }
        else {
            alert('Information incomplètes ou incorrectes');
        }
    });

    this.el.on('click','.alreadyUser',function(){
        goToPage('#login');
     });
     
    this.el.on('click','.facebook',function(){
        CreatePage.continueType = "facebook";
        CreatePage.showCGUPopUp();
    });
    
    this.el.on('click','.overlay, .popUpCancel',function(){
        hidePopUp(CreatePage);
    });
    
    this.el.on('click','#facebook',function(){
        if (CreatePage.continueType === "facebook")
            fbLogin();
        else if (CreatePage.continueType === "form") {
            showLoading();
            CreatePage.createRequest(CreatePage.formFill);
        }
    });
    
    this.el.on('click','.popUp',function(event){
        event.stopPropagation();
    });
    
    this.el.on('click','.firstName',function(event){
        setTimeout(function(){
            CreatePage.el.find('input[name=firstName]').focus();
            cordova.plugins.Keyboard.show();
        },100);
    });
    
    this.el.on('click','.name',function(event){
        setTimeout(function(){
            CreatePage.el.find('input[name=name]').focus();
            cordova.plugins.Keyboard.show();
        },100);
    });
    
    this.el.on('click','.mail',function(event){
        setTimeout(function(){
            CreatePage.el.find('input[name=mail]').focus();
            cordova.plugins.Keyboard.show();
        },100);
    });
    
    this.el.on('click','.pass',function(event){
        setTimeout(function(){
            CreatePage.el.find('input[name=password]').focus();
            cordova.plugins.Keyboard.show();
        },100);
    });
};

CreatePage.createRequest = function(formData) {
    serverRequest(
        "/createAccountAttempt",
        "POST",
        function(data) {
            CreatePage.createSuccess(data,formData);
        },
        "create account",
        null,
        formData,
        null,
        null,
        null
    );
};

CreatePage.createSuccess = function(data,formData) {
    hidePopUp(CreatePage);
    if (typeof data.error !== "undefined")
    {
        alert("Cette adresse mail correspond déjà à un compte Kankaroo");
    } else {
        sendRegIDToServer();
        localStorage.mail = formData.mail;
        localStorage.loginToken = data.loginToken;
        localStorage.userId = data.id;
        localStorage.hadAccount = true;
        localStorage.createStateMemory = 2;
        Create2Page.load = false;
        Create3Page.reset();
        goToPage("#create2");
        endLoading();
    }
};

CreatePage.showCGUPopUp = function() {
    CreatePage.el.find('.onoffswitch-checkbox[value="CGU"]').prop('checked', false);
    CreatePage.el.find('.popUpCancel').show();
    CreatePage.el.find('#facebook').hide();
    showPopUp(CreatePage);
};

//Affiche la page
CreatePage.render = function () {
    CreatePage.reset();
    $(".create_error").hide();
    this.el.addClass("shown");
};

CreatePage.reset = function () {
    this.el.find('form')[0].reset();
    this.el.find('.focus').removeClass('focus');
    var img = CreatePage.el.find('.selectedLabel').find('img');
    if (img.length !== 0) {
        replaceImgSrc(img.attr("src").substring(0, img.attr("src").length - 5) + "0.svg", img);
    }
    this.el.find('.selectedLabel').removeClass("selectedLabel");
    hidePopUp(CreatePage);
    CreatePage.formFill = {};
};