var Feedback = new Object();

Feedback.el = $('#feedback');
Feedback.fullStarUrl="img/rattingStar0.svg";
Feedback.emptyStarUrl="img/rattingStarEmpty.svg";
Feedback.grade;

//Fonction d'initialisation, affecte les evenements.
Feedback.initialize = function () {
    this.eventHandler();
};

Feedback.eventHandler = function () {
    this.el.on('click', ".star1", function() {
        Feedback.starOne(Feedback);
    });
    
    this.el.on('click', ".star2", function() {
        Feedback.starTwo(Feedback);
    });
    
    this.el.on('click', ".star3", function() {
        Feedback.starThree(Feedback);
    });
    
    this.el.on('click', ".star4", function() {
        Feedback.starFour(Feedback);
    });
    
    this.el.on('click', ".star5", function() {
        Feedback.starFive(Feedback);
    });
    
    this.el.on('click', '.valid', function () {
        Feedback.prepareRequest();
    });
    
};

Feedback.starOne = function(page) {
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star1'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star2'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star3'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star4'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star5'));
    page.grade = 1;
};

Feedback.starTwo = function(page) {
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star1'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star2'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star3'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star4'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star5'));
    page.grade = 2;
};

Feedback.starThree = function(page) {
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star1'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star2'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star3'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star4'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star5'));
    page.grade = 3;
};

Feedback.starFour = function(page) {
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star1'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star2'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star3'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star4'));
    replaceImgSrc(Feedback.emptyStarUrl, page.el.find('.star5'));
    page.grade = 4;
};

Feedback.starFive = function(page) {
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star1'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star2'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star3'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star4'));
    replaceImgSrc(Feedback.fullStarUrl, page.el.find('.star5'));
    page.grade = 5;
};

Feedback.prepareRequest = function(){
    var data = new Object();
    var send = false;
    var positive = Feedback.el.find('textarea[name="positive"]').val();
    if (positive !== Feedback.el.find('textarea[name="positive"]').attr('placeholder')) {
        data.positive = positive;
        send = true;
    }
    var negative = Feedback.el.find('textarea[name="negative"]').val();
    if (negative !== Feedback.el.find('textarea[name="negative"]').attr('placeholder')) {
        data.negative = negative;
        send = true;
    }
    if (Feedback.grade !== -1) {
        data.grade = Feedback.grade;
        send = true;
    }
    if (send){
        showLoading();
        Feedback.sendRequest(data);
    }
};

Feedback.sendRequest = function(data) {
    serverRequest(
        "/administration/feedback",
        "GET",
        function(data) {Feedback.reset();},
        "send Feedback",
        function() {Feedback.sendRequest(data);},
        data,
        null,
        function(data) {Feedback.reset();}
    );
};

//affiche la page
Feedback.render = function() {
    Feedback.reset();
    this.el.addClass("shown");
};

Feedback.reset = function() {
    this.el.find("textarea").val("").blur();
    Feedback.grade = -1;
    Feedback.el.find('.star1').attr("src", Feedback.emptyStarUrl);
    Feedback.el.find('.star2').attr("src", Feedback.emptyStarUrl);
    Feedback.el.find('.star3').attr("src", Feedback.emptyStarUrl);
    Feedback.el.find('.star4').attr("src", Feedback.emptyStarUrl);
    Feedback.el.find('.star5').attr("src", Feedback.emptyStarUrl);
};