/* global Notification, MapPage, Feedback, Menu */

var GradePage = new Object();

GradePage.el = $('#grade');
GradePage.commingFrom;
GradePage.grade;

//Fonction d'initialisation, affecte les evenements.
GradePage.initialize = function () {
    this.eventHandler();
};

GradePage.eventHandler = function () {
    this.el.on('click','.back-menu',function (event){
        GradePage.backToPreviousPage();
    });
    
    this.el.on('click', ".star1", function() {
        Feedback.starOne(GradePage);
    });

    this.el.on('click', ".star2", function() {
        Feedback.starTwo(GradePage);
    });

    this.el.on('click', ".star3", function() {
        Feedback.starThree(GradePage);
    });

    this.el.on('click', ".star4", function() {
        Feedback.starFour(GradePage);
    });

    this.el.on('click', ".star5", function() {
        Feedback.starFive(GradePage);
    });
    
    this.el.on('click','.blockContact',function(){
        if (GradePage.el.find('.unblocked').is(':visible')) {
            GradePage.el.find('.unblocked').hide();
            GradePage.el.find('.blocked').show();
        } else {
            GradePage.el.find('.unblocked').show();
            GradePage.el.find('.blocked').hide();
        }
    });
    
    this.el.on('click','.grade',function(){
        var data = new Object();
        var comment = GradePage.el.find('textarea[name="comment"]').val();
        if (comment !== GradePage.el.find('textarea[name="comment"]').attr('placeholder') & comment.length > 0)
            data.comment = encodeURIComponent(comment);
        if (GradePage.el.find('.blocked').is(':visible'))
            data.blockContact = true;
        if (GradePage.grade !== -1)
            data.grade = GradePage.grade;
        data.setContact = GradePage.el.find('input[name="addFriend"]').is(':checked');
        if (!!data.comment & !data.grade) alert('vous devez mettre une note (entre 1 et 5) pour pouvoir laisser un commentaire');
        else if (! data.grade) {
            navigator.notification.confirm(
                "Vous n'avez pas mis de note (une note valide est entre 1 et 5)\n\nMettre une note ?", 
                function(index) {
                    if (index === 1) {
                        MapPage.agreementUpdate("grade",data);
                    }
                },
                "Kankaroo",
                "Non merci,Mettre une note"
            );
        }
        else MapPage.agreementUpdate("grade",data);
    });
};

GradePage.backToPreviousPage = function() {
    $(".shown").removeClass("shown");
    MapPage.el.addClass("shown");
    Notification.handleNotification();
    Menu.scroller(MapPage);
};

//affiche la page
GradePage.render = function() {
    if (GradePage.commingFrom === 'rdv')
        GradePage.el.find('.commingFrom').html('La personne était-elle sympatique ?<br>Etait-elle à l’heure au bon endroit ?');
    else
        GradePage.el.find('.commingFrom').html('Ne soyez pas excessivement sévère');
    GradePage.el.find('.remoteName').html(escapeXml(MapPage.matchList[MapPage.matchNum].profile.name));
    GradePage.reset();
    this.el.addClass("shown");
    Menu.handleJSRendering(GradePage);
};

GradePage.reset = function() {
    GradePage.el.find("textarea").val("").blur();
    GradePage.grade = -1;
    GradePage.el.find('.star1').attr("src", Feedback.emptyStarUrl);
    GradePage.el.find('.star2').attr("src", Feedback.emptyStarUrl);
    GradePage.el.find('.star3').attr("src", Feedback.emptyStarUrl);
    GradePage.el.find('.star4').attr("src", Feedback.emptyStarUrl);
    GradePage.el.find('.star5').attr("src", Feedback.emptyStarUrl);
    GradePage.el.find('.blocked').hide();
    GradePage.el.find('.unblocked').show();
};