var ImageHandler                = new Object();
ImageHandler.url                = new Object();
ImageHandler.car                = new Object();
ImageHandler.profile            = new Object();
ImageHandler.insurance          = new Object();
ImageHandler.noImage            = new Object();

ImageHandler.addImage = function(data,matchId,type) {
    ImageHandler[matchId] = true;
    if (type  === "profile"){
        ImageHandler.profile[matchId] = data;
    } else if (type === "car") {
        ImageHandler.car[matchId] = data;
    } else if (type === "insurance") {
        ImageHandler.insurance[matchId] = data;
    }
};

ImageHandler.addUrlImage = function(data,matchId,type) {
    ImageHandler[matchId] = false;
    if (type  === "profile"){
        ImageHandler.profile[matchId] = data;
    } else if (type === "car") {
        ImageHandler.car[matchId] = data;
    } else if (type === "insurance") {
        ImageHandler.insurance[matchId] = data;
    }
};

ImageHandler.getImage = function(matchId,type){
    if (type  === "profile"){
        return ImageHandler.profile[matchId];
    } else if (type === "car") {
        return ImageHandler.car[matchId];
    } else if (type === "insurance") {
        return ImageHandler.insurance[matchId];
    }
};

ImageHandler.isData = function(matchId) {
    return ImageHandler[matchId];
};

ImageHandler.isLoaded = function (matchId,type){
    if (type  === "profile"){
        return (typeof ImageHandler.profile[matchId] !== "undefined");
    } else if (type === "car") {
        return (typeof ImageHandler.car[matchId] !== "undefined");
    } else if (type === "insurance") {
        return (typeof ImageHandler.insurance[matchId] !== "undefined");
    }
};

ImageHandler.notifyNoImg = function (matchId,type){
    if (typeof type === "undefined"){
        ImageHandler.noMyImage = true;
    } else {
        ImageHandler.noImage[type+matchId] = true;
    }
};

ImageHandler.noImg = function(matchId,type){
    if(typeof ImageHandler.noImage[type+matchId] === "undefined"){
        return false;
    } else {
        return true;
    }
};

ImageHandler.reset = function(){
    ImageHandler.url                = new Object();
    ImageHandler.car                = new Object();
    ImageHandler.profile            = new Object();
    ImageHandler.insurance          = new Object();
    ImageHandler.noImage            = new Object();
    delete ImageHandler.myProfile;
    delete ImageHandler.noMyImage;
};

ImageHandler.resetNoImage = function() {
    ImageHandler.noImage = new Object();
};