/* global PartirPage, MyTravels, Notification, MapPage, Map2Page */

var Partir4Page = new Object();

Partir4Page.el = $('#partir4');
Partir4Page.pickupTime;
Partir4Page.pickupTimeMax;
Partir4Page.userType;
Partir4Page.journeyId;
Partir4Page.regularity;
//Partir4Page.matchNotification; Suspended for the moment
Partir4Page.commingFrom;
Partir4Page.plannedRDV;
Partir4Page.potentialMatches;
Partir4Page.activeAgreements;
Partir4Page.passiveAgreements;
Partir4Page.vehicle;
Partir4Page.helmet;
Partir4Page.luggage;
Partir4Page.passengers;
Partir4Page.detour;
Partir4Page.dep = {};
Partir4Page.arr = {};
Partir4Page.arrAlt = {};
Partir4Page.isPro;

//Fonction d'initialisation, affecte les evenements.
Partir4Page.initialize = function () {
    this.eventHandler();
};

Partir4Page.eventHandler = function () {
    this.el.on('click', '.back-menu', function (event) {
        if (Partir4Page.commingFrom === "MyTravelsPage")
            MyTravels.noReload = true;
        goToPage('#myTravels');
    });
    
    this.el.on('click','.messageTag, .RDVTag, .activeTag, .passiveTag, .potentialTag',function (event){
        var temp = $('<div></div>');
        temp.addClass($(this).attr("class"));
        if (Partir4Page.commingFrom === "MyTravelsPage") {
            showLoading();
            MyTravels.requestLoadTravel(Partir4Page.journeyId, {tag : temp.attr("class")});
        } else {
            MapPage.goToProperAgreement(temp.attr("class"));
            goToPage('#map');
        }
    });
    
    this.el.on('click',".popUp",function (event) {
        event.stopPropagation();
    });
    
    this.el.on('click','.overlay, .popUpOk, .popUpCancel',function(event){
        event.stopPropagation();
        hidePopUp(Partir4Page);
    });
    
    this.el.on('click',".details",function (event) {
        var object = Partir4Page.el.find('.hiddenDetails');
        if (object.is(":visible")) {
            object.hide();
            $(this).html("+ De détails");
        } else {
            object.show();
            $(this).html('- De détails');
        }
        if (Partir4Page.userType === 'driver') {
            Partir4Page.el.find('.car').show();
            Partir4Page.el.find('.carVal').html(escapeXml(Partir4Page.vehicle.name));
            if (Partir4Page.vehicle.type === 'moto') {
                Partir4Page.el.find('.helmet').show();
                Partir4Page.el.find('.helmetVal').html(Partir4Page.fromTrueToYes(Partir4Page.helmet));
            } else Partir4Page.el.find('.helmet').hide();
        } else {
            Partir4Page.el.find('.car').hide();
            if (Partir4Page.helmet) Partir4Page.el.find('.helmet').show();
            else Partir4Page.el.find('.helmet').hide();
        }
        Partir4Page.el.find('.detour').html(Partir4Page.detourConverter(Partir4Page.detour));
        Partir4Page.el.find('.luggage').html(Partir4Page.fromTrueToYes(Partir4Page.luggage));
        Partir4Page.el.find('.passengers').html(Partir4Page.passengers);
    });
    
    this.el.on('click','.navigate',function(event){
        MyTravels.navigatePopUp(Partir4Page.arr.lat, Partir4Page.arr.lng, Partir4Page.arr.str);
    });
    
    this.el.on('click','.delete',function(event){
        MyTravels.deletePopUp(Partir4Page.journeyId);
    });
    
    this.el.on('click','.modifyJourney',function (event){
        event.stopPropagation();
        Partir4Page.el.find('.popUp').html(popUp_modify_time_template());
        if (Partir4Page.el.find('.messageTag').is(':visible')) {
            alert('Impossible de modifier un trajet avec des propositions ou des accords en cours','Modifications impossibles');
            return;
        }
        MyTravels.el.find('.timePop .journeyId').html(Partir4Page.journeyId);
        MyTravels.popUpJourneyId = Partir4Page.journeyId;
        MyTravels.popUpRegularity = Partir4Page.regularity;
        MyTravels.popUpPickupTimeMin = Partir4Page.pickupTime;
        if (!!Partir4Page.pickupTimeMax) {
            MyTravels.popUpPickupTimeMax = Partir4Page.pickupTimeMax;
            MyTravels.popUpPickupTimeMax.setDate(Partir4Page.pickupTime.getDate());
        } else
            MyTravels.popUpPickupTimeMax = Partir4Page.pickupTime;
        if (MyTravels.popUpRegularity === 0) {
            Partir4Page.el.find('.unregular').show();
            Partir4Page.el.find('.regular').hide();
            Partir4Page.el.find("input[value='travelRegularity']").prop('checked',false);
        } else {
            Partir4Page.el.find('.unregular').hide();
            Partir4Page.el.find('.regular').show();
            Partir4Page.el.find("input[value='travelRegularity']").prop('checked',true);
        }
        MyTravels.fillRegularity(Partir4Page, MyTravels.popUpRegularity);
        MyTravels.fillDate(Partir4Page, MyTravels.popUpPickupTimeMin, MyTravels.popUpPickupTimeMax);
        PartirPage.TimeLaps = PartirPage.computeTimeLaps(Partir4Page);
        showPopUp(Partir4Page);
    });
    
    this.el.on('click','.popUpValid',function (event){
        MyTravels.handleTravelModification(Partir4Page);
    });
    
    this.el.on('touchstart', '.addH', function (event) {
        var object = $(this);
        PartirPage.addMinAddH(object, true);
    });
    
    this.el.on('touchstart', '.addMin', function (event) {
        var object = $(this);
        PartirPage.addMinAddH(object, false);
    });

    this.el.on('touchstart', '.substractH', function (event) {
        var object = $(this);
        PartirPage.subMinSubH(object, true);
    });
    
    this.el.on('touchstart', '.substractMin', function (event) {
        var object = $(this);
        PartirPage.subMinSubH(object, false);
    });
    
    this.el.on('touchstart', '.addDay, .addMonth, .addYear', function (event) {
        var object = $(this);
        PartirPage.addDayAddMonthAddYear(Partir4Page, object);
    });
    
    this.el.on('touchstart', '.substractDay, .substractMonth, .substractYear', function (event) {
        var object = $(this);
        PartirPage.subDaySubMonthSubYear(Partir4Page, object);
    });
    
    this.el.on('blur',"input[name='dayInput'], input[name='month'], input[name='year']",function () {
        PartirPage.blurDayMonthYear(Partir4Page);
    });

    this.el.on('blur',"input[name='hourMin'], input[name='hourMax']",function () {
        var object = $(this);
        PartirPage.blurHminHmax(Partir4Page, object);
    });

    this.el.on('blur',"input[name='minutesMin'], input[name='minutesMax']",function () {
        var object = $(this);
        PartirPage.blurMminMmax(Partir4Page, object);
    });
    
    this.el.on('touchstart', 'label', function (event) {
        $(this).one('touchmove',function (event){
           object.off('touchend'); 
        });
        var object = $(this);
        $(this).one('touchend', function (event) {
            if (event.target.tagName !== "INPUT") {
                if (object.hasClass("checkbox"))
                {
                    if (object.hasClass("selectedLabel"))
                    {
                        object.removeClass("selectedLabel");
                    } else {
                        object.addClass("selectedLabel");
                    }
                }
            }
        });
    });
    
    this.el.on('click',".prices",function () {
        Partir4Page.el.find('.popUp').html(partir4_prices_template());
        showPopUp(Partir4Page);
    });
};

Partir4Page.fromTrueToYes = function(bool) {
    if (bool) return 'oui';
    else return 'non';
};

Partir4Page.detourConverter = function(detour) {
    if (detour === '200') return '200 m';
    if (detour === '500') return '500 m';
    if (detour === '1') return '1 km';
    if (detour === '2') return '2 km';
    if (detour === '3') return '3 km';
    if (detour === '5') return '5 km';
};

Partir4Page.sendJourneyToMe = function (travelData, tags) {
    Partir4Page.regularity = travelData.regularity;
    Partir4Page.journeyId = travelData.idjourney;

    Partir4Page.pickupTime = new Date(travelData.pickupTimeMin+" GMT");
    if (typeof travelData.pickupTimeMax !== "undefined") {
        Partir4Page.pickupTimeMax = new Date(travelData.pickupTimeMax+" GMT");
    } else {
        delete Partir4Page.pickupTimeMax;
    }
    Partir4Page.userType = travelData.offeringType;

    /* Suspended for the moment
    Partir4Page.computeMatchNotification(travelData.matchNotification);
    */
    Partir4Page.dep.lat = travelData.pickupPlace.latitude;
    Partir4Page.dep.lng = travelData.pickupPlace.longitude;
    Partir4Page.dep.str = travelData.pickupAddress;

    Partir4Page.arr.lat = travelData.dropPlace.latitude;
    Partir4Page.arr.lng = travelData.dropPlace.longitude;
    Partir4Page.arr.str = travelData.dropAddress;

    if (!!travelData.dropPlaceAlt) {
        Partir4Page.arrAlt.lat = travelData.dropPlaceAlt.latitude;
        Partir4Page.arrAlt.lng = travelData.dropPlaceAlt.longitude;
        Partir4Page.arrAlt.str = travelData.dropAltAddress;
    } else Partir4Page.arrAlt = {};

    Partir4Page.computeTags(tags);

    Partir4Page.vehicle = travelData.vehicleIdvehicle;
    Partir4Page.helmet = travelData.helmet;
    Partir4Page.luggage = travelData.luggage;
    Partir4Page.passengers = travelData.passengers;
    Partir4Page.detour = travelData.detour;

    if (typeof travelData.workplaceIdworkplace !== 'undefined')
        Partir4Page.isPro = true;
    else
        Partir4Page.isPro = false;
        
    Partir4Page.fillPage(travelData);
};

Partir4Page.fillPage = function(journey) {
    
    Partir4Page.el.find('.travelContainer').html("");
    journey.plannedRDV = Partir4Page.plannedRDV;
    journey.potentialMatches = Partir4Page.potentialMatches;
    journey.activeAgreements = Partir4Page.activeAgreements;
    journey.passiveAgreements = Partir4Page.passiveAgreements;
    journey.dep = Partir4Page.dep.str;
    journey.arr = Partir4Page.arr.str;
    journey.arrAlt = Partir4Page.arrAlt.str;
    journey.time = MyTravels.computeTimeString(Partir4Page.regularity, Partir4Page.pickupTime, Partir4Page.pickupTimeMax);
    MyTravels.endJourneyRendering(journey, null, "Partir4Page");
    
    Partir4Page.el.find('.hiddenDetails').hide();
    Partir4Page.el.find('.details').html('+ De détails');
    if(Partir4Page.userType === "driver"){
        Partir4Page.el.find('.driver').show();
        Partir4Page.el.find('.passenger').hide();
    } else if (Partir4Page.userType === "passenger"){
        Partir4Page.el.find('.driver').hide();
        Partir4Page.el.find('.passenger').show();
    }
    
    if (Partir4Page.isPro)
        Partir4Page.el.find('.prices').hide();
    else
        Partir4Page.el.find('.prices').show();
    /*Suspended for the moment
    if (Partir4Page.matchNotification) 
        Partir4Page.el.find('.onoffswitch-checkbox[value="matchNotification"]').prop('checked',true);
    else
        Partir4Page.el.find('.onoffswitch-checkbox[value="matchNotification"]').prop('checked',false);
    */
};

//Affiche la page
Partir4Page.render = function () {
    this.el.addClass("shown");
    Partir4Page.el.find('.arrowCover').each(function() {
        $(this).height($(this).parent().outerHeight() + 2);
    });
};

/* Suspended for the moment
Partir4Page.handleMatchNotification = function(status) {
    var data = new Object();
    data.set = status;
    data.myJourneyId = Partir4Page.journeyId;
    serverRequest(
        "/travel/notificationPrefs",
        "GET",
        function() {},
        "matchNotification",
        function() {Partir4Page.handleMatchNotification(status);},
        data
    );
    var alreadyInList = false;
    for (var i = 0; i < MyTravels.modifiedMatchNotifications.length; i++) {
        var elt = MyTravels.modifiedMatchNotifications[i];
        if (elt.journeyId === Partir4Page.journeyId) {
            alreadyInList = true;
            elt.matchNotification = status;
            break;
        }
    }
    if (!alreadyInList) {
        elt = {
            journeyId : Partir4Page.journeyId,
            matchNotification : status
        };
        MyTravels.modifiedMatchNotifications.push(elt);
    }
    Partir4Page.matchNotification = status;
};

Partir4Page.computeMatchNotification = function(status) {
    var alreadyInList = false;
    for (var i = 0; i < MyTravels.modifiedMatchNotifications.length; i++) {
        var elt = MyTravels.modifiedMatchNotifications[i];
        if (elt.journeyId === Partir4Page.journeyId) {
            alreadyInList = true;
            Partir4Page.matchNotification = elt.matchNotification;
            break;
        }
    }
    if (!alreadyInList)
        Partir4Page.matchNotification = status;
};
*/

Partir4Page.computeTags = function(tags) {
    Partir4Page.plannedRDV = tags.plannedRDV;
    Partir4Page.potentialMatches = tags.potentialMatches;
    Partir4Page.activeAgreements = tags.activeAgreements;
    Partir4Page.passiveAgreements = tags.passiveAgreements;
};