/* global LoginPage */

var PasswdPage = new Object();

PasswdPage.el = $('#passwd');

PasswdPage.initialize = function(){
    this.eventHandler();
};

PasswdPage.eventHandler = function(){
    this.el.find(".valid").on('click',function(){
        PasswdPage.sendRequest();
    });

    this.el.on('click','.back-menu',function(){
        PasswdPage.backToLogin();
     });

    this.el.on('click','.email',function(){
        PasswdPage.el.find('.email').hide();
        PasswdPage.el.find('input[name="e-mail"]').show().focus();
     });

     this.el.on('blur','input[name="e-mail"]',function(){
         if($(this).val()===''){
             PasswdPage.el.find('.email').show();
             PasswdPage.el.find('input[name="e-mail"]').hide();
         }
     });
};

PasswdPage.sendRequest = function(){
    var data = {'mail' : PasswdPage.el.find('input[name="e-mail"]').val()}; 
    if (data.mail !==""){
        showLoading();
        serverRequest(
            "/restorePassword",
            "GET",
            function(data) {
                alert('Vous avez reçu un mail de récupération');
                PasswdPage.backToLogin();
            },
            "password recuperation",
            null,
            data
        );  
    }
};

PasswdPage.backToLogin = function() {
    LoginPage.email = PasswdPage.el.find('input[name="e-mail"]').val();
    goToPage('#login');
};

PasswdPage.render = function(){
    this.el.find('input').removeClass('focus').blur();
    if (PasswdPage.el.find('input[name="e-mail"]').val() !== '' & PasswdPage.el.find('input[name="e-mail"]').val() !== 'Adresse e-mail') {
        PasswdPage.el.find('.email').hide();
        PasswdPage.el.find('input[name="e-mail"]').show();
    }
    this.el.addClass('shown');
};

PasswdPage.reset = function(){
    this.el.find('input').val(this.el.find('input').attr("placeholder")).removeClass('focus');
};