/* global cordova */

var Create3FirmPage = new Object();

Create3FirmPage.el = $('#create3firm');
Create3FirmPage.return;

//Fonction d'initialisation, affecte les evenements.
Create3FirmPage.initialize = function() {
    this.eventHandler();
};

Create3FirmPage.eventHandler = function () {
    this.el.on('click','.back-menu',function(event){
        if (Create3FirmPage.return === "#create3Special") {
            localStorage.createStateMemory = 2;
            goToPage("#create2");
        } else
            goToPage(Create3FirmPage.return); 
    });
    
    this.el.on('click','.clearFirm',function(event){
        Create3FirmPage.returnObject.el.find('#firm').html("<span style=\"color: rgb(140,140,140)\">Entreprise ou campus</span>");
        if (Create3FirmPage.return === "#create3Special")
            goToPage("#create3");
        else
            goToPage(Create3FirmPage.return);
    });

    this.el.on('click','.choice',function(event){
        Create3FirmPage.returnObject.el.find('#firm').html(escapeXml($(this).html()));
        if (Create3FirmPage.return === "#create3Special")
            goToPage("#create3");
        else
            goToPage(Create3FirmPage.return);
    });
};

Create3FirmPage.showAutocompletion = function(){
    serverRequest(
        "/getWorkplaces",
        "GET",
        Create3FirmPage.autocompletionSuccess,
        "autocompletion crete3firm",
        null                       
    );
};

Create3FirmPage.autocompletionSuccess = function(data){
    var results = Create3FirmPage.el.find('.results');
    results.append('<div class="clearFirm italic">Autre (pas dans la liste)</div>');
    var list = JSON.parse(data.suitableWorkplaces);
    list.sort(function(a,b){
        return a.name < b.name ? -1 : 1;
    });
    var length = list.length;
    for (var i = 0;i<length;i++){
        results.append('<div class="choice">'+escapeXml(list[i].name)+'</div>');
    }
};

//Affiche la page
Create3FirmPage.render = function () {
    Create3FirmPage.reset();
    this.el.addClass("shown");
    this.showAutocompletion('');
    if (Create3FirmPage.return === "#create3Special") {
        Create3FirmPage.el.find('.created').hide();
        Create3FirmPage.el.find('.progressionInfo, .creating').show();
    } else {
        Create3FirmPage.el.find('.created').show();
        Create3FirmPage.el.find('.progressionInfo, .creating').hide();
    }
};

Create3FirmPage.reset = function() {
    Create3FirmPage.el.find('.results').html('');
};