/* global device, SoftKeyboard, ContactsPage, MyTravels, Notification, pushNotification, appIsOnForeground, Feedback, MessagePage, EWalletPage, ProfilePage, HistoryPage, gaPlugin, Partir4Page, Partir3Page, Partir2Page, Create2Page, Create3Page, MyCarsPage, Create3FirmPage, MyProfilePage, MapPage, PasswdPage, CreatePage, MyAccountPage, PartirPage, TestPage, LoginPage, Menu, Handlebars, load, facebookConnectPlugin, Storage, ImageHandler, Map2Page, GradePage, Map3Page, JourneyPage, cordova, StatusBar, AccountsPage, AccountPage */

//variable et fonctions globalles
var gaPlugin; //google analytics
var ServerUrl = "https://www.kankaroo.com/Carpooling";
var pushNotification;
var canExitApp = false;
var loadingTimeout;
var appIsOnForeground = true;
var httpTimeOut;
var MONDAY = 0x01;
var TUESDAY = 0x02;
var WEDNESDAY = 0x04;
var THURSDAY = 0x08;
var FRIDAY = 0x10;
var SATURDAY = 0x20;
var SUNDAY = 0x40;
var deviceType;
var windowHeight = $(window).height();

function servError(XMLHttpRequest, textStatus, errorThrown, origin, dataSend, requestsSynchro, additionalData) {
    //background requests that do not impact hardly the behaviour of the app
    if (["autocompletion crete3firm", "switch favorite","image profil create3","get favorites PartirPage","matchNotification","getProfile MapPage",
        "cashPref MapPage","image MapPage","change travel message notif pref","delete Notifications","block contact","remove contact","image profil contact profile",
        "downgrade unread messages"
    ].indexOf(origin) >= 0) {
        if (errorThrown === "timeout" || errorThrown.length === 0) {
        } else logErrorToServer(dataSend, errorThrown);
        return;
    }
    //main requests that do need reactions if blocked by a bad connection
    if (errorThrown === "timeout" || errorThrown.length === 0) {
        if (requestsSynchro) {
            requestsSynchro.number--;
            requestsSynchro.success = false;
            if (requestsSynchro.number === 0) {
                handleRequestSynchroTimeout(origin);
                endLoading();
            }
        }
        else {
            if (origin === "Loading request") { //the app is loading restart load from scratch
                if (load.iOSFirstLoad === true) {
                    load.iOSFirstLoad = false;
                    httpTimeOut = 6000;
                    load.checkVersion();
                    return;
                } else {
                    navigator.notification.alert(
                        "Connexion internet requise",  // message
                        function(){load.checkVersion();},        // callback
                        'Erreur de connexion',            // title
                        'Réessayer'                          // buttonName
                    );
               }
            } else if(origin === "send Reg Id") {
                navigator.notification.alert(
                    "Vous ne pouvez pas recevoir de notification",  // message
                    function(){sendRegIDToServer();},           // callback
                    'Erreur de connexion',                   // title
                    'Réessayer'                                 // buttonName
                );
            } else if (origin === "modify profil create3") {
                navigator.notification.confirm(
                    "Votre profil n'a pas pu être enregistré\n\nEnregistrer à nouveau votre profil ?",
                    function(index){
                        if (index === 2)
                            goToPage('#myProfile');
                    },
                    'Erreur de connexion',
                    'Plus tard,Enregistrer'
                );
            } else if (origin === "send message travel MessagePage" | origin === "send message contact MessagePage") {
                var json = {
                    journeyId: parseInt(additionalData.find('.storeJourneyId').html()),
                    matchId: parseInt(additionalData.find('.storeMatchId').html()),
                    contactId: parseInt(additionalData.find('.storeContactId').html())
                };
                window.plugin.notification.local.add({
                    id:         0,
                    date:       new Date(),                                // This expects a date object
                    message:    "L'envoi du message a échoué",
                    title:      "Kankaroo",
                    json:       json,
                    autoCancel: true                                 // Setting this flag and the notification is automatically canceled when the user clicks it
                });
                window.plugin.notification.local.onclick = function (id, state, json) {
                    onLocalNotification(id, json);
                };
                window.plugin.notification.local.ontrigger = function (id, state, json) {
                    onLocalNotificaitonTrigger(id);
                };
                MessagePage.messageSent(additionalData, true);
                if (deviceType === 'iOS')
                    alert("Echec lors de l'envoi du message");
            } else if (origin === "get Notifications") {
                delete Notification.justClicked;
            } else {
                //requests that need no callback or special message but need a special action
                if (origin === "get contacts") {
                    if (!!ContactsPage.goingStraight.contactId) {
                        ContactsPage.el.addClass("shown");
                    }
                    endLoading();
                } else {
                    endLoading();
                }
                navigator.notification.alert(
                    "Connexion internet requise",  // message
                    function(){},                        // callback
                    'Erreur de connexion',            // title
                    'OK'                                 // buttonName
                );
            }
        }
    }
    else {
        endLoading();
        logErrorToServer(dataSend, errorThrown);
        navigator.notification.alert(
            "Une erreur inattendue est survenue, rééssayez plus tard\n\nSi le problème persiste essayez avec d'autres paramètres",  // message
            function(){},         // callback
            'Erreur',            // title
            'OK'                  // buttonName
        );
    }
} 

function goToPage(page, avoidCheck){
    if (!!MapPage.panorama)
        if (MapPage.panorama.getVisible())
            Map2Page.streetViewAlert();
    var hash = window.location.hash;
    if (!avoidCheck) {
        if (hash === '#myProfile') {
            MyProfilePage.checkForChanges(page);
            return;
        } else if (hash === '#myAccount') {
            MyAccountPage.checkForChanges(page);
            return;
        } else if (hash === '#myCars') {
            MyCarsPage.checkForChanges(page);
            return;
        }
    }
    if(page!==hash){
        $(".shown").removeClass("shown");
        window.location.hash = page;
    } else {
        $(".shown").removeClass("shown");
        route();
    }
}

function deconnexion() {
    var data = new Object();
    data.deviceId = device.uuid;
    sendDeconnexion(data);
}

function sendDeconnexion(data) {
    serverRequest(
        "/deconnection",
        "GET",
        function() {
            window.localStorage.removeItem("mail");
            window.localStorage.removeItem("loginToken");
            window.localStorage.removeItem("regId");
            window.localStorage.removeItem("favoriteGPS");
            window.localStorage.removeItem("localStorage.alarmsDelay");
            window.localStorage.setArray("partir2Favorites", []);
            window.localStorage.setArray("partir3Favorites", []);
            window.localStorage.setArray("geocodingCache", []);
            window.localStorage.setArray("messagesCache", []);
            window.localStorage.setArray("reverseGeocodingCache", []);
            window.localStorage.setArray("notificationsHandled", []);
            window.localStorage.setArray("alarms", []);
            window.plugin.notification.local.cancelAll();
            window.localStorage.removeItem("pushTokenRegistred");
            facebookConnectPlugin.logout(function(data){},function(data){});
            reload();
            goToPage("#login", true);
        },
        "deconnexion failed",
        function() {sendDeconnexion(data);},
        data
    );
};

function reload() {
    LoginPage.reset();
    CreatePage.reset();
    Create2Page.reset();
    Create3Page.reset();
    Create3FirmPage.reset();
    MyAccountPage.reset();
    MyCarsPage.reset();
    MyProfilePage.reset();
    PasswdPage.reset();
    PartirPage.reset();
    Partir2Page.reset();
    Feedback.reset();
    ImageHandler.reset();
    EWalletPage.reset();
    AccountsPage.reset();
    AccountPage.reset();
    GradePage.reset();
    ProfilePage.reset();
    HistoryPage.reset();
    ContactsPage.reset();
    Map2Page.reset();
    Map3Page.reset();
    JourneyPage.reset();
}

function showPopUp(Page) {
    if (deviceType === 'iOS')
        cordova.plugins.Keyboard.disableScroll(false);
    var popUp = Page.el.find('.popUp');
    var overlay = Page.el.find('.overlay');
    popUp.show();
    overlay.show();
    var hauteur = popUp.outerHeight();
    popUp.css('margin-top',-hauteur/2);
}

function hidePopUp(Page) {
    if (deviceType === 'iOS')
        cordova.plugins.Keyboard.disableScroll(true);
    if (Page === PartirPage && PartirPage.tooLate === true) return;
    var popUp = Page.el.find('.popUp');
    var overlay = Page.el.find('.overlay');
    popUp.hide();
    overlay.hide();
}

String.prototype.endsWith = function(suffix) {
        return this.indexOf(suffix, this.length - suffix.length) !== -1;
};

function radioImg(object,Page){
    var previous = object.parent().find(".selectedLabel");
    if(previous.length!==0){
            previous.removeClass("selectedLabel");
            var prevImg = previous.find("img");
            replaceImgSrc(prevImg.attr("src").substring(0,prevImg.attr("src").length-5)+"0.svg", prevImg);
    }
    object.addClass("selectedLabel");
    var img =object.find("img");
    replaceImgSrc(img.attr("src").substring(0,img.attr("src").length-5)+"1.svg", img);

    var id = object.attr("for");
    Page.el.find('input[name='+Page.el.find('input[id='+id+']').attr('name')+']').each(function (){
            $(this).prop('checked',false);
            if($(this).attr("id")===id)
            {
                $(this).prop('checked',true);
            }
    });
}

function replaceImgSrc(src, oldImage) {
    var newImage = $('<img>');
    newImage.attr('src', src);
    
    //give the new image all the caracteristics of the old one
    var classes = oldImage.attr("class");
    if (!!classes) {
        var classesString = classes.toString();
        newImage.addClass(classesString);
    }
    newImage.attr('id', oldImage.attr('id'));
    newImage.attr('style', oldImage.attr('style'));
    
    oldImage.replaceWith(newImage);
};

function serverRequest(url,method,successCallback,origin,disconectedCallback,dataSend,errorCallback,forwardCallback,bugCallback,requestsSynchro,additionalData){
    return $.ajax({type: method,
        url: ServerUrl+url, 
        dataType:"json",
        data: dataSend,
        success : function(data) {
            if(typeof data.status !== "undefined") {
                if(data.status==="success" || data.status==='update' || data.status==='tooLate') {
                    if(successCallback) successCallback(data);
                    handleRequestSuccess(origin, requestsSynchro);
                } else if (data.status === "disconnected"){
                    LoginPage.disconnected(disconectedCallback, origin);
                } else if (data.status === "parseError" || data.status === "unexpectedError") {
                    //send error et affiche popUp
                    endLoading();
                    navigator.notification.alert(
                        "Une erreur inattendue est survenue, rééssayez plus tard\n\nSi le problème persiste essayez avec d'autres paramètres",  // message
                        function(){},         // callback
                        'Erreur',            // title
                        'OK'                  // buttonName
                    );
                    logErrorToServer(url+" "+JSON.stringify(dataSend), JSON.stringify(data));
                    if(errorCallback) errorCallback(data);
                }
            } else if (typeof data.forward !== "undefined") {
                endLoading();
                navigator.notification.alert(
                    data.forward,         // message
                    function(){},         // callback
                    'Kankaroo',           // title
                    'OK'                  // buttonName
                );
                if (forwardCallback) forwardCallback();
            } else{
                if(successCallback) successCallback(data);
                handleRequestSuccess(origin, requestsSynchro);
            }
        },
        error : function(a,b,c) {
            servError(a,b,c,origin,url+" "+JSON.stringify(dataSend),requestsSynchro, additionalData);
            if (typeof bugCallback !== "undefined") {
                bugCallback();
            }
        },
        timeout : httpTimeOut
    });
}

function handleRequestSuccess(origin, requestsSynchro) {
    if (requestsSynchro) {
        requestsSynchro.number--;
        if (requestsSynchro.number === 0) {
            if (requestsSynchro.success === false) handleRequestSynchroTimeout(origin);
            //Some Synchro requests must do something if they overall succeed
            else if (origin === "create or modify vehicle MyCarsPage") {
                if (requestsSynchro.fromPartirPage === true) {
                    PartirPage.reload = true;
                    goToPage("#partir", true);
                } else {
                    window.plugins.toast.showShortBottom('Modifications Enregistrées');
                    MyCarsPage.readyToSendVehicles('save');
                }
            }
            
            //some Synchro requests must not end loading
            if (["create or modify vehicle MyCarsPage","create or modify vehicle Create2"].indexOf(origin) >= 0) {}
            else endLoading();
        }
    }
    //some NOT sychro requests must not end loading
    else if (["get my cars list","send Vehicle Delete","autocompletion crete3firm","modify profil create3","image profil create3","connection LodingPage",
        "modify account","modify profil myProfile","delete travel Travelpage","switch favorite","get favorites PartirPage","send travel data synchro",
        "send Reg Id","MyTravels getTravels","matchNotification","getProfile MapPage","cashPref MapPage","image MapPage","change travel message notif pref","get Notifications",
        "delete Notifications","block contact","remove contact","image profil contact profile","downgrade unread messages","get message travel MessagePage"
    ].indexOf(origin) >= 0) {}
    else endLoading();
}

function handleRequestSynchroTimeout(origin) {
    if (origin === "create or modify vehicle Create2") {
        navigator.notification.confirm(
            "Vos véhicules n'ont pas pu être enregistrés\n\nEnregistrer à nouveau vos véhicules ?", 
            function(index) {
                if (index === 2) {
                    if (localStorage.createStateMemory === '3') {
                        localStorage.createStateMemory = 2;
                        goToPage("#create2");
                    } else if(localStorage.createStateMemory === '2') {
                    } else {
                        MyCarsPage.registerVehicle = true;
                        MyCarsPage.fromPartirPage = false;
                        goToPage('#myCars');
                    }
                }
            },
            "Erreur de connexion",
            "Plus tard,Enregistrer"
        );
    } else {
        navigator.notification.alert(
            "Connexion internet requise",  // message
            function(){},                        // callback
            'Erreur de connexion',            // title
            'OK'                                 // buttonName
        );
    }
}

function showLoading () {
    $('#overlayLoad').show();
}

function endLoading () {
    $('#overlayLoad').hide();
}

function logErrorToServer(requested, received) {
    $.ajax(
        {type: "GET",
        url: ServerUrl+"/administration/receivedError?requested="+requested+"&received="+received,
        dataType:"json",
        success : function () {},
        error : function() {}	
    });
}

function exitApp() {
    if (canExitApp) navigator.app.exitApp();
    else {
        canExitApp = true;
        window.plugins.toast.showShortBottom("Appuyez encore pour quitter");
        setTimeout(function() {
            canExitApp = false;
        }, 2000);
    }
}

Storage.prototype.setArray = function(key, obj) {
    return this.setItem(key, JSON.stringify(obj));
};

Storage.prototype.getArray = function(key) {
    return JSON.parse(this.getItem(key));
};

function notifyNotificationNotActual() {
    alert("La notification n'était plus d'actualité");
}

function escapeXml(unsafe) {
    if (unsafe === null)
        return null;
    if (!unsafe)
        return unsafe;
    return unsafe.replace(/[<>&'"]/g, function (c) {
        switch (c) {
            case '<': return '&lt;';
            case '>': return '&gt;';
            case '&': return '&amp;';
            case '\'': return '&apos;';
            case '"': return '&quot;';
        }
    });
}

function restoreXml(safe) {
    if (safe === null)
        return null;
    if (!safe)
        return safe;
    return safe.replace(/&apos;/g, "'")
               .replace(/&quot;/g, '"')
               .replace(/&gt;/g, '>')
               .replace(/&lt;/g, '<')
               .replace(/&amp;/g, '&');
}
      
