/* global Partir4Page, MessagePage, MyTravels, Notification, ImageHandler, MyProfilePage, HistoryPage, google, Geocoding, Create2Page, Create3Page, Feedback, PartirPage, cordova, device, ProfilePage, Map2Page, GradePage, MONDAY, TUESDAY, WEDNESDAY, THURSDAY, deviceType, Map3Page, windowHeight, JourneyPage, Menu */

var MapPage = new Object();

MapPage.el = $('#map');
MapPage.matchList;
MapPage.matchNoAgreementsNumsList = [];
MapPage.matchNum;
MapPage.agreementNum;
MapPage.vehicle;
MapPage.route;
MapPage.markers = [];
MapPage.arrPassenger = {};
MapPage.depPassenger = {};
MapPage.timeMarker;
MapPage.counterProposition;
MapPage.counterPropositionInitialMatch;
MapPage.counterPropositionMatchNum;
MapPage.cantEdit; //Allow to modify the placement of everything or not (To be used when no in proposing state)
MapPage.type; //correspond to the context in which this page is accessed (proposition / affichage des matches ..)
MapPage.lockedSwitchContent;
MapPage.lockedNewJourney;
MapPage.RDVTutoSnobed;
MapPage.goingStraightToChat;
MapPage.vehiType;
MapPage.priceIsNegative;
MapPage.shortcutMemory;

//Fonction d'initialisation, affecte les evenements.
MapPage.initialize = function() {
    this.eventHandler();
};

MapPage.eventHandler = function () {
    this.el.on('click', '.back-menu', function (event) {
        if (!!MapPage.lockedNewJourney) {
            goSomewhere(Partir4Page.journeyId);
            return;
        }
        if (MapPage.counterProposition === true)
            MapPage.matchList[MapPage.counterPropositionMatchNum] = MapPage.counterPropositionInitialMatch;
        Partir4Page.commingFrom = "MapPage";
        goToPage('#partir4');
    });
    
    this.el.on('click', '.profileTag', function (event) {
        var vehicle;
        if (Partir4Page.userType === 'passenger')
            vehicle = MapPage.vehicle;
        var match = MapPage.matchList[MapPage.matchNum];
        var data = {
            journeyId : Partir4Page.journeyId,
            matchId : match.match.idmatches
        };
        ProfilePage.setUpUsers(data, vehicle, match.profile);
        //go to page profile
        $(".shown").removeClass("shown");
        ProfilePage.render();
    });
    
    this.el.on('click', '.travelTag', function (event) {
        $(".shown").removeClass("shown");
        JourneyPage.render();
    });
    
    this.el.on('click', '.messageTag', function (event) {
        MapPage.goToChatPage();
    });
    
    this.el.on('click', '.rdvBox', function (event) {
        MapPage.goToMap2Page('.rdv');
    });
    
    this.el.on('click', '.dropBox', function (event) {
        MapPage.goToMap2Page('.arrival');
    });
    
    this.el.on('click', '.timeBox', function (event) {
        if (MapPage.cantEdit)
            return;
        $(".shown").removeClass("shown");
        Map3Page.render();
    });
    
    this.el.on('click', '.priceBox', function (event) {
        if (MapPage.cantEdit | MapPage.priceIsNegative)
            return;
        MapPage.el.find('.popUp').html(map_popUp_price_template());
        MapPage.fillPrice();
        showPopUp(MapPage);
    });

    this.el.on('click','.validPrice',function(){
        var euro = parseInt(MapPage.el.find(".popUp input[name='euro']").val(), 10);
        var cent = parseInt(MapPage.el.find(".popUp input[name='cent']").val(), 10);
        var price = 100*euro + cent;
        if (Partir4Page.userType ==="driver"){
            MapPage.matchList[MapPage.matchNum].agreementJourney.price = price;
        } else {
            MapPage.matchList[MapPage.matchNum].agreementJourney.passengerPrice = price;
        }
        MapPage.el.find('.priceBox .agreementBoxAddress').html(MapPage.computeSimplePrice(price));
        if (MapPage.type !== 'normal')
            Map2Page.checkForCounterProposition();
        hidePopUp(MapPage);
    });

    this.el.on('click', '.overlay, .popUpCancel, .popUpOk', function (event) {
        event.stopPropagation();
        hidePopUp(MapPage);
    });

    this.el.on('click', '.popUp', function (event) {
        event.stopPropagation();
    });

    this.el.on('touchstart', '.addCent', function (event) {
        var object = $(this);
        PartirPage.addMinAddH(object, false);
    });

    this.el.on('touchstart', '.substractCent', function (event) {
        var object = $(this);
        PartirPage.subMinSubH(object, false);
    });

    this.el.on('touchstart', '.addMin, .addH', function (event) {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
        var object = $(this);
        var num = parseInt(object.parent().find('input').val(), 10);
        object.parent().find('input').val(num + 1).blur();
        PartirPage.timer = setTimeout(function(){
        if (object.hasClass('addMin')) PartirPage.timeOutMin(object, "plus", 1, 100);
        else PartirPage.timeOutH(object, "plus");
        },300);
        object.one('touchend', function () {
            clearTimeout(PartirPage.timer);
            clearInterval(PartirPage.interval);
        });
    });

    this.el.on('touchstart', '.substractMin, .substractH', function (event) {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
        var object = $(this);
        var num = parseInt(object.parent().find('input').val(), 10);
        object.parent().find('input').val(num - 1).blur();
        PartirPage.timer = setTimeout(function(){
        if (object.hasClass('substractMin')) PartirPage.timeOutMin(object, "substract", 1, 100);
        else PartirPage.timeOutH(object, "substract");
        },300);
        object.one('touchend', function () {
            clearTimeout(PartirPage.timer);
            clearInterval(PartirPage.interval);
        });
    });

    this.el.on('blur','input[name="euro"]',function () {
        if ($(this).val() === "")
            $(this).val("00");
        if (parseInt($(this).val(), 10) < 1) {
            $(this).val('0');
        }
    });

    this.el.on('blur','input[name="cent"]',function () {
        if ($(this).val() === "")
            $(this).val("00");
        if (parseInt($(this).val(), 10) > 99) {
            $(this).val('00');
            MapPage.el.find("input[name='euro']").val(parseInt(MapPage.el.find("input[name='euro']").val(), 10) + 1);
        } else if (parseInt($(this).val(), 10) < 0) {
            $(this).val(95);
            var euro = MapPage.el.find("input[name='euro']").val();
            if (euro !== '0') MapPage.el.find("input[name='euro']").val(parseInt(euro, 10) - 1);
        }
        var value = parseInt(MapPage.el.find('input[name="cent"]').val(), 10);
        if (value < 10) MapPage.el.find('input[name="cent"]').val("0"+value);
    });
    
    this.el.on('click','.map-footer .normal .pinkButton',function(){
        var action = Partir4Page.userType === 'driver'?"Proposer":"Réserver";
        navigator.notification.confirm(
            "Vérifiez bien :\n\n- Le lieu de RDV\n- Le lieu de dépose\n- L'horaire de RDV\n", 
             function(index){
                if (index === 2) {
                    MapPage.validateProposition(MapPage.gatherProposition());
                }
            },
            action + " ce covoiturage ?",
            "Retour,J'ai vérifié"
        );
    });
    
    this.el.on('click','.map-footer .normal .greenButton',function(){
        if (JSON.stringify(MapPage.gatherProposition()) !== JSON.stringify(MapPage.shortcutMemory)) {
            alert("Impossible d'utiliser cette fonctionnalité car vous avez modifié les éléments du covoiturage","Impossible","Compris");
            return;
        }
        var name = escapeXml(MapPage.matchList[MapPage.matchNum].profile.name);
        navigator.notification.confirm(
            'Ce covoiturage sera comptabilisé dans la page "Mes comptes"', 
             function(index){
                if (index === 2) {
                    var data = MapPage.gatherProposition();
                    data.shortcut = true;
                    MapPage.validateProposition(data);
                }
            },
            "Vous êtes déjà en train de covoiturer avec "+name+" ?",
            "Retour,Comptabiliser le covoiturage"
        );
    });
    
    this.el.on('click','.map-footer .receive .greenButton',function(){
        var match = MapPage.matchList[MapPage.matchNum];
        var name = escapeXml(match.profile.name);
        var agreement = match.agreements[MapPage.agreementNum];
        if (!!agreement.shortcut) {
            navigator.notification.confirm(
                'Ce covoiturage sera comptabilisé dans la page "Mes comptes"', 
                 function(index){
                    if (index === 2) {
                        MapPage.agreementUpdate("confirmed");
                    }
                },
                "Vous êtes en train de covoiturer avec "+name+" ?",
                "Retour,Comptabiliser le covoiturage"
            );
        } else if(MapPage.type === "type2" & Partir4Page.userType === "passenger"){
            MapPage.handlePaiementMode();
        } else {
            var action = Partir4Page.userType === 'driver'?"Accepter":"Réserver";
            navigator.notification.confirm(
                "Vérifiez bien :\n\n- Le lieu de RDV\n- Le lieu de dépose\n- L'horaire de RDV\n", 
                 function(index){
                    if (index === 2) {
                        MapPage.agreementUpdate("confirmed");
                    }
                },
                action + " ce covoiturage ?",
                "Retour,J'ai vérifié"
            );
        }
    });
    
    this.el.on('click','.map-footer .receive .red, .map-footer .counter .red',function(){
        var match = MapPage.matchList[MapPage.matchNum];
        var name = escapeXml(match.profile.name);
        var agreement = match.agreements[MapPage.agreementNum];
        if (!!agreement.shortcut) {
            navigator.notification.confirm(
                "Vous n'êtes pas en train de covoiturer avec "+name, 
                 function(index){
                    if (index === 2) {
                        MapPage.agreementUpdate("canceled"); 
                    }
                },
                "C'est une erreur",
                "Retour,Je ne covoiture pas"
            );
        } else {
            var action = Partir4Page.userType === 'driver'?"modifier la demande de réservation":"modifier la proposition";
            navigator.notification.confirm(
                "Vous pouvez "+ action + "\n\nRefuser quand même ?", 
                 function(index){
                    if (index === 2) {
                        MapPage.agreementUpdate("canceled"); 
                    }
                },
                "Kankaroo",
                "Non,Refuser"
            );
        }
    });
    
    this.el.on('click','.map-footer .counter .greenButton',function(){
        MapPage.agreementUpdate("proposing",MapPage.gatherCounterProposition());
    });
    
    this.el.on('click','.map-footer .counter .normalColour',function(){
        MapPage.loadMatch(false);
    });
    
    this.el.on('click','.map-footer .passive .money',function(){
        if (MapPage.priceIsNegative) {
            MapPage.el.find('.popUp').html(map_popUp_money_template({free : true}));
        } else if (Partir4Page.userType === 'driver') {
            MapPage.el.find('.popUp').html(map_popUp_money_template({driver : true}));
            MapPage.el.find("#myonoffswitchCash").attr("checked",!MapPage.matchList[MapPage.matchNum].agreements[MapPage.agreementNum].driverRefuseCash);
        } else {
            MapPage.el.find('.popUp').html(map_popUp_money_template());
        }
        showPopUp(MapPage);
    });
    
    this.el.on('click','.map-footer .passive .normalColour, .map-footer .haveConfirm .normalColour',function(){
        navigator.notification.confirm(
            "Vous êtes sur le point de passer un accord\n\nDésirez-vous annuler ?", 
             function(index){
                if (index === 2) {
                    MapPage.agreementUpdate("canceled"); 
                }
            },
            "Kankaroo",
            "Non,Oui"
        );
    });
    
    this.el.on('click','.map-footer .haveConfirm .greenButton',function(){
        MapPage.handlePaiementMode();
    });
    
    this.el.on('click','.map-footer .haveRDV .greenButton',function(){
        var message;
        if (Partir4Page.userType === 'driver')
            message = 'Vous confirmez avoir déposé le passager à bon port et avoir été payé';
        else
            message = 'Vous confirmez avoir été déposé à bon port et avoir payé le conducteur';
        navigator.notification.confirm(
            message,
             function(index){
                if (index === 2) {
                    MapPage.goToGradePage('rdv');
                }
            },
            "Covoiturage terminé ?",
            "Annuler,Je confirme"
        );
    });
    
    this.el.on('click','.map-footer .haveRDV .normalColour',function(){
        navigator.notification.confirm(
            "Attention le "+MapPage.readableUserType(true)+" compte sur vous !\n\nLe "+MapPage.readableUserType(true)+" pourra mettre une appréciation sur vous\n\nDésirez-vous vraiment annuler ?", 
             function(index){
                if (index === 2) {
                    MapPage.agreementUpdate("canceled");
                }
            },
            "Kankaroo",
            "Non,Oui"
        );
    });
    
    this.el.on('click','.map-footer .haveRDV .red',function(){
        var data = {};
        if (Partir4Page.userType === 'passenger') data.driver = true;
        MapPage.el.find('.popUp').html(map_popUp_help(data));
        setTimeout(function() {
            showPopUp(MapPage);
        },10);
    });
    
    this.el.on('click','.map-footer .haveAck .greenButton',function(){
        MapPage.agreementUpdate("ack");
    });
    
    this.el.on('click','.map-footer .haveGrading .greenButton',function(){
        MapPage.agreementUpdate("grade",{setContact : true});
    });
    
    this.el.on('click','.map-footer .haveGrading .green',function(){
        MapPage.goToGradePage('grading');
    });
    
    this.el.on('click','.map-footer .haveGrading .red',function(){
        MapPage.el.find('.popUp').html(map_popUp_help());
        MapPage.el.find('.popUp .normal').hide();
        MapPage.el.find('.popUp .noPay').show();
        MapPage.el.find("textarea[name='complain']").blur();
        showPopUp(MapPage);
    });
    
    this.el.on('click','.rdvGPS',function(event){
        event.stopPropagation();
        var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
        var lat = journey.pickupPlace.latitude;
        var lng = journey.pickupPlace.longitude;
        MyTravels.navigatePopUp(lat, lng, MapPage.el.find('.rdvBox .agreementBoxAddress').html());
    });
    
    this.el.on('click','.dropGPS',function(event){
        event.stopPropagation();
        var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
        var lat = journey.dropPlace.latitude;
        var lng = journey.dropPlace.longitude;
        MyTravels.navigatePopUp(lat, lng, MapPage.el.find('.dropBox .agreementBoxAddress').html());
    });

    this.el.on('click','.showHelp',function(){
        var data = {};
        if (Partir4Page.userType === 'passenger') data.driver = true;
        MapPage.el.find('.popUp').html(map_popUp_help(data));
        showPopUp(MapPage);
    });

    this.el.on('click','.showLate',function(){            
        MapPage.el.find('.popUp .normal').hide();
        MapPage.el.find('.popUp .late').show();
        showPopUp(MapPage);
    });

    this.el.on('click','.showLost',function(){
        MapPage.el.find('.popUp .normal').hide();
        MapPage.el.find('.popUp .lost').show();
        showPopUp(MapPage);
    });

    this.el.on('click','.showComplain',function(){
        MapPage.el.find('.popUp').html(map_popUp_help());
        MapPage.el.find('.popUp .normal').hide();
        MapPage.el.find('.popUp .noPay').show();
        MapPage.el.find("textarea[name='complain']").blur();
        showPopUp(MapPage);
    });

    this.el.on('click','.showNoPay',function(){
        MapPage.el.find('.popUp').html(map_popUp_help());
        MapPage.el.find('.popUp .normal').hide();
        MapPage.el.find('.popUp .noPay').show();
        MapPage.el.find("textarea[name='complain']").blur();
        showPopUp(MapPage);
    });

    this.el.on('click','.showNotHere',function(){
        MapPage.el.find('.popUp .normal').hide();
        MapPage.el.find('.popUp .notHere').show();
        showPopUp(MapPage);
    });

    this.el.on('click','.showRDVOnMap',function(){
        hidePopUp(MapPage);
        MapPage.goToMap2Page('.rdv');
    });

    this.el.on('click','.navigateToRDV',function(){
        hidePopUp(MapPage);
        MapPage.el.find('.rdvGPS').click();
    });
    
    this.el.on('click','.cancel',function(){
        hidePopUp(MapPage);
        MapPage.el.find('.map-footer .haveRDV .normalColour').click();
    });

    this.el.on('click','.sendComplain',function(){
        var data = new Object();
        data.message = MapPage.el.find('#complainComment').val();
        if (data.message !== MapPage.el.find('#complainComment').attr('placeholder')) {
            MapPage.agreementUpdate("complain",data);
            hidePopUp(MapPage);
        } else
            alert("Merci d'expliquer brièvement la nature du problème");
    });

    this.el.on('click','.chatJourney',function(){
        hidePopUp(MapPage);
        MapPage.goToChatPage();
    });
};

MapPage.fillPrice = function() {
    var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
    var priceR;
    var price;
    if (Partir4Page.userType === "driver"){
        priceR = journey.priceR;
        price = journey.price;
    } else {
        priceR = journey.passengerPriceR;
        price = journey.passengerPrice;
    }
    var computedPrice = MapPage.computePrice(price);
    var euro = computedPrice[0];
    var cent = computedPrice[1];
    MapPage.el.find('input[name="euro"]').val(euro);
    MapPage.el.find('input[name="cent"]').val(cent);
    MapPage.el.find('.priceR').html(MapPage.computeSimplePrice(priceR));
};

MapPage.switchMatch = function(switchingAgreement, goToMessagePage) {
    if (!switchingAgreement) MapPage.agreementNum = -1;
    MapPage.loadMatch(goToMessagePage);
};

MapPage.loadMatch = function (goToMessagePage, skipScrollTop) {
    if (!!MapPage.lockedSwitchContent) {
        var content = MapPage.lockedSwitchContent.content;
        var match = MapPage.matchList[MapPage.matchNum];
        if (content.journeyId === Partir4Page.journeyId & content.matchId === match.match.idmatches) {
            var ok = false;
            if (MapPage.agreementNum === -1) 
                ok = true;
            else if (content.agreementId === match.agreements[MapPage.agreementNum].idagreements)
                ok = true;
            if ((ok & MapPage.lockedSwitchContent.track === 'agreement')
                | (MapPage.lockedSwitchContent.track === 'matchId')) {
                    alert(MapPage.lockedSwitchContent.message);
                    goSomewhere(content.journeyId, content.matchId, content.agreementId);
                    return;
            } else if (MapPage.lockedSwitchContent.track === 'matchCanceled') {
                alert(MapPage.lockedSwitchContent.message);
                goSomewhere(content.journeyId, content.matchId, null);
                return;
            } else if (ok & MapPage.lockedSwitchContent.track === 'comptes') {
                alert(MapPage.lockedSwitchContent.message);
                goToPage("#myTravels");
                return;
            }
        }
    }
    if (MapPage.counterProposition === true)
        MapPage.matchList[MapPage.counterPropositionMatchNum] = MapPage.counterPropositionInitialMatch;
    MapPage.reset();
    MapPage.loadMatchData(skipScrollTop);
    if (!!goToMessagePage)
        MapPage.goToChatPage();
};

MapPage.sendDataToMap = function (matchList, goingStraight) {
    MapPage.matchList = matchList;
    MapPage.matchList.sort(function(a,b){
        var Ascore = a.match.score;
        var Bscore = b.match.score;
        return Ascore < Bscore ? -1 : 1;
    });
    MapPage.buildMatchLists();
    Notification.addAgreements(Partir4Page.journeyId);
    
    //if by chance we go nowhere bottom, we at least arrive somewhere coherent
    if (MapPage.matchAgreementsPairsList.length > 0) MapPage.matchNum = MapPage.matchAgreementsPairsList[0].matchNum;
    else MapPage.matchNum = 0;
    MapPage.agreementNum = -1;
    
    if (Partir4Page.userType === "driver"){
        MapPage.vehicle = Partir4Page.vehicle;
    }

    if (!!goingStraight) {
        if (!!goingStraight.matchId) {
            var matchNum = -1;
            for (var i = 0; i < MapPage.matchList.length; i++) {
                if (MapPage.matchList[i].match.idmatches === goingStraight.matchId) {
                    matchNum = i;
                    break;
                }
            }
            if (matchNum === -1)
                return true;
            MapPage.matchNum = matchNum;
            if (!!goingStraight.agreementId) {
                var agreementNum = -1;
                for (var i = 0; i < MapPage.matchList[MapPage.matchNum].agreements.length; i++) {
                    if (MapPage.matchList[MapPage.matchNum].agreements[i].idagreements === goingStraight.agreementId) {
                        agreementNum = i;
                        break;
                    }
                }
                if (agreementNum === -1)
                    return true;
                MapPage.agreementNum = agreementNum;
            }
        } else if (!!goingStraight.tag) {
            var result = MapPage.setUpMapPageForProperAgreement(goingStraight.tag);
            if (result === "update")
                return true;
        }
    }
    
    ImageHandler.resetNoImage();
    delete MapPage.lockedSwitchContent;
    delete MapPage.lockedNewJourney;
    Notification.popUp.find('.lockedNewJourneyRefresh').hide();
    MapPage.reset();

    MapPage.loadMatchData();
    return false;
};

MapPage.loadMatchData = function(skipScrollTop){
    if (!skipScrollTop)
        Menu.scroller(MapPage);
    var match = MapPage.matchList[MapPage.matchNum];
    if(MapPage.agreementNum === -1 & match.agreements.length>0){
        MapPage.agreementNum = 0;
    }
    
    if (match.agreements.length>0)
        Notification.setSelectedGuy(match.match.idmatches, match.agreements[MapPage.agreementNum].idagreements);
    else
        Notification.setSelectedGuy(match.match.idmatches);

    for (var i = 0; i < MapPage.markers.length; i++) {
        MapPage.markers[i].setMap(null);
    }
    MapPage.markers = [];
    if(Partir4Page.userType === "passenger"){
        MapPage.vehicle = match.userJourney.vehicleIdvehicle;
    }
    var distant = match.userJourney;
    MapPage.depPassenger = {};
    MapPage.depDriver = {};
    if (Partir4Page.userType === 'passenger') {
        MapPage.depPassenger.lat = Partir4Page.dep.lat;
        MapPage.depPassenger.lng = Partir4Page.dep.lng;
        MapPage.depDriver.lat = distant.pickupPlace.latitude;
        MapPage.depDriver.lng = distant.pickupPlace.longitude;
    } else {
        MapPage.depPassenger.lat = distant.pickupPlace.latitude;
        MapPage.depPassenger.lng = distant.pickupPlace.longitude;
        MapPage.depDriver.lat = Partir4Page.dep.lat;
        MapPage.depDriver.lng = Partir4Page.dep.lng;
    }

    if (Partir4Page.userType === 'driver')
        MapPage.vehiType = MapPage.vehicle.type;
    else MapPage.vehiType = match.userJourney.vehicleIdvehicle.type;
    if (MapPage.vehiType === 'car')
        MapPage.vehiType = 'driver';

    MapPage.addDepMarkers();

    MapPage.arrPassenger = {};
    if (Partir4Page.userType === 'passenger') {
        if (match.match.isAlt) {
            MapPage.arrPassenger.lat = Partir4Page.arrAlt.lat;
            MapPage.arrPassenger.lng = Partir4Page.arrAlt.lng;
        } else {
            MapPage.arrPassenger.lat = Partir4Page.arr.lat;
            MapPage.arrPassenger.lng = Partir4Page.arr.lng;
        }
    } else {
        if (match.match.isAlt) {
            MapPage.arrPassenger.lat = distant.dropPlaceAlt.latitude;
            MapPage.arrPassenger.lng = distant.dropPlaceAlt.longitude;
        } else {
            MapPage.arrPassenger.lat = distant.dropPlace.latitude;
            MapPage.arrPassenger.lng = distant.dropPlace.longitude;
        }
    }
    MapPage.arrDriver = {};
    if (Partir4Page.userType === 'passenger') {
        MapPage.arrDriver.lat = distant.dropPlace.latitude;
        MapPage.arrDriver.lng = distant.dropPlace.longitude;
    } else {
        MapPage.arrDriver.lat = Partir4Page.arr.lat;
        MapPage.arrDriver.lng = Partir4Page.arr.lng;
    }

    MapPage.addArrMarkers();

    //Réponse de google + time + other macthes
    if (!!match.polyline)
        MapPage.route = google.maps.geometry.encoding.decodePath(JSON.parse(match.polyline).points);
    else
        delete MapPage.route;
    MapPage.time  = match.travelTime;

    //Compute the RDV Road point and drop Road point for later
    if (!!MapPage.route) {
        var passengerDep = new google.maps.LatLng(MapPage.depPassenger.lat, MapPage.depPassenger.lng);
        var passengerArr = new google.maps.LatLng(MapPage.arrPassenger.lat, MapPage.arrPassenger.lng);
        MapPage.rdvRoadPoint = MapPage.route[0];
        MapPage.dropRoadPoint = MapPage.route[0];
        for (var i = 0; i < MapPage.route.length; i++) {
            if (google.maps.geometry.spherical.computeDistanceBetween (MapPage.route[i], passengerDep) < google.maps.geometry.spherical.computeDistanceBetween (MapPage.rdvRoadPoint, passengerDep)) MapPage.rdvRoadPoint = MapPage.route[i];
            if (google.maps.geometry.spherical.computeDistanceBetween (MapPage.route[i], passengerArr) < google.maps.geometry.spherical.computeDistanceBetween (MapPage.dropRoadPoint, passengerArr)) MapPage.dropRoadPoint = MapPage.route[i];
        }
    } else {
        delete MapPage.rdvRoadPoint;
        delete MapPage.dropRoadPoint;
    }

    //Display the numbre of unread messages
    var nbr;
    if (Partir4Page.userType === 'driver') nbr = match.match.nbrUnreadD;
    else nbr = match.match.nbrUnreadP;
    Notification.changeNumNotif(MapPage.el.find(".messageTagNotif"),nbr);
    MapPage.determineAgreementType();
    MapPage.fillInInformation();
};

MapPage.addDepMarkers = function() {
    var distant = MapPage.matchList[MapPage.matchNum].userJourney;
    if (Math.abs(Partir4Page.dep.lat - distant.pickupPlace.latitude) < 0.0001 && Math.abs(Partir4Page.dep.lng - distant.pickupPlace.longitude) < 0.0001) {
        if (MapPage.vehiType === 'driver')
            MapPage.addMarker(Partir4Page.dep.lat, Partir4Page.dep.lng, 'driver_passenger', 'dep');
        else
            MapPage.addMarker(Partir4Page.dep.lat, Partir4Page.dep.lng, 'moto_passenger', 'dep');
    }
    else {
        if (Partir4Page.userType === 'passenger') {
            MapPage.addMarker(Partir4Page.dep.lat, Partir4Page.dep.lng, Partir4Page.userType, 'dep');
            MapPage.addMarker(distant.pickupPlace.latitude, distant.pickupPlace.longitude, MapPage.vehiType, 'dep');
        } else {
            MapPage.addMarker(Partir4Page.dep.lat, Partir4Page.dep.lng, MapPage.vehiType, 'dep');
            MapPage.addMarker(distant.pickupPlace.latitude, distant.pickupPlace.longitude, distant.offeringType, 'dep');
        }
    }
};

MapPage.addArrMarkers = function() {
    if (Math.abs(MapPage.arrDriver.lat - MapPage.arrPassenger.lat) < 0.0001 && Math.abs(MapPage.arrDriver.lng - MapPage.arrPassenger.lng) < 0.0001) {
        if (MapPage.vehiType === 'driver')
            MapPage.addMarker(MapPage.arrDriver.lat, MapPage.arrDriver.lng, 'driver_passenger', 'arr');
        else
            MapPage.addMarker(MapPage.arrDriver.lat, MapPage.arrDriver.lng, 'moto_passenger', 'arr');
    }
    else {
        MapPage.addMarker(MapPage.arrPassenger.lat, MapPage.arrPassenger.lng, 'passenger', 'arr');
        MapPage.addMarker(MapPage.arrDriver.lat, MapPage.arrDriver.lng, MapPage.vehiType, 'arr');
    }
};

MapPage.addMarker = function(lat,lng, userType, iconType) {
    var url = 'img/';
    url += userType;
    if (iconType === 'dep') url += '_pickup.svg';
    else url += '_drop.svg';

    var imageScaledSize;
    var imageAnchor;
    if (userType === 'driver_passenger' || userType === 'moto_passenger') {
        imageScaledSize = new google.maps.Size(60,90);
        imageAnchor = new google.maps.Point(30,90);
    }
    else {
        imageScaledSize = new google.maps.Size(40,60);
        imageAnchor = new google.maps.Point(20,60);
    }

    var image = {
        url: url,
        scaledSize: imageScaledSize,
        origin: new google.maps.Point(0,0),
        anchor: imageAnchor
    };

    var marker = new google.maps.Marker({
        position: new google.maps.LatLng(lat,lng),
        map: null,
        icon: image,
        zIndex: -20
    });

    //Warning after that point userType does not tell if car or Moto
    if (userType === 'moto')
        userType = 'driver';
    if (userType === 'moto_passenger')
        userType = 'driver_passenger';

    var message;
    if (iconType === 'dep' & userType === 'passenger' & Partir4Page.userType === 'driver') message = 'Lieu de départ du passager';
    if (iconType === 'dep' & userType === 'driver' & Partir4Page.userType === 'passenger') message = 'Lieu de départ du conducteur';
    if (iconType === 'dep' & userType === 'driver_passenger' & Partir4Page.userType === 'passenger') message = 'Mon point de départ ainsi que celui du conducteur';
    if (iconType === 'dep' & userType === 'driver_passenger' & Partir4Page.userType === 'driver') message = 'Mon point de départ ainsi que celui du passager';
    if (iconType === 'dep' & ((userType === 'passenger' & Partir4Page.userType === 'passenger') || (userType === 'driver' & Partir4Page.userType === 'driver'))) message = 'Mon point de départ';
    if (iconType === 'arr' & userType === 'passenger' & Partir4Page.userType === 'driver') message = 'Destination finale du passager';
    if (iconType === 'arr' & userType === 'driver' & Partir4Page.userType === 'passenger') message = 'Destination finale du conducteur';
    if (iconType === 'arr' & userType === 'driver_passenger' & Partir4Page.userType === 'passenger') message = 'Ma destination finale ainsi que celle du conducteur';
    if (iconType === 'arr' & userType === 'driver_passenger' & Partir4Page.userType === 'driver') message = 'Ma destination finale ainsi que celle du passager';
    if (iconType === 'arr' & ((userType === 'passenger' & Partir4Page.userType === 'passenger') || (userType === 'driver' & Partir4Page.userType === 'driver'))) message = 'Ma destination finale';
    google.maps.event.addListener(marker, 'click', function() {
        alert(message);
    });

    MapPage.markers.push(marker);
};

MapPage.determineAgreementType = function(){
    MapPage.cantEdit = true;
    if(MapPage.agreementNum === -1){
        MapPage.cantEdit = false;
        MapPage.type ="normal";
    } else {
        var agreement      = MapPage.matchList[MapPage.matchNum].agreements[MapPage.agreementNum];
        var driverState    = agreement.stateDriver;
        var passengerState = agreement.statePassenger;
        if (driverState === "receiving" & passengerState === "proposing"){
            MapPage.type="type1";
            if (Partir4Page.userType === 'driver' & !agreement.shortcut)
                MapPage.setUpActiveVariables();
        } else if (driverState === "proposing" & passengerState === "receiving"){
            if (Partir4Page.userType === 'passenger' & !agreement.shortcut)
                MapPage.setUpActiveVariables();
            MapPage.type="type2";
        } else if (driverState === "confirmed" & passengerState === "proposing"){
            MapPage.type="type3";
        } else if (driverState === "confirmed" & passengerState === "confirmed"){
            MapPage.type="type4";
        } else if (driverState === "proposing" & passengerState === "confirmed"){
            MapPage.type="type5";
        } else if (driverState === "confirmed" & passengerState === "paid"){
            MapPage.type="type6";
        } else if (driverState === "proposing" & passengerState === "paid"){
            MapPage.type="type7";
        } else if (driverState === "refused" & (passengerState === "receiving" | passengerState === "proposing")){
            MapPage.type="type8";
        } else if ((driverState === "proposing" | driverState === "receiving" | driverState === "confirmed") & passengerState === "refused"){
            MapPage.type="type9";

        } else if (Partir4Page.userType === 'passenger' & passengerState ==="grading") {
            if (typeof agreement.complainIdcomplain === "undefined")
                MapPage.type="type10";
            else if (agreement.complainIdcomplain.passengerManifested === false)
                MapPage.type="type10";
            else
                MapPage.type="type11";
        } else if (Partir4Page.userType === 'driver' & driverState ==="grading") {
            if (typeof agreement.complainIdcomplain === "undefined")
                MapPage.type="type10";
            else if (agreement.complainIdcomplain.driverManifested === false)
                MapPage.type="type10";
            else
                MapPage.type="type11";
        }
    }
};

MapPage.setUpActiveVariables = function() {
    MapPage.cantEdit = false;
    MapPage.RDVTutoSnobed = true;
    MapPage.counterPropositionInitialMatch = jQuery.extend(true, {}, MapPage.matchList[MapPage.matchNum]);
    MapPage.counterPropositionMatchNum = MapPage.matchNum;
};

MapPage.fillInInformation = function() {
    var match = MapPage.matchList[MapPage.matchNum];
    var name = escapeXml(match.profile.name);
    var agreement = match.agreements[MapPage.agreementNum];
    var isD = Partir4Page.userType === 'driver';
    
    //This part concerns the top part
    if (isD) {
        if (match.userJourney.passengers === 1)
            MapPage.el.find('.passengerType').html("1 passager");
        else
            MapPage.el.find('.passengerType').html(match.userJourney.passengers+" passagers");
        MapPage.el.find('.remotePassengerType').attr("src","img/passenger0.svg");
    } else {
        MapPage.el.find('.passengerType').html("conducteur");
        MapPage.el.find('.remotePassengerType').attr("src","img/driver0.svg");
    }
    
    //This part concers the colours of the agreement and its title
    if (MapPage.type === 'normal') {
        if (isD)
            MapPage.el.find('.whiteBgTitle').html(name + " cherche un conducteur");
        else
            MapPage.el.find('.whiteBgTitle').html(name + " est disponible");
        MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(173,70,224)');
        MapPage.el.find('.whiteBg').css('backgroundColor','rgb(237,216,248)');
    } else if ((MapPage.type === 'type2' & isD) | (MapPage.type === 'type1' & !isD)) {
        MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(54,164,127)');
        MapPage.el.find('.whiteBg').css('backgroundColor','rgb(220,244,236)');
        if (!!agreement.shortcut)
            MapPage.el.find('.whiteBgTitle').html("En attente de la confirmation");
        else
            MapPage.el.find('.whiteBgTitle').html("En attente d'une réponse");
    } else if ((MapPage.type === 'type1' & isD) | (MapPage.type === 'type2' & !isD)) {
        MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(255,80,80)');
        MapPage.el.find('.whiteBg').css('backgroundColor','rgb(255,225,225)');
        var action = isD?" veut réserver":" propose";
        if (agreement.counterProposition === 0)
            MapPage.el.find('.whiteBgTitle').html(name + action + ' ce covoiturage');
        else
            MapPage.el.find('.whiteBgTitle').html(name + action + ' ce nouveau covoiturage');
        if (!!agreement.shortcut)
            MapPage.el.find('.whiteBgTitle').html('Vous êtes en train de covoiturer');
    } else if (MapPage.type === 'type3') {
        if (isD) {
            MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(54,164,127)');
            MapPage.el.find('.whiteBg').css('backgroundColor','rgb(220,244,236)');
            MapPage.el.find('.whiteBgTitle').html(name + ' confirme et paie');
        } else {
            MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(255,80,80)');
            MapPage.el.find('.whiteBg').css('backgroundColor','rgb(255,225,225)');
            MapPage.el.find('.whiteBgTitle').html('Finalisez la réservation');
        }
    } else if (MapPage.type === 'type4' | MapPage.type === 'type5' | MapPage.type === 'type6' | MapPage.type === 'type7') {
        MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(255,80,150)');
        MapPage.el.find('.whiteBg').css('backgroundColor','rgb(255,209,228)');
        MapPage.el.find('.whiteBgTitle').html('Vous avez rendez-vous !');
    } else if (MapPage.type === 'type8' | MapPage.type === 'type9') {
        MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(255,80,80)');
        MapPage.el.find('.whiteBg').css('backgroundColor','rgb(255,225,225)');
        if (!!agreement.shortcut)
            MapPage.el.find('.whiteBgTitle').html("Vous n'êtes pas en train de covoiturer");
        else
            MapPage.el.find('.whiteBgTitle').html(name + ' a refusé ou annulé');
    } else if (MapPage.type === 'type10' | MapPage.type === 'type11') {
        MapPage.el.find('.whiteBgTitle').css('backgroundColor','rgb(255,80,80)');
        MapPage.el.find('.whiteBg').css('backgroundColor','rgb(255,225,225)');
        MapPage.el.find('.whiteBgTitle').html(name + ' a annulé le RDV');
    }
    
    //This part concerns control options
    /* TODO handle
    MapPage.el.find('.rdvReminder').hide();
    if (MapPage.type === 'type4' | MapPage.type === 'type5' | MapPage.type === 'type6' | MapPage.type === 'type7') {
        MapPage.el.find('.rdvReminder').show();
        MapPage.fillInRDVReminder();
    }*/
    
    //This part concerns the agreement div
    MapPage.resetRDVDrop();
    MapPage.fillInRDVDrop(true);
    if (MapPage.type === 'type2' | MapPage.type === 'type1')
        if (agreement.counterProposition !== 0)
            MapPage.fillInCounterPropositionColours(agreement.counterProposition);
    MapPage.priceIsNegative = MapPage.isPriceNegative();
    MapPage.handleTimePriceModifyVisibility(!MapPage.cantEdit);
    if (!MapPage.priceIsNegative) {
        var paiementMean = '';
        if (!!agreement) {
            if (agreement.paiementMean === 'cash')
                paiementMean = " <span class='green italic'>Paiement en espèces</span>";
        }
        MapPage.el.find('.priceBox .agreementBoxAddress').html(MapPage.computeSimplePrice() + paiementMean);
    } else {
        MapPage.el.find('.priceBox .agreementBoxAddress').html("GRATUIT");
    }
    
    //This part fills the map overlay of map2page
    if (!!match.match.pickupDescription) {
        Map2Page.el.find('input[name="rdv-description"]').val(decodeURIComponent(match.match.pickupDescription));
        Map2Page.el.find('.rdv-description').html(escapeXml(decodeURIComponent(match.match.pickupDescription)));
    } else {
        Map2Page.el.find('input[name="rdv-description"]').val("Décrivez le lieu de RDV");
        Map2Page.el.find('.rdv-description').html('');
    }
    if (!!match.match.dropDescription) {
        Map2Page.el.find('input[name="arrival-description"]').val(decodeURIComponent(match.match.dropDescription));
        Map2Page.el.find('.arrival-description').html(escapeXml(decodeURIComponent(match.match.dropDescription)));
    } else {
        Map2Page.el.find('input[name="arrival-description"]').val("Décrivez le lieu de dépose");
        Map2Page.el.find('.arrival-description').html('');
    }
    
    //This part concerns the footer
    MapPage.el.find('.normal, .receive, .counter, .passive, .haveConfirm, .haveRDV, .haveAck, .haveGrading').hide();
    if (MapPage.type === 'normal') {
        if (isD)
            MapPage.el.find('.normal .pinkButton').html("Proposer ce covoiturage");
        else
            MapPage.el.find('.normal .pinkButton').html("Réserver ce covoiturage");
        if (!!match.match.accomplished) {
            MapPage.shortcutMemory = MapPage.gatherProposition();
            MapPage.el.find('.normal .greenButton').show();
        }
        else
            MapPage.el.find('.normal .greenButton').hide();
        MapPage.el.find('.normal').show();
    } else if ((MapPage.type === 'type2' & isD) | (MapPage.type === 'type1' & !isD) | (MapPage.type === 'type3' & isD)) {
        if (!!agreement.shortcut)
            MapPage.el.find('.passive').hide();
        else
            MapPage.el.find('.passive').show();
    } else if ((MapPage.type === 'type1' & isD) | (MapPage.type === 'type2' & !isD)) {
        if (isD) {
            MapPage.el.find('.map-footer .receive .greenButton').html("Accepter");
            MapPage.el.find('.map-footer .counter .greenButton').html("Proposer ce nouveau covoiturage");
        } else {
            MapPage.el.find('.map-footer .receive .greenButton').html("Réserver");
            MapPage.el.find('.map-footer .counter .greenButton').html("Réserver ce nouveau covoiturage");
        }
        if (!!agreement.shortcut) {
            MapPage.el.find('.map-footer .receive .greenButton').html("Je confirme");
            MapPage.el.find('.map-footer .receive .whiteButton').html("C'est une erreur");
        } else {
            MapPage.el.find('.map-footer .receive .whiteButton').html("Refuser");
        }
        MapPage.el.find('.receive').show();
    } else if (MapPage.type === 'type3' & !isD) {
        MapPage.el.find('.haveConfirm').show();
    } else if (MapPage.type === 'type4' | MapPage.type === 'type5' | MapPage.type === 'type6' | MapPage.type === 'type7') {
        if (isD)
            MapPage.el.find('.haveRDV .greenButton').html("Passager déposé");
        else
            MapPage.el.find('.haveRDV .greenButton').html("J'ai été déposé");
        MapPage.el.find('.haveRDV').show();
    } else if (MapPage.type === 'type8' | MapPage.type === 'type9') {
        MapPage.el.find('.haveAck').show();
    } else if (MapPage.type === 'type10' | MapPage.type === 'type11') {
        MapPage.el.find('.haveGrading').show();
        if (MapPage.type === 'type10')
            MapPage.el.find('.haveGrading .red').show();
        else
            MapPage.el.find('.haveGrading .red').hide();
    }
    
    //This is generalStuff
    MapPage.el.find('.remoteName').html(name);
    MapPage.el.find('.profileImage').html('<img class="imageLoaded" src="img/profile_grey.svg" alt="">');
    ProfilePage.fillImageProfile(match.match.idmatches, Partir4Page.journeyId, false);
    var workplace = match.profile.workplace;
    if (typeof workplace !== 'undefined')
        MapPage.el.find('.firm').html('<img src="http://kankaroo.com/partenaire/'+workplace+'.png" style="max-height: 1.6em; max-width: 4em; height: auto; width: auto; margin-top: 0.2em; margin-right: -0.3em">');
    else
        MapPage.el.find('.firm').html('');
    
    //Give the footer pading it's correct size
    setTimeout(function() {
       MapPage.el.find('.physicalFooterPadding').height(MapPage.el.find('.map-footer').height());
    },50);
};

MapPage.fillInRDVReminder = function() {
    var agreement = MapPage.matchList[MapPage.matchNum].agreements[MapPage.agreementNum];
    var alarms = window.localStorage.getArray("alarms");
    var indice;
    for (var i = 0; i < alarms.length; i++) {
        if (parseInt(alarms[i].id) === parseInt(agreement.idagreements)) {
            indice = i;
            break;
        }
    }
    if (typeof indice !== 'undefined') {
        MapPage.el.find("input[value='RDVReminder']").prop('checked',alarms[indice].val);
        MapPage.el.find('select[name="RDVReminderParameter"]').val(alarms[indice].delay);
    } else {
        MapPage.el.find("input[value='RDVReminder']").prop('checked',false);
        if (!!localStorage.alarmsDelay)
            MapPage.el.find('select[name="RDVReminderParameter"]').val(localStorage.alarmsDelay);
    }
};

MapPage.fillInRDVDrop = function(fromLoadMatch) {
    var match = MapPage.matchList[MapPage.matchNum];
    
    MapPage.fillReverseGeocode(MapPage.el.find('.rdvBox .agreementBoxAddress'), match.agreementJourney.pickupPlace.latitude, match.agreementJourney.pickupPlace.longitude);
    if (fromLoadMatch === false) {
        var pickupDescription = Map2Page.el.find('input[name="rdv-description"]').val();
        if (pickupDescription !== 'Décrivez le lieu de RDV')
            match.match.pickupDescription = encodeURIComponent(pickupDescription);
        else
            match.match.pickupDescription = '';
    }
    var pickupDes = escapeXml(decodeURIComponent(match.match.pickupDescription));
    if (pickupDes === '' | pickupDes === 'undefined') {
        MapPage.el.find('.rdvBox .agreementBoxDescription').hide();
    } else {
        MapPage.el.find('.rdvBox .agreementBoxDescription').show();
        MapPage.el.find('.rdvBox .agreementBoxDescription').html(pickupDes);
    }
    
    MapPage.fillReverseGeocode(MapPage.el.find('.dropBox .agreementBoxAddress'), match.agreementJourney.dropPlace.latitude, match.agreementJourney.dropPlace.longitude);
    if (fromLoadMatch === false) {
        var dropDescription = Map2Page.el.find('input[name="arrival-description"]').val();
        if (dropDescription !== 'Décrivez le lieu de dépose')
            match.match.dropDescription = encodeURIComponent(dropDescription);
        else
            match.match.dropDescription = '';
    }
    var dropDes = escapeXml(decodeURIComponent(match.match.dropDescription));
    if (dropDes === '' | dropDes === 'undefined') {
        MapPage.el.find('.dropBox .agreementBoxDescription').hide();
    } else {
        MapPage.el.find('.dropBox .agreementBoxDescription').show();
        MapPage.el.find('.dropBox .agreementBoxDescription').html(dropDes);
    }
    
    MapPage.el.find('.timeBox .agreementBoxAddress').html(MyTravels.computeTimeString(0, new Date(match.agreementJourney.pickupTimeMin + " GMT")));
};

MapPage.fillInCounterPropositionColours = function(counter) {
    if ((counter & MONDAY) !== 0) {
        MapPage.el.find('.rdvBox').css('backgroundColor','rgb(225,232,247)');
    }
    if ((counter & TUESDAY) !== 0) {
        MapPage.el.find('.dropBox').css('backgroundColor','rgb(225,232,247)');
    }
    if ((counter & WEDNESDAY) !== 0) {
        MapPage.el.find('.timeBox').css('backgroundColor','rgb(225,232,247)');
    }
    if ((counter & THURSDAY) !== 0) {
        MapPage.el.find('.priceBox').css('backgroundColor','rgb(225,232,247)');
    }
};

MapPage.resetRDVDrop = function() {
    MapPage.el.find('.rdvBox, .dropBox, .timeBox, .priceBox').css('backgroundColor','rgba(0,0,0,0)');
    MapPage.el.find('.rdvBox .agreementBoxDescription').hide();
    MapPage.el.find('.dropBox .agreementBoxDescription').hide();
};

MapPage.handleTimePriceModifyVisibility = function(visible) {
    if (visible) {
        MapPage.el.find('.timeBox .agreementBox').css('width','78%');
        MapPage.el.find('.timeBox .chevronContainer').show();
        if (MapPage.priceIsNegative) {
            MapPage.el.find('.priceBox .agreementBox').css('width','100%');
            MapPage.el.find('.priceBox .chevronContainer').hide();
        } else {
            MapPage.el.find('.priceBox .agreementBox').css('width','78%');
            MapPage.el.find('.priceBox .chevronContainer').show();
        }
    } else {
        MapPage.el.find('.timeBox .agreementBox, .priceBox .agreementBox').css('width','100%');
        MapPage.el.find('.timeBox .chevronContainer, .priceBox .chevronContainer').hide();
    }
};

MapPage.switchToCounterProposition = function(causedByMap) {
    MapPage.counterProposition = true;
    MapPage.el.find('.receive').hide();
    MapPage.el.find('.counter').show();
    var timer;
    if (!!causedByMap) {
        timer = 400;
    } else {
        timer = 200;
    }
    setTimeout(function() {
        MapPage.el.find('.physicalFooterPadding').height(MapPage.el.find('.map-footer').height());
    },50);
};

MapPage.gatherProposition = function() {
    var match = MapPage.matchList[MapPage.matchNum];
    var journey = match.agreementJourney;
    
    var data = 
        {
            myJourneyId       : Partir4Page.journeyId,
            matchId           : match.match.idmatches,
            pickupLat         : journey.pickupPlace.latitude,
            pickupLong        : journey.pickupPlace.longitude,
            dropLat           : journey.dropPlace.latitude,
            dropLong          : journey.dropPlace.longitude,
            pickupDescription : match.match.pickupDescription,
            dropDescription   : match.match.dropDescription
        };
        
    var date = new Date(journey.pickupTimeMin+" GMT");
    data.pickupTime = date.toISOString();
    
    if (Partir4Page.userType === "driver"){
        data.price =  journey.price;
    } else {
        data.price =  journey.passengerPrice;
    }
    
    return data;
};

MapPage.gatherCounterProposition = function() {
    var initialMatch = MapPage.counterPropositionInitialMatch;
    var initialJourney = initialMatch.agreementJourney;
    var match = MapPage.matchList[MapPage.matchNum];
    var journey = match.agreementJourney;
    
    var modified = {};
    
    if (initialJourney.pickupPlace.latitude !== journey.pickupPlace.latitude
            | initialJourney.pickupPlace.longitude !== journey.pickupPlace.longitude) {
        modified.pickupLat = journey.pickupPlace.latitude;
        modified.pickupLong = journey.pickupPlace.longitude;
    }

    if (initialJourney.dropPlace.latitude !== journey.dropPlace.latitude
            | initialJourney.dropPlace.longitude !== journey.dropPlace.longitude) {
        modified.dropLat = journey.dropPlace.latitude;
        modified.dropLong = journey.dropPlace.longitude;
    }
    
    if (initialMatch.match.pickupDescription !== match.match.pickupDescription) {
        modified.pickupDescription = match.match.pickupDescription;
    }
    
    if (initialMatch.match.dropDescription !== match.match.dropDescription) {
        modified.dropDescription = match.match.dropDescription;
    }
    
    var initialDate = new Date(initialMatch.agreementJourney.pickupTimeMin + " GMT");
    var date = new Date(match.agreementJourney.pickupTimeMin + " GMT");
    if (initialDate.getTime() !== date.getTime()) {
        modified.pickupTime = date.toISOString();
    }
    
    var initialPrice;
    var price;
    if (Partir4Page.userType ==="driver"){
        initialPrice = initialMatch.agreementJourney.price;
        price = match.agreementJourney.price;
    } else {
        initialPrice = initialMatch.agreementJourney.passengerPrice;
        price = match.agreementJourney.passengerPrice;
    }
    if (initialPrice !== price) {
        modified.price = price;
    }
    
    var agreement = match.agreements[MapPage.agreementNum];
    agreement.counterProposition = 0;
    //update agreement.counterProposition
    if (!!modified.pickupLat | !!modified.pickupDescription)
        agreement.counterProposition += 1;
    if (!!modified.dropLat | !!modified.dropDescription)
        agreement.counterProposition += 2;
    if (!!modified.pickupTime)
        agreement.counterProposition += 4;
    if (!!modified.price)
        agreement.counterProposition += 8;

    return modified;
};

MapPage.handlePaiementMode = function() {
    //TODO Implement a popUp that makes you choose between Cash, wallet and CB
    if (MapPage.priceIsNegative) {
        MapPage.agreementUpdate("confirmed");
        return;
    }
    navigator.notification.confirm(
        "Pour simplifier le paiement, le prix va être arrondi au 0,10 € supérieur\n\nBientôt un paiement automatique possible", 
         function(index){
            if (index === 2) {
                MapPage.agreementUpdate("confirmed");
            }
        },
        "Paiement en espèces",
        "Annuler,D'accord"
    );
};

MapPage.validateProposition = function(data) {
    showLoading();
    serverRequest(
        "/agreementProposition",
        "GET",
        function (data) {
            if(data.status==="update"){
                MapPage.handleStatusUpdate();
            } else MapPage.reload("firstProposition", data);
        },
        "MapPage validate proposition",
        function() {MapPage.validateProposition(data);},
        data
    );
};

MapPage.agreementUpdate = function (newStatus,aditionalOptions) {
    showLoading();
    var data = new Object();
    data.userType = Partir4Page.userType;
    data.agreementId = MapPage.matchList[MapPage.matchNum].agreements[MapPage.agreementNum].idagreements;
    data.newStatus = newStatus;
    if (typeof aditionalOptions !== "undefined"){
        jQuery.extend(data,aditionalOptions);
    }
    serverRequest(
        "/agreementUpdate",
        "GET",
        function (data){
            if(data.status==="update"){
                MapPage.handleStatusUpdate();
            } else MapPage.reload(newStatus, data);
        },
        "agreementUpdate MapPage",
        function () {
            MapPage.agreementUpdate(newStatus,aditionalOptions);
        },
        data
    );
};

MapPage.reload = function(newStatus, data){
    var match = MapPage.matchList[MapPage.matchNum];
    var agreement;
    if (newStatus === "firstProposition") {
        agreement = data;
        if (Partir4Page.userType === 'driver') {
            agreement.stateDriver = "proposing";
            agreement.statePassenger = "receiving";
        } else { //if the user is passenger
            agreement.stateDriver = "receiving";
            agreement.statePassenger = "proposing";
        }
        agreement.counterProposition = 0;
        match.agreements.push(agreement);
        MapPage.agreementNum = match.agreements.length - 1;
        MapPage.buildMatchLists();
    } else {
        agreement = match.agreements[MapPage.agreementNum];
        switch (newStatus) {
            case "proposing":
                if (Partir4Page.userType === 'driver') {
                    agreement.stateDriver = "proposing";
                    agreement.statePassenger = "receiving";
                } else { //if the user is passenger
                    agreement.stateDriver = "receiving";
                    agreement.statePassenger = "proposing";
                }
                MapPage.counterProposition = false;
                break;
            case "ack":
                MapPage.deleteAgreement();
                break;
            case "confirmed":
                if (!!agreement.shortcut) {
                    navigator.notification.confirm(
                        'Ce covoiturage a été comptabilisé dans la page "Mes comptes"', 
                         function(index){
                            if (index === 2) {
                                goToPage("#accounts");
                            } else {
                                goToPage("#myTravels");
                            }
                        },
                        "Covoiturage comptabilisé",
                        "Terminé,Montrez moi"
                    );
                    return;
                }
                if (Partir4Page.userType === 'driver') {
                    agreement.stateDriver = "confirmed";
                } else {
                    agreement.statePassenger = "confirmed";
                    agreement.paiementMean = 'cash';
                    //if (Partir4Page.regularity === 0) Partir4Page.matchNotification = false; Suspended for the moment
                }
                break;
            case "payDriver":
                agreement.stateDriver = "paid";
                break;
            case "grade":
                if (Partir4Page.userType === 'driver' & Partir4Page.regularity === 0 & agreement.seatsBooked === true)
                    MapPage.freePlaces();
                if (!((Partir4Page.userType === 'driver' & agreement.stateDriver === 'grading') || (Partir4Page.userType === 'passenger' & agreement.statePassenger === 'grading'))) {
                    var journeysNum;
                    if (data.journeys === 1) journeysNum = '1er';
                    else journeysNum = data.journeys + 'e';
                    var kilo = Math.floor(data.meters*0.001);
                    var decKilo = Math.round((data.meters-(kilo*1000))*0.01);
                    if (decKilo === 10) {
                        decKilo = 0;
                        kilo += 1;
                    }
                    var kiloS = kilo + ',' + decKilo;
                    var hoursHoover = HistoryPage.getHoursOfHooverFromMeters(data.meters);
                    alert("Vous avez terminé votre "+journeysNum+" covoiturage !\nVos "+kiloS+" km en covoiturage ont économisé "+hoursHoover+" kg de CO2",'Félicitations');
                    goToPage('#myTravels');
                    return;
                }
                MapPage.deleteAgreement();
                if (MapPage.matchNoAgreementsNumsList.length === MapPage.matchList.length) {
                    goToPage('#myTravels');
                    return;
                }
                GradePage.backToPreviousPage();
                break;
            case "notifyPaiement":
                alert('Une notification a été envoyée au passager');
                break;
            case "canceled":
                if (Partir4Page.userType === 'driver' & Partir4Page.regularity === 0 & agreement.seatsBooked === true)
                    MapPage.freePlaces();
                MapPage.deleteAgreement();
                break;
            case "complain":
                if (Partir4Page.userType === 'driver' & Partir4Page.regularity === 0 & agreement.seatsBooked === true)
                    MapPage.freePlaces();
                agreement.stateDriver = "grading";
                agreement.statePassenger = "grading";
                var complain = {};
                if (Partir4Page.userType === 'driver')
                    complain.driverManifested = true;
                else
                    complain.passengerManifested = true;
                agreement.complainIdcomplain = complain;
                alert('Votre réclamation a été envoyée');
                break;
        }
    }
    MapPage.refreshAgreements();
    MapPage.switchMatch(true);
};

MapPage.freePlaces = function() {
    Partir4Page.passengers += MapPage.matchList[MapPage.matchNum].userJourney.passengers;
    if (Partir4Page.el.find('.passengers').length>0)
        Partir4Page.el.find('.passengers').html(Partir4Page.passengers);
};

MapPage.deleteAgreement = function() {
    MapPage.matchList[MapPage.matchNum].agreements.splice(MapPage.agreementNum, 1);
    
    MapPage.buildMatchLists();
    if (MapPage.matchAgreementsPairsList.length > 0) {
        MapPage.matchNum = MapPage.matchAgreementsPairsList[0].matchNum;
        MapPage.agreementNum = MapPage.matchAgreementsPairsList[0].agreementNum;
    }
    else {
        MapPage.matchNum = 0;
        MapPage.agreementNum = -1;
    }
};

MapPage.refreshAgreements = function() {
    var tags = {};
    tags.potentialMatches = MapPage.matchNoAgreementsNumsList.length;
    tags.plannedRDV = 0;
    tags.activeAgreements = 0;
    tags.passiveAgreements = 0;
    
    for (var i = 0; i < MapPage.matchAgreementsPairsList.length; i++) {
        var pair = MapPage.matchAgreementsPairsList[i];
        var match = MapPage.matchList[pair.matchNum];
        var agreement = match.agreements[pair.agreementNum];
        agreement.tag = MapPage.computeAgreementTag(agreement);
        switch(agreement.tag) {
            case "RDVTag" :
                tags.plannedRDV++;
                break;
            case "activeTag" :
                tags.activeAgreements++;
                break;
            case "passiveTag" :
                tags.passiveAgreements++;
                break;
        }
    }
    Notification.addAgreements(Partir4Page.journeyId);
    
    Partir4Page.computeTags(tags);
    MyTravels.showTags(Partir4Page.el, Partir4Page);
};

MapPage.handleStatusUpdate = function() {
    goToPage('#myTravels');
    navigator.notification.alert(
        "Les informations contenues sur la page précédente n'étaient plus à jour\n\nResynchronisation avec le serveur",  // message
        function(){},         // callback
        'Oups',               // title
        'OK'                  // buttonName
    );
};

//Affiche la page
MapPage.render = function () {
    this.el.addClass("shown");
    hidePopUp(MapPage);
    if (!!MapPage.goingStraightToChat) {
        delete MapPage.goingStraightToChat;
        setTimeout(function() {
            MapPage.goToChatPage();
        }, 100);
    }
    MapPage.el.find('.headerPhysicalPadding').height(MapPage.el.find('.header').height() + MapPage.el.find('.tagsContainer').height());
};

MapPage.reset = function() {
    Map2Page.el.find('#map-overlay .rdv-overlay .address').html("chargement de l'adresse...");
    Map2Page.el.find('#map-overlay .arrival-overlay .address').html("chargement de l'adresse...");
    MapPage.counterProposition = false;
    MapPage.RDVTutoSnobed = false;
    MapPage.grade = -1;
};

MapPage.readableUserType = function(reverse) {
    if (Partir4Page.userType === 'driver') {
        if (!reverse) return 'conducteur';
        else return 'passager';
    }
    else if (!reverse) return 'passager';
    else return 'conducteur';
};

MapPage.goToChatPage = function() {
    var data = new Object();
    data.match = MapPage.matchList[MapPage.matchNum];
    data.name = data.match.profile.name;
    data.matchId = data.match.match.idmatches;
    data.journeyId = Partir4Page.journeyId;
    if (Partir4Page.userType === 'driver') data.notif = MapPage.matchList[MapPage.matchNum].match.driverNotifMessage;
    else data.notif = MapPage.matchList[MapPage.matchNum].match.passengerNotifMessage;
    MessagePage.setUpUsers(data);
    //go to page chat
    $(".shown").removeClass("shown");
    MessagePage.render();
};

MapPage.goToMap2Page = function(label) {
    $(".shown").removeClass("shown");
    Map2Page.render(label);
};

MapPage.goToGradePage = function(commingFrom) {
    GradePage.commingFrom = commingFrom;
    $(".shown").removeClass("shown");
    GradePage.render();
};

MapPage.otherTimeStringFormat = function(match) {
    var journey = match.userJourney;
    var dateMin = new Date(journey.pickupTimeMin+" GMT");
    var dateMax;
    if (!!journey.pickupTimeMax) dateMax = new Date(journey.pickupTimeMax+" GMT");
    var regularity = journey.regularity;
    var myTravelsTime = MyTravels.computeTimeString(regularity, dateMin, dateMax);
    var time;
    if (myTravelsTime.substring(0, 1) === 'E') time = 'e'+myTravelsTime.substring(1, myTravelsTime.length);
    else time = 'à'+myTravelsTime.substring(1, myTravelsTime.length);
    return time;
};

MapPage.computeSimpleTime = function() {
    var journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
    var date    = new Date(journey.pickupTimeMin + " GMT");
    var minutes = date.getMinutes();
    var hour    = date.getHours();
    var time;
    if (minutes < 10) {
        time = hour + ":0" + minutes;
    } else {
        time = hour + ":" + minutes;
    }
    return time;
};

MapPage.computeSimplePrice = function(input) {
    var journey;
    var price;
    var match;
    if (typeof input !== 'undefined') {
        price = input;
    } else {
        match = MapPage.matchList[MapPage.matchNum];
        journey = MapPage.matchList[MapPage.matchNum].agreementJourney;
        if (Partir4Page.userType === "driver"){
            price = journey.price;
        } else {
            price = journey.passengerPrice;
        }
        if (MapPage.agreementNum !== -1) {
            if (match.agreements[MapPage.agreementNum].paiementMean === 'cash')
                price = journey.cashPrice;
        }
    }
    var computedPrice = MapPage.computePrice(price);
    var euro = computedPrice[0];
    var cent = computedPrice[1];
    var text = euro+","+cent+" €";
    return text;
};

MapPage.isPriceNegative = function() {
    var price;
    if (Partir4Page.userType === "driver"){
        price = MapPage.matchList[MapPage.matchNum].agreementJourney.price;
    } else {
        price = MapPage.matchList[MapPage.matchNum].agreementJourney.passengerPrice;
    }
    return price < 0;
};

MapPage.buildMatchLists = function() {
    MapPage.matchNoAgreementsNumsList = [];
    MapPage.matchAgreementsPairsList = [];
    for (var i = 0; i < MapPage.matchList.length; i++) {
        var match = MapPage.matchList[i];
        if (match.agreements.length === 0) MapPage.matchNoAgreementsNumsList.push(i);
        else {
            for(var j=0;j<match.agreements.length;j++){
                var agreement = match.agreements[j];
                agreement.tag = MapPage.computeAgreementTag(agreement);
                MapPage.matchAgreementsPairsList.push({matchNum : i, agreementNum : j});
            }
        }
    }
};

//If there is no bug it can't receive true from MapPage.setUpMapPageForProperAgreement
//Because it's called from partir4Page when partir4Page and MapPage are synchronized
MapPage.goToProperAgreement = function(tag) {
    MapPage.setUpMapPageForProperAgreement(tag);
    MapPage.reset();
    MapPage.loadMatchData();
};

MapPage.setUpMapPageForProperAgreement = function (tag) {
    var result;
    if (tag === "potentialTag") {
        if (MapPage.matchNoAgreementsNumsList.length === 0)
            return "update";
        else {
            MapPage.matchNum = MapPage.matchNoAgreementsNumsList[0];
            MapPage.agreementNum = -1;
            if (MapPage.matchNoAgreementsNumsList.length === 1)
                result = "normal";
            else
                result = "choice";
        }
    } else if (tag === "messageTag") {
        if (MapPage.matchAgreementsPairsList.length === 0)
            return "update";
        else {
            var pair = MapPage.matchAgreementsPairsList[0];
            MapPage.matchNum = pair.matchNum;
            MapPage.agreementNum = pair.agreementNum;
            if (MapPage.matchAgreementsPairsList.length === 1)
                result = "goToChat";
            else
                result = "choice";
        }
    } else {
        var correspondancesNum = 0;
        var firstPair;
        for (var i=0;i<MapPage.matchAgreementsPairsList.length;i++){
            var pair = MapPage.matchAgreementsPairsList[i];
            var match = MapPage.matchList[pair.matchNum];
            var agreement = match.agreements[pair.agreementNum];
            if (tag === MapPage.computeAgreementTag(agreement)) {
                correspondancesNum++;
                if (typeof firstPair === 'undefined') {
                    firstPair = pair;
                }
            }
        }
        if (correspondancesNum === 0)
            return "update";
        else {
            MapPage.matchNum = firstPair.matchNum;
            MapPage.agreementNum = firstPair.agreementNum;
            if (correspondancesNum === 1)
                result = "normal";
            else
                result = "choice";
        }
    }
    if (result === "choice") {
        if (Partir4Page.userType === "driver")
            Notification.el.find('#passengerNotifContainer').trigger('touchstart').trigger('touchend');
        else
            Notification.el.find('#driverNotifContainer').trigger('touchstart').trigger('touchend');
    } else if (result === "goToChat") {
        MapPage.goingStraightToChat = true;
    }
    return false;
};

MapPage.computeAgreementTag = function(agreement) {
    var statePassenger = agreement.statePassenger;
    var stateDriver = agreement.stateDriver;
    var r = "RDV";
    var b = "both";
    var d = "driverActive";
    var p = "passengerActive";
    var state;
    if(stateDriver === "receiving" | statePassenger === "refused")
        state = d;
    else if (statePassenger === "receiving" | stateDriver === "refused")
        state = p;
    else if (statePassenger === "confirmed" | statePassenger === "paid") {
        if (stateDriver === "paid" | stateDriver === "grading")
            state = b;
        else
            state = r;
    } else if (stateDriver === "confirmed") {
        state = p;
    } else if (statePassenger === "grading" | stateDriver === "grading")
        state = b;
    
    switch (state) {
        case "RDV":
            return "RDVTag";
            break;
        case "both":
            return "activeTag";
            break;
        case "driverActive":
            if (Partir4Page.userType === 'driver')
                return "activeTag";
            else
                return "passiveTag";
            break;
        case "passengerActive":
            if (Partir4Page.userType === 'driver')
                return "passiveTag";
            else
                return "activeTag";
            break;
    }
};

MapPage.fillReverseGeocode = function(object, lat, lng) {
    var latlong = {lat : lat, lng : lng};
    var address = MapPage.retriveFromCache(latlong);
    if (!address) {
        object.html('Chargement en cours...');
        Geocoding.reverseGeocoding(latlong,function(data){
            if(data[0]){
                var addressString = data[0].formatted_address;
                object.html(addressString);
                MapPage.putInCache(latlong, addressString);
            }
        });
    } else {
        object.html(address);
    }
};

MapPage.putInCache = function(latlong, address) {
    var reverseGeocodingCache = window.localStorage.getArray("reverseGeocodingCache");
    for (var i=0; i<reverseGeocodingCache.length; i++) {
        var item = reverseGeocodingCache[i];
        if (item.lat === latlong.lat & item.lng === latlong.lng) {
            return;
        }
    }
    latlong.address = address;
    reverseGeocodingCache.push(latlong);
    if (reverseGeocodingCache.length>150) {
        reverseGeocodingCache.splice(0,75);
    }
    window.localStorage.setArray("reverseGeocodingCache", reverseGeocodingCache);
};

MapPage.retriveFromCache = function(latlong) {
    var reverseGeocodingCache = window.localStorage.getArray("reverseGeocodingCache");
    var address;
    for (var i=0; i<reverseGeocodingCache.length; i++) {
        var item = reverseGeocodingCache[i];
        if (item.lat === latlong.lat & item.lng === latlong.lng) {
            address = item.address;
        }
    }
    return address;
};

MapPage.computePrice = function(price){
    var euro = Math.floor(price*0.01);
    var cent = price - (euro * 100);
    if (cent<10) cent = "0"+cent;
    return [euro,cent];
};