/* global Geocoding, Partir4Page, Notification, MapPage, device, PartirPage, appIsOnForeground, MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY, deviceType */

var MyTravels = new Object();

MyTravels.el = $('#myTravels');
MyTravels.delete = false;
MyTravels.cacheTimeBeforeUpdate = 2592000000; //1 month
MyTravels.cacheMaxSize = 70; //Not constantly guaranted
MyTravels.travels;
MyTravels.undefinedVariable;
MyTravels.regularity;
MyTravels.dateMin;
MyTravels.dateMax;
MyTravels.popUpRegularity;
MyTravels.popUpPickupTimeMin;
MyTravels.popUpPickupTimeMax;
MyTravels.popUpJourneyId;
//MyTravels.modifiedMatchNotifications = []; Suspended for the moment
MyTravels.gpsTimeout;
MyTravels.showTuto = false;
//Fonction d'initialisation, affecte les evenements.
MyTravels.initialize = function () {
    this.eventHandler();
};

MyTravels.eventHandler = function () {
    
    this.el.on('click','.newTravel',function (event){
        setTimeout(function() {
            PartirPage.reload = true;
            goToPage("#partir");
        }, 100);
    });
    
    this.el.on('click','.travel',function (event){
        var journeyId = parseInt($(this).find('.journeyId').html());
        MyTravels.loadTravel(journeyId, $(this));
        Partir4Page.commingFrom = "MyTravelsPage";
        goToPage("#partir4");
    });
    
    this.el.on('click','.messageTag, .RDVTag, .activeTag, .passiveTag, .potentialTag',function (event){
        event.stopPropagation();
        var journeyId = parseInt($(this).parent().parent().find('.journeyId').html());
        MyTravels.loadTravel(journeyId, $(this).parent().parent());
        showLoading();
        var temp = $('<div></div>');
        temp.addClass($(this).attr("class"));
        MyTravels.requestLoadTravel(journeyId, {tag : temp.attr("class")});
    });
    
    this.el.on('click','.delete',function (event){
        event.stopPropagation();
        var object = $(this).parent().parent();
        var id = parseInt(object.find('.journeyId').html());
        MyTravels.deletePopUp(id, object);
    });
    
    this.el.on('click','.modifyJourney',function (event){
        event.stopPropagation();
        MyTravels.el.find('.popUp').html(popUp_modify_time_template());
        var object = $(this).parent().parent();
        if (object.find('.messageTag').is(':visible')) {
            alert('Impossible de modifier un trajet avec des propositions ou des accords en cours','Modifications impossibles');
            return;
        }
        var journeyId = parseInt(object.find('.journeyId').html());
        MyTravels.el.find('.timePop .journeyId').html(journeyId);
        MyTravels.popUpJourneyId = journeyId;
        MyTravels.popUpRegularity = parseInt(object.find('.regularity').html());
        MyTravels.popUpPickupTimeMin = new Date(parseInt(object.find('.pickupTimeMin').html()));
        var pickupTimeMaxS = object.find('.pickupTimeMax').html();
        if (pickupTimeMaxS.length !== 0) {
            MyTravels.popUpPickupTimeMax = new Date(parseInt(pickupTimeMaxS));
            MyTravels.popUpPickupTimeMax.setDate(MyTravels.popUpPickupTimeMin.getDate());
        } else
            MyTravels.popUpPickupTimeMax = MyTravels.popUpPickupTimeMin;
        if (MyTravels.popUpRegularity === 0) {
            MyTravels.el.find('.unregular').show();
            MyTravels.el.find('.regular').hide();
            MyTravels.el.find("input[value='travelRegularity']").prop('checked',false);
        } else {
            MyTravels.el.find('.unregular').hide();
            MyTravels.el.find('.regular').show();
            MyTravels.el.find("input[value='travelRegularity']").prop('checked',true);
        }
        MyTravels.fillRegularity(MyTravels, MyTravels.popUpRegularity);
        MyTravels.fillDate(MyTravels, MyTravels.popUpPickupTimeMin, MyTravels.popUpPickupTimeMax);
        PartirPage.TimeLaps = PartirPage.computeTimeLaps(MyTravels);
        showPopUp(MyTravels);
    });
    
    this.el.on('click','.popUpValid',function (event){
        MyTravels.handleTravelModification(MyTravels);
    });
    
    this.el.on('click','.navigate',function (event){
        event.stopPropagation();
        var object = $(this).parent().parent();
        var lat = object.find('.destLat').html();
        var lng = object.find('.destLng').html();
        var add = object.find('.arrival .address').html();
        MyTravels.navigatePopUp(lat, lng, add);
    });
    
    this.el.on('click', '.overlay, .popUpOk, .popUpCancel', function (event) {
        event.stopPropagation();
        hidePopUp(MyTravels);
    });
    
    this.el.on('click', '.popUp', function (event) {
        event.stopPropagation();
    });
    
    this.el.on('touchstart', '.addH', function (event) {
        var object = $(this);
        PartirPage.addMinAddH(object, true);
    });
    
    this.el.on('touchstart', '.addMin', function (event) {
        var object = $(this);
        PartirPage.addMinAddH(object, false);
    });

    this.el.on('touchstart', '.substractH', function (event) {
        var object = $(this);
        PartirPage.subMinSubH(object, true);
    });
    
    this.el.on('touchstart', '.substractMin', function (event) {
        var object = $(this);
        PartirPage.subMinSubH(object, false);
    });
    
    this.el.on('touchstart', '.addDay, .addMonth, .addYear', function (event) {
        var object = $(this);
        PartirPage.addDayAddMonthAddYear(MyTravels, object);
    });
    
    this.el.on('touchstart', '.substractDay, .substractMonth, .substractYear', function (event) {
        var object = $(this);
        PartirPage.subDaySubMonthSubYear(MyTravels, object);
    });
    
    this.el.on('blur',"input[name='dayInput'], input[name='month'], input[name='year']",function () {
        PartirPage.blurDayMonthYear(MyTravels);
    });

    this.el.on('blur',"input[name='hourMin'], input[name='hourMax']",function () {
        var object = $(this);
        PartirPage.blurHminHmax(MyTravels, object);
    });

    this.el.on('blur',"input[name='minutesMin'], input[name='minutesMax']",function () {
        var object = $(this);
        PartirPage.blurMminMmax(MyTravels, object);
    });
    
    this.el.on('touchstart', 'label', function (event) {
        $(this).one('touchmove',function (event){
           object.off('touchend'); 
        });
        var object = $(this);
        $(this).one('touchend', function (event) {
            if (event.target.tagName !== "INPUT") {
                if (object.hasClass("checkbox"))
                {
                    if (object.hasClass("selectedLabel"))
                    {
                        object.removeClass("selectedLabel");
                    } else {
                        object.addClass("selectedLabel");
                    }
                }
            }
        });
    });
    
    this.el.on('click','.onoffswitch-label',function(event){
        event.preventDefault();
    });
};

MyTravels.deletePopUp = function(id, object) {
    navigator.notification.confirm(
        "Supprimer ce trajet ?", 
        function(index) {
            if (index === 2) {
                window.plugins.toast.showShortTop("Suppression en cours...");
                var data = {
                    "myJourneyId" : id
                }; 
                MyTravels.sendTravelDelete(data, object);
            }
        },
        "Kankaroo",
        "Annuler,Supprimer"
    );
};

MyTravels.navigatePopUp = function(lat, lng, add) {
    navigator.notification.confirm(
        "Guider vers : "+add+" ?", 
        function(index) {
            if (index === 2) {
                MyTravels.navigateCheck(lat, lng, add);
            }
        },
        "Navigation",
        "Annuler,Guider"
    );
};

MyTravels.navigateCheck = function(lat, lng, add) {
    if (!localStorage.favoriteGPS) {
        var choices = "Google Maps,Waze";
        if (deviceType === 'iOS')
            choices += ",Plan,Annuler";
        navigator.notification.confirm(
            "Selectionner votre application favorite\n\nVous pouvez modifier votre choix depuis votre compte", 
            function(index) {
                if (index === 1) {
                    localStorage.favoriteGPS = "maps";
                    MyTravels.navigateAction(lat, lng, add);
                } else if (index === 2) {
                    localStorage.favoriteGPS = "waze";
                    MyTravels.navigateAction(lat, lng, add);
                } else if (index === 3) {
                    localStorage.favoriteGPS = "plan";
                    MyTravels.navigateAction(lat, lng, add);
                }
            },
            "Application GPS favorite",
            choices
        );
    } else {
        MyTravels.navigateAction(lat, lng, add);
    }
};

MyTravels.navigateAction = function(lat, lng, add) {
    MyTravels.gpsTimeout = setTimeout(function() {
        if (appIsOnForeground) {
            navigator.notification.confirm(
                "Il semblerait que cette application ne soit pas sur votre appareil", 
                function() {
                    window.localStorage.removeItem("favoriteGPS");
                    MyTravels.navigateCheck(lat, lng, add);
                },
                "Erreur",
                "Ok"
            );
        }
    }, 2000);
    if (localStorage.favoriteGPS === "maps") {
        if (deviceType === 'android')
            window.location.href = "google.navigation:q="+lat+","+lng;
        else
            window.location.href = "comgooglemaps://?daddr="+add+"&nav=1";
    } else if (localStorage.favoriteGPS === "waze") {
        window.location.href = "waze://?ll="+lat+","+lng+"&navigate=yes";
    } else if (localStorage.favoriteGPS === "plan") {
        window.location.href = "maps://maps.apple.com/?daddr="+add+"&dirflg=d";
    }
};

MyTravels.sendTravelDelete = function(data, object) {
    serverRequest(
            "/travel/cancelJourney",
            "GET",
            function(response) {
                if (!!object) {
                    var next = object.next();
                    if (next.length !== 0)
                        next.remove();
                    else
                        object.prev().remove();
                    object.remove();
                    if (MyTravels.el.find('.areTravels').html().length === 0)
                        MyTravels.el.find('.noTravels').show();
                } else {
                    goToPage('#myTravels');
                }
            },
            "delete travel Travelpage",
            function() {MyTravels.sendTravelDelete(data, object);},
            data
    );
};

MyTravels.loadTravel = function (journeyId, object) {
    var result = $.grep(MyTravels.travels,function(e){
        var journey = JSON.parse(e.journey);
        return journey.idjourney === journeyId;
    });
    var journey = JSON.parse(result[0].journey);
    
    //send data to Partir4Page
    journey.pickupAddress = object.find('.departure .address').html();
    journey.dropAddress = object.find('.arrival .address').html();
    if (!!journey.dropPlaceAlt) journey.dropAltAddress = object.find('.arrival_Alt .address').html();
    var tags = {
        plannedRDV : result[0].plannedRDV,
        potentialMatches : result[0].potentialMatches,
        activeAgreements : result[0].activeAgreements,
        passiveAgreements : result[0].passiveAgreements
    };
    Partir4Page.sendJourneyToMe(journey, tags);
};

MyTravels.requestLoadTravel = function(journeyId, goingStraight) {
    serverRequest(
        "/travel/matches",
        "GET",
        function(data) {
            MyTravels.sendDateToMap(data, goingStraight, journeyId);
        },
        "load travel page",
        function(){
            MyTravels.requestLoadTravel(journeyId, goingStraight);
        },
        {"myJourneyId":journeyId}             
    );
};

MyTravels.sendDateToMap = function (data, goingStraight, journeyId) {
    if (data.status === 'update') {
        alert("Ce trajet n'était plus d'actualité");
        goToPage('#myTravels');
    }
    if (data.matches.length === 0) {
        if (!!goingStraight.matchId) {
            notifyNotificationNotActual();
            goSomewhere(journeyId);
        } else if (!!goingStraight.tag) {
            alert("Les informations contenues sur la page précédente n'étaient plus à jour\n\nResynchronisation avec le serveur");
            goSomewhere(journeyId);
        } else {
            Partir4Page.commingFrom = "MyTravelsPage";
            goToPage('#partir4');
        }
    } else {
        var fail = MapPage.sendDataToMap(data.matches, goingStraight);
        if (!!goingStraight.tag) {
            if (fail === false)
                goToPage('#map');
            else {
                alert("Les informations contenues sur la page précédente n'étaient plus à jour\n\nResynchronisation avec le serveur");
                goSomewhere(journeyId);
            }
        } else {
            if (fail === false) {
                if (!!goingStraight.message)
                    MapPage.goingStraightToChat = true;
                goToPage('#map');
            } else {
                notifyNotificationNotActual();
                goSomewhere(journeyId);
            }
        }
    }
};

MyTravels.getTravels = function (goingStraight) {
    serverRequest(
            "/travel/journeys",
            "GET",
            function (data) {
                MyTravels.reset();
                if (typeof goingStraight !== 'undefined') {
                    showLoading();
                    MyTravels.gotTravels(data);
                    MyTravels.gotTheTravel(data, goingStraight);
                } else {
                    MyTravels.gotTravels(data);
                }
            },
            "MyTravels getTravels",
            function () {MyTravels.getTravels(goingStraight);}
        );
};

MyTravels.gotTravels = function (data) {
    data.sort(function(a,b){
        var Ajourney = JSON.parse(a.journey);
        var Bjourney = JSON.parse(b.journey);
        if(Ajourney.regularity>0 && Bjourney.regularity === 0){
            return 1;
        } else if (Bjourney.regularity>0 && Ajourney.regularity === 0) {
            return -1;
        } else {
            a = new Date(Ajourney.pickupTimeMin);
            b = new Date(Bjourney.pickupTimeMin);
            return a.getTime() < b.getTime() ? -1 : 1;
        }
    });
    
    MyTravels.travels = data;
    
    var buffer = {
        count : {count1 : MyTravels.travels.length},
        placesToFetch : [],
        placesToUpdate : []
    };
    
    if (MyTravels.travels.length === 0) {
        MyTravels.el.find('.noTravels').show();
        endLoading();
        return;
    }
    
    for(var i=0;i<MyTravels.travels.length;i++){
        var journey = JSON.parse(MyTravels.travels[i].journey);
        MyTravels.preParsePlaces(journey, buffer);
    }
    
    var placesToFetch = buffer.placesToFetch;
    var placesToFetchLength = placesToFetch.length;
    if (placesToFetchLength === 0) {
        for(var i=0;i<MyTravels.travels.length;i++){
            var journey = JSON.parse(MyTravels.travels[i].journey);
            journey.plannedRDV = MyTravels.travels[i].plannedRDV;
            journey.potentialMatches = MyTravels.travels[i].potentialMatches;
            journey.activeAgreements = MyTravels.travels[i].activeAgreements;
            journey.passiveAgreements = MyTravels.travels[i].passiveAgreements;
            MyTravels.fillInPlaces(journey, buffer);
        }
    }
    else { buffer.count.count2 = placesToFetchLength;
        for(var i=0;i<placesToFetchLength;i++){
            var place = placesToFetch[i];
            Geocoding.reverseGeocoding(place,function(data, place) {MyTravels.placesAssembled(place, buffer, data);});
        }
    }
};

MyTravels.preParsePlaces = function (journey, buffer) {
    var alreadySpoted = buffer.placesToFetch.concat(buffer.placesToUpdate);
    
    var dep = {lat : journey.pickupPlace.latitude, lng : journey.pickupPlace.longitude};
    var depCache = MyTravels.isInGeocodingCache(dep, alreadySpoted);
    if (depCache === 'None') {buffer.placesToFetch.push(dep); alreadySpoted.push(dep);}
    else if (depCache === 'Update') {buffer.placesToUpdate.push(dep); alreadySpoted.push(dep);}
    
    var arr = {lat : journey.dropPlace.latitude, lng : journey.dropPlace.longitude};
    var arrCache = MyTravels.isInGeocodingCache(arr, alreadySpoted);
    if (arrCache === 'None') buffer.placesToFetch.push(arr);
    else if (arrCache === 'Update') buffer.placesToUpdate.push(arr);
    
    if (!!journey.dropPlaceAlt) {
        alreadySpoted = buffer.placesToFetch.concat(buffer.placesToUpdate);
        var arrAlt = {lat : journey.dropPlaceAlt.latitude, lng : journey.dropPlaceAlt.longitude};
        var arrAltCache = MyTravels.isInGeocodingCache(arrAlt, alreadySpoted);
        if (arrAltCache === 'None') buffer.placesToFetch.push(arrAlt);
        else if (arrAltCache === 'Update') buffer.placesToUpdate.push(arrAlt);
    }
};

MyTravels.placesAssembled = function(place, buffer, data) {
    place.str = data[0].formatted_address;
    MyTravels.putInGeocodingCache(place);
    
    buffer.count.count2--;
    if (buffer.count.count2 === 0) {
        for(var i=0;i<MyTravels.travels.length;i++){
            var journey = JSON.parse(MyTravels.travels[i].journey);
            journey.plannedRDV = MyTravels.travels[i].plannedRDV;
            journey.potentialMatches = MyTravels.travels[i].potentialMatches;
            journey.activeAgreements = MyTravels.travels[i].activeAgreements;
            journey.passiveAgreements = MyTravels.travels[i].passiveAgreements;
            MyTravels.fillInPlaces(journey, buffer);
        }
    }
};

MyTravels.fillInPlaces = function(journey, buffer) {
    var dep = {lat : journey.pickupPlace.latitude, lng : journey.pickupPlace.longitude};
    journey.dep = MyTravels.findInGeocodingCache(dep);
    
    var arr = {lat : journey.dropPlace.latitude, lng : journey.dropPlace.longitude};
    journey.arr = MyTravels.findInGeocodingCache(arr);
    
    if (!!journey.dropPlaceAlt) {
        var arrAlt = {lat : journey.dropPlaceAlt.latitude, lng : journey.dropPlaceAlt.longitude};
        journey.arrAlt = MyTravels.findInGeocodingCache(arrAlt);
    }
    
    MyTravels.fillInTime(journey, buffer);
};

MyTravels.fillInTime = function(journey, buffer) {
    var dateMin = new Date(journey.pickupTimeMin+" GMT");
    var dateMax;
    if (journey.pickupTimeMax) dateMax = new Date(journey.pickupTimeMax+" GMT");
    var regularity = journey.regularity;
    
    journey.time = MyTravels.computeTimeString(regularity, dateMin, dateMax);
    MyTravels.endJourneyRendering (journey, buffer, "MyTravelsPage");
    
};

MyTravels.endJourneyRendering = function(journey, buffer, page) {
    var travelObject =  {
        "isPro":!!journey.workplaceIdworkplace,
        "departure":journey.dep,
        "arrival":journey.arr,
        "journeyId":journey.idjourney,
        "destLat":journey.dropPlace.latitude,
        "destLng":journey.dropPlace.longitude,
        "regularity":journey.regularity,
        "pickupTimeMin":new Date(journey.pickupTimeMin+" GMT").getTime(),
        "pickupTimeMax":new Date(journey.pickupTimeMax+" GMT").getTime()
    };
    if (!!journey.isBackWay)
        travelObject.way = "retour";
    else
        travelObject.way = "aller";
    if (page === "MyTravelsPage") {
        if (buffer.count.count1 % 2 === 0)
            travelObject.backgroundColor = "even";
        else
            travelObject.backgroundColor = "odd";
    } else {
        travelObject.backgroundColor = "oddven";
    }
    if (journey.offeringType === "driver") {
        travelObject.myType = "conducteur";
        travelObject.type = "passager";
    } else {
        travelObject.myType = "passager";
        travelObject.type = "conducteur";
    }
    
    if (!!journey.arrAlt) {
        travelObject.arrAlt = true;
        travelObject.arrival_Alt = journey.arrAlt;
    }
    
    var travel = $(travel_template(travelObject));
    travel.find('.timeInfo').html(journey.time);
    MyTravels.showTags(travel, journey, page);
    
    if (page === "MyTravelsPage") {
        MyTravels.el.find('.areTravels').append(travel);
        if (buffer.count.count1 !== 1)
            MyTravels.el.find('.areTravels').append($("<div class='travelSeparator'></div>"));
        buffer.count.count1--;
        if (buffer.count.count1 === 0) MyTravels.handleTravelBorder(buffer);
    } else {
        Partir4Page.el.find('.travelContainer').append(travel);
    }
    MyTravels.el.find('.arrowCover').each(function() {
        $(this).height($(this).parent().outerHeight() + 2);
    });
    
};

MyTravels.handleTravelBorder = function (buffer) {
    endLoading();
    
    var placesToUpdate = buffer.placesToUpdate;
    var placesToUpdateLength = placesToUpdate.length;
    
    if (placesToUpdateLength === 0) MyTravels.purgeGeocodingCache();
    else {
        buffer.count.count3 = placesToUpdateLength;
        for(var i=0;i<placesToUpdateLength;i++){
            var place = placesToUpdate[i];
            Geocoding.reverseGeocoding(place,function(data, place) {MyTravels.placesUpdated(place, buffer, data);});
        }
    }
};

MyTravels.placesUpdated = function(place, buffer, data) {
    place.str = data[0].formatted_address;
    MyTravels.updateInGeocodingCache(place);
    
    buffer.count.count3--;
    if (buffer.count.count3 === 0) {
        MyTravels.purgeGeocodingCache();
    }
};

MyTravels.isInGeocodingCache = function(place, alreadySpoted) {
    for (var i = 0; i < alreadySpoted.length; i++) {
        var el = alreadySpoted[i];
        if (el.lat === place.lat && el.lng === place.lng) return "Ok";
    }
    var cache = window.localStorage.getArray("geocodingCache");
    var date = new Date();
    for (var i = 0; i < cache.length; i++) {
        var el = cache[i];
        if (el.lat === place.lat && el.lng === place.lng) {
            if (date.getTime() - el.update > MyTravels.cacheTimeBeforeUpdate) {
                el.used = date.getTime();
                window.localStorage.setArray("geocodingCache", cache);
                return "Update";
            }
            el.used = date.getTime();
            window.localStorage.setArray("geocodingCache", cache);
            return "Ok";
        }
    }
    return "None";
};

MyTravels.findInGeocodingCache = function(place) {
    var cache = window.localStorage.getArray("geocodingCache");
    for (var i = 0; i < cache.length; i++) {
        var el = cache[i];
        if (el.lat === place.lat && el.lng === place.lng) return el.str;
    }
    return 'adresse non résolue';
};

MyTravels.putInGeocodingCache = function(place) {
    var cache = window.localStorage.getArray("geocodingCache");
    var date = new Date();
    cache.push({str : place.str, lat : place.lat, lng : place.lng, update : date.getTime(), used : date.getTime()});
    window.localStorage.setArray("geocodingCache", cache);
};

MyTravels.updateInGeocodingCache = function(place) {
    var cache = window.localStorage.getArray("geocodingCache");
    var date = new Date();
    for (var i = 0; i < cache.length; i++) {
        var el = cache[i];
        if (el.lat === place.lat && el.lng === place.lng) {
            el.str = place.str;
            el.update = date.getTime();
            window.localStorage.setArray("geocodingCache", cache);
        }
    }
};

MyTravels.purgeGeocodingCache = function() {
    var cache = window.localStorage.getArray("geocodingCache");
    if (cache.length > MyTravels.cacheMaxSize) {
        cache.sort(function(a,b){
            return a.used < b.used ? -1 : 1;
        });
        cache.splice(MyTravels.cacheMaxSize, cache.length - MyTravels.cacheMaxSize);
        window.localStorage.setArray("geocodingCache", cache);
    }
};

MyTravels.gotTheTravel = function(data, goingStraight) {
    MyTravels.travels = data;
    
    var result = $.grep(MyTravels.travels,function(e){
        var journey = JSON.parse(e.journey);
        return journey.idjourney === goingStraight.journeyId;
    });
    
    if (result.length === 0) {
        endLoading();
        notifyNotificationNotActual();
        return;
    }
    
    var journey = JSON.parse(result[0].journey);
    var buff = {count: 0, warning: result[0].matches === 0 & result[0].agreements === 0};
    
    var dep = {lat : journey.pickupPlace.latitude, lng : journey.pickupPlace.longitude};
    journey.pickupAddress = MyTravels.findInGeocodingCache(dep);
    if (journey.pickupAddress === 'adresse non résolue') {
        buff.count++;
        Geocoding.reverseGeocoding(dep, function(result) {
            journey.pickupAddress = result[0].formatted_address;
            MyTravels.collectGeocodingResults(journey, goingStraight, buff);
        });
    }
    
    var arr = {lat : journey.dropPlace.latitude, lng : journey.dropPlace.longitude};
    journey.dropAddress = MyTravels.findInGeocodingCache(arr);
    if (journey.dropAddress === 'adresse non résolue') {
        buff.count++;
        Geocoding.reverseGeocoding(arr, function(result) {
            journey.dropAddress = result[0].formatted_address;
            MyTravels.collectGeocodingResults(journey, goingStraight, buff);
        });
    }
    
    if (!!journey.dropPlaceAlt) {
        var arrAlt = {lat : journey.dropPlaceAlt.latitude, lng : journey.dropPlaceAlt.longitude};
        journey.dropAltAddress = MyTravels.findInGeocodingCache(arrAlt);
        if (journey.dropAltAddress === 'adresse non résolue') {
            buff.count++;
            Geocoding.reverseGeocoding(arrAlt, function(result) {
                journey.dropAltAddress = result[0].formatted_address;
                MyTravels.collectGeocodingResults(journey, goingStraight, buff);
            });
        }
    }
    
    var tags = {
        plannedRDV : result[0].plannedRDV,
        potentialMatches : result[0].potentialMatches,
        activeAgreements : result[0].activeAgreements,
        passiveAgreements : result[0].passiveAgreements
    };
    if (buff.count === 0) MyTravels.goToTheTravel(journey, goingStraight, tags);
};

MyTravels.goToTheTravel = function(journey, goingStraight, tags) {
    //send data to Partir4Page
    Partir4Page.sendJourneyToMe(journey, tags);
    
    if(typeof goingStraight.matchId === 'undefined') {
        Partir4Page.commingFrom = "MyTravelsPage";
        goToPage("#partir4");
        endLoading();
    }
    else if (tags.activeAgreements === 0 & tags.passiveAgreements === 0 & tags.plannedRDV === 0 & tags.potentialMatches === 0) {
        endLoading();
        notifyNotificationNotActual();
        return;
    } else {
        MyTravels.requestLoadTravel (goingStraight.journeyId, goingStraight);
    }
};

MyTravels.collectGeocodingResults = function(journey, goingStraight, buff) {
    if (buff.count !== 1) {
        buff.count--;
        return;
    } else MyTravels.goToTheTravel(journey, goingStraight, buff.warning);
};

//Affiche la page
MyTravels.render = function () {
    if (MyTravels.noReload === true) {
        MyTravels.noReload = false;
        this.el.addClass("shown");
        return;
    }
    MyTravels.reset();
    this.el.addClass("shown");
    showLoading();
    MyTravels.getTravels();
    if (MyTravels.showTuto === true) {
        MyTravels.showTuto = false;
        alert('Votre compte a été créé avec succès !','Bienvenue sur Kankaroo');
    }
};

MyTravels.reset = function () {
    MyTravels.el.find('.areTravels').html('');
    MyTravels.el.find('.noTravels').hide();
    //MyTravels.modifiedMatchNotifications = []; Suspended for the moment
};

MyTravels.computeTimeString = function (regularity, dateMin, dateMax) { 
    var html = '';
    
    var hourMin= dateMin.getHours();
    var minutesMin = dateMin.getMinutes();
    var dateMinString;
    if(minutesMin<10) minutesMin = "0"+minutesMin;
    if(hourMin<10) hourMin = "0"+hourMin;
    dateMinString = hourMin+":"+minutesMin;
    if(typeof dateMax !== "undefined"){
        var hourMax= dateMax.getHours();
        var minutesMax = dateMax.getMinutes();
        var dateMaxString;
        if(minutesMax<10) minutesMax = "0"+minutesMax;
        if (hourMax<10) hourMax = "0"+hourMax;
        dateMaxString = hourMax+":"+minutesMax;
        html += 'Entre <span class="green">'+dateMinString+'</span> et <span class ="green">'+dateMaxString+'</span>';
    }
    else html += 'À <span class="green">'+dateMinString+'</span>';
    
    html+=' ';
    
    var date = new Date();
    var year = dateMin.getFullYear();
    var month = dateMin.getMonth()+1;
    var day = dateMin.getDate();
    if (regularity === 0) {
        if(date.getDate()===day && (date.getMonth()+1)===month && date.getFullYear()===year) html += "aujourd'hui ";
        else {
            if(day<10) day = "0"+day;
            if(month<10) month = "0"+month;
            html += "le "+day+"/"+month+"/"+year+" ";
        }
    }
        
    if (regularity !== 0) {
        var htmlDays = MyTravels.computePositiveRegularity(regularity);
        html+= htmlDays;
    }
    return html;
};

MyTravels.computePositiveRegularity = function(regularity) {
    var htmlDays = "<span class='italic' style='font-weight: normal;'>(<span class='red'>";
    var firstDay = true;
    if ((regularity & MONDAY) !== 0) {
        if (firstDay) {
            htmlDays += "L";
            firstDay = false;
        }
        else htmlDays += " L";
    }
    if ((regularity & TUESDAY) !== 0) {
        if (firstDay) {
            htmlDays += "Ma";
            firstDay = false;
        }
        else htmlDays += " Ma";
    }
    if ((regularity & WEDNESDAY) !== 0) {
        if (firstDay) {
            htmlDays += "Me";
            firstDay = false;
        }
        else htmlDays += " Me";
    }
    if ((regularity & THURSDAY) !== 0) {
        if (firstDay) {
            htmlDays += "J";
            firstDay = false;
        }
        else htmlDays += " J";
    }
    if ((regularity & FRIDAY) !== 0) {
        if (firstDay) {
            htmlDays += "V";
            firstDay = false;
        }
        else htmlDays += " V";
    }
    if ((regularity & SATURDAY) !== 0) {
        if (firstDay) {
            htmlDays += "S";
            firstDay = false;
        }
        else htmlDays += " S";
    }
    if ((regularity & SUNDAY) !== 0) {
        if (firstDay) {
            htmlDays += "D";
            firstDay = false;
        }
        else htmlDays += " D";
    }
    htmlDays += '</span>)</span>';
    return htmlDays;
};

MyTravels.fillRegularity = function(page, regularity) {
    if ((regularity & MONDAY) !== 0) page.el.find("input[value='lun']").parent().addClass("selectedLabel");
    else page.el.find("input[value='lun']").parent().removeClass("selectedLabel");
    if ((regularity & TUESDAY) !== 0) page.el.find("input[value='mar']").parent().addClass("selectedLabel");
    else page.el.find("input[value='mar']").parent().removeClass("selectedLabel");
    if ((regularity & WEDNESDAY) !== 0) page.el.find("input[value='mer']").parent().addClass("selectedLabel");
    else page.el.find("input[value='mer']").parent().removeClass("selectedLabel");
    if ((regularity & THURSDAY) !== 0) page.el.find("input[value='jeu']").parent().addClass("selectedLabel");
    else page.el.find("input[value='jeu']").parent().removeClass("selectedLabel");
    if ((regularity & FRIDAY) !== 0) page.el.find("input[value='ven']").parent().addClass("selectedLabel");
    else page.el.find("input[value='ven']").parent().removeClass("selectedLabel");
    if ((regularity & SATURDAY) !== 0) page.el.find("input[value='sam']").parent().addClass("selectedLabel");
    else page.el.find("input[value='sam']").parent().removeClass("selectedLabel");
    if ((regularity & SUNDAY) !== 0) page.el.find("input[value='dim']").parent().addClass("selectedLabel");
    else page.el.find("input[value='dim']").parent().removeClass("selectedLabel");
};

MyTravels.fillDate = function(page, DateMin, DateMax) {
    var dayNum = DateMin.getDate();
    if (dayNum < 10) dayNum = "0"+dayNum;
    var monthNum = DateMin.getMonth() + 1;
    if (monthNum < 10) monthNum = "0"+monthNum;
    var hMin = DateMin.getHours();
    if (hMin < 10) hMin = "0"+hMin;
    var mMin = DateMin.getMinutes();
    if (mMin < 10) mMin = "0"+mMin;
    var hMax = DateMax.getHours();
    if (hMax < 10) hMax = "0"+hMax;
    var mMax = DateMax.getMinutes();
    if (mMax < 10) mMax = "0"+mMax;
    page.el.find("input[name='dayInput']").val(dayNum);
    page.el.find("input[name='month']").val(monthNum);
    page.el.find("input[name='year']").val(DateMin.getFullYear());
    page.el.find("input[name='hourMin']").val(hMin);
    page.el.find("input[name='hourMax']").val(hMax);
    page.el.find("input[name='minutesMin']").val(mMin);
    page.el.find("input[name='minutesMax']").val(mMax);
};

MyTravels.computeDate = function(page) {
    var day = parseInt(page.el.find("input[name='dayInput']").val(), 10);
    var month = parseInt(page.el.find("input[name='month']").val(), 10);
    var year = parseInt(page.el.find("input[name='year']").val(), 10);
    var hourMin = parseInt(page.el.find("input[name='hourMin']").val(), 10);
    var hourMax = parseInt(page.el.find("input[name='hourMax']").val(), 10);
    var minutesMin = parseInt(page.el.find("input[name='minutesMin']").val(), 10);
    var minutesMax = parseInt(page.el.find("input[name='minutesMax']").val(), 10);

    MyTravels.dateMin = new Date(year, month-1, day, hourMin, minutesMin, 0, 0);
    MyTravels.dateMax = new Date(year, month-1, day, hourMax, minutesMax, 0, 0);
};

MyTravels.handleTravelModification = function(page) {
    var data = {};
    MyTravels.regularity = PartirPage.computeRegularity(page);
    if (MyTravels.regularity === 0 & page.el.find("input[value='travelRegularity']").prop('checked')) {
        alert('Vous devez cocher au moins un jour');
        return;
    }
    if (!page.el.find("input[value='travelRegularity']").prop('checked'))
        MyTravels.regularity = 0;
    MyTravels.computeDate(page);
    if (MyTravels.popUpRegularity === MyTravels.regularity & MyTravels.popUpPickupTimeMin.getTime() === MyTravels.dateMin.getTime() & MyTravels.popUpPickupTimeMax.getTime() === MyTravels.dateMax.getTime()) {
        hidePopUp(page);
        return;
    }
    var now = new Date();
    if (MyTravels.regularity === 0 & MyTravels.dateMin.getTime() + 600000 < now.getTime()) {
        alert("Impossible d'enregistrer un trajet dans le passé");
        return;
    }
    else {
        data.myJourneyId = MyTravels.popUpJourneyId;
        data.pickupTime = MyTravels.dateMin.toISOString();
        data.regularity = MyTravels.regularity;
        var rightNow = new Date();
        rightNow.setMonth(1);
        data.timeZone = String(String(rightNow).split("(")[1]).split(")")[0];
        var compared = PartirPage.compareDates(MyTravels.dateMin, MyTravels.dateMax);
        if(compared === 0) ;
        else if (compared === -1) {
            data.pickupTimeMax = MyTravels.dateMax.toISOString();
        }
        else {
            MyTravels.dateMax.setDate(MyTravels.dateMax.getDate()+1);
            data.pickupTimeMax = MyTravels.dateMax.toISOString();
        }
        MyTravels.sendTravelModification(page, data);
        hidePopUp(page);
        showLoading();
    }
};

MyTravels.sendTravelModification = function(page, data) {
    serverRequest(
        "/travel/updateDepartureTime",
        "GET",
        function(response) {
            if (response.status === 'success') {
                if (page === MyTravels)
                    goToPage('#myTravels');
                else
                    goSomewhere(data.myJourneyId);
                alert('La liste des covoitureurs disponibles sur ce trajet a été mise à jour','Modifications enregistrées');
            } else if (response.status === 'update') {
                if (page === MyTravels)
                    goToPage('#myTravels');
                else
                    goSomewhere(data.myJourneyId);
                alert('Impossible de modifier un trajet avec des propositions ou des accords en cours','Modifications impossibles');
            } else if (response.status === 'tooLate') {
                alert("Impossible d'enregistrer un trajet dans le passé");
            }
        },
        "modify travel Travelpage",
        function() {MyTravels.sendTravelModification(data);},
        data
    );
};

MyTravels.showTags = function(elt, journey, page) {
    var lastTag = "void";
    var showMessages = false;
    if (journey.plannedRDV === 0) {
        elt.find('.RDVTag').hide();
    } else {
        lastTag = ".RDVTag";
        elt.find(lastTag).show();
        elt.find(".RDVTag .numberTag").html(journey.plannedRDV);
        showMessages = true;
    } if (journey.activeAgreements === 0) {
        elt.find('.activeTag').hide();
    } else {
        lastTag = ".activeTag";
        elt.find(lastTag).show();
        elt.find(".activeTag .numberTag").html(journey.activeAgreements);
        showMessages = true;
    } if (journey.passiveAgreements === 0) {
        elt.find('.passiveTag').hide();
    } else {
        lastTag = ".passiveTag";
        elt.find(lastTag).show();
        elt.find(".passiveTag .numberTag").html(journey.passiveAgreements);
        showMessages = true;
    } if (journey.potentialMatches === 0) {
        elt.find('.potentialTag').hide();
    } else {
        lastTag = ".potentialTag";
        elt.find(lastTag).show();
        elt.find(".potentialTag .numberTag").html(journey.potentialMatches);
    } if (lastTag !== "void") {
        elt.find('.voidTag').hide();
    } else {
        if (page === "MyTravelsPage")
            elt.find('.tagsContainer').hide();
        else
            elt.find('.voidTag').show();
    }
    if (!showMessages | page === "MyTravelsPage")
        elt.find('.messageTag').hide();
    else
        elt.find('.messageTag').show();
};