/* global MapPage, Partir2Page, MyTravels, Notification, Geocoding, MyCarsPage, Partir3Page, NaN, windowHeight, Menu */

var PartirPage = new Object();

PartirPage.el = $('#partir');

PartirPage.departureObject;
PartirPage.arrivalAltObject;
PartirPage.arrivalObject;
PartirPage.dateMin;
PartirPage.dateMax;
PartirPage.vehicles;
PartirPage.preferences;
PartirPage.reload = true;
PartirPage.waiting = false;
PartirPage.synchroTool;
PartirPage.interval;
PartirPage.timer;
PartirPage.tooLate;
PartirPage.regularity;
PartirPage.addresses;
PartirPage.pickupTimeJourneyForward;
PartirPage.TimeLaps;
PartirPage.isRegular = false;
PartirPage.canPro;
PartirPage.journeyNature;
PartirPage.state;
PartirPage.firmVehicleId;

//Fonction d'initialisation, affecte les evenements.
PartirPage.initialize = function () {
    this.eventHandler();
};

PartirPage.eventHandler = function () {
    this.el.on('click', '.first .back-menu', function (event) {
        MyTravels.noReload = true;
        goToPage('#myTravels');
    });
    
    this.el.on('click', '.next .back-menu', function () {
        if (PartirPage.state === "travel2")
            PartirPage.goToTravel0();
        if (PartirPage.state === "travel4")
            PartirPage.goToTravel2();
        if (PartirPage.state === "travel5")
            PartirPage.goToTravel4();
        if (PartirPage.state === "backTravel")
            PartirPage.goToTravel6();
    });
    
    this.el.on('touchstart', 'label', function (event) {
        $(this).one('touchmove',function (event){
           object.off('touchend'); 
        });
        var object = $(this);
        $(this).one('touchend', function (event) {
            if (event.target.tagName !== "INPUT") {
                if (object.hasClass("checkbox")) {
                    if (object.hasClass("selectedLabel"))
                        object.removeClass("selectedLabel");
                    else
                        object.addClass("selectedLabel");
                    PartirPage.regularity = PartirPage.computeRegularity(PartirPage);
                } else if (object.hasClass("onoffswitch-label")) {
                    //Handled elsewhere
                } else {
                    if (object.attr('for') === "radioRolePi" | object.attr('for') === "radioRoleBo") {
                        if (PartirPage.el.find('select[name="vehicule"]').html() === "") {
                            navigator.notification.confirm(
                                "Vous devez enregistrer un véhicule", 
                                function(index) {
                                    if (index === 2) {
                                        MyCarsPage.registerVehicle = true;
                                        MyCarsPage.fromPartirPage = true;
                                        goToPage('#myCars');
                                    }
                                },
                                "Kankaroo",
                                "Non merci,Enregistrer"
                            );
                            return;
                        }
                    }
                    radioImg(object, PartirPage);
                }
            }
        });
    });

    this.el.on('click', '.time', function (event) {
        event.stopPropagation();
        PartirPage.el.find('.normal').show();
        PartirPage.el.find('.dateTime').hide();
        PartirPage.el.find('.hourTime').show();
        PartirPage.el.find('.disclamer').hide();
        showPopUp(PartirPage);
    });
    
    this.el.on('click', '.day', function (event) {
        event.stopPropagation();
        PartirPage.el.find('.normal').show();
        PartirPage.el.find('.dateTime').show();
        PartirPage.el.find('.hourTime').hide();
        PartirPage.el.find('.disclamer').hide();
        showPopUp(PartirPage);
    });

    this.el.on('click', '.valid.popUpValid', function (event) {
        event.stopPropagation();
        PartirPage.fillDate();
        hidePopUp(PartirPage);
    });
    
    this.el.on('click', '.overlay, .popUpCancel', function (event) {
        event.stopPropagation();
        hidePopUp(PartirPage);
        if (PartirPage.tooLate === true) window.plugins.toast.showShortBottom("En attente du serveur...\nLa connexion est peut-être lente"); //reasure the user because the appli is completely blocked
    });

    this.el.on('click', '.popUp', function (event) {
        event.stopPropagation();
    });

    this.el.on('touchstart', '.addH', function (event) {
        var object = $(this);
        PartirPage.addMinAddH(object, true);
    });
    
    this.el.on('touchstart', '.addMin', function (event) {
        var object = $(this);
        PartirPage.addMinAddH(object, false);
    });

    this.el.on('touchstart', '.substractH', function (event) {
        var object = $(this);
        PartirPage.subMinSubH(object, true);
    });
    
    this.el.on('touchstart', '.substractMin', function (event) {
        var object = $(this);
        PartirPage.subMinSubH(object, false);
    });
    
    this.el.on('touchstart', '.addDay, .addMonth, .addYear', function (event) {
        var object = $(this);
        PartirPage.addDayAddMonthAddYear(PartirPage, object);
    });
    
    this.el.on('touchstart', '.substractDay, .substractMonth, .substractYear', function (event) {
        var object = $(this);
        PartirPage.subDaySubMonthSubYear(PartirPage, object);
    });

    this.el.on('click', '.departure ,.arrival ,.alt_arrival', function (event) {
        var object = $(this);
        Partir2Page.request(object);
        goToPage("#partir2");
    });

    this.el.find("input[name='dayInput'], input[name='month'], input[name='year']").blur(function () {
        PartirPage.blurDayMonthYear(PartirPage);
    });

    this.el.find("input[name='hourMin'], input[name='hourMax']").blur(function () {
        var object = $(this);
        PartirPage.blurHminHmax(PartirPage, object);
    });

    this.el.find("input[name='minutesMin'], input[name='minutesMax']").blur(function () {
        var object = $(this);
        PartirPage.blurMminMmax(PartirPage, object);
    });

    this.el.on('touchstart', 'label[for="radioRolePa"]', function () {
        $(this).one('touchend', function () {
            PartirPage.el.find(".driver").hide();
            PartirPage.el.find(".both").hide();
            PartirPage.el.find(".passenger").show();
            PartirPage.el.find(".travel2").show();
            PartirPage.fillInPreferences("passenger");
        });
    });

    this.el.on('touchstart', 'label[for="radioRolePi"]', function (event) {
        $(this).one('touchend', function () {
            if (PartirPage.el.find('select[name="vehicule"]').html() !== "") {
                PartirPage.el.find(".driver").show();
                PartirPage.el.find(".passenger").hide();
                PartirPage.el.find(".both").hide();
                PartirPage.el.find(".travel2").show();
                PartirPage.fillInPreferences("driver");
            }
        });
    });
    
    this.el.on('touchstart', 'label[for="radioRoleBo"]', function (event) {
        $(this).one('touchend', function () {
            if (PartirPage.el.find('select[name="vehicule"]').html() !== "") {
                PartirPage.el.find(".driver").show();
                PartirPage.el.find(".passenger").hide();
                PartirPage.el.find(".travel5 .passenger").show();
                PartirPage.el.find(".both").show();
                PartirPage.el.find(".travel2").show();
                PartirPage.fillInPreferences("both");
            }
        });
    });

    this.el.on('click', '.star', function () {
        goToPage("#partir3");
    });

    this.el.find('select[name="vehicule"]').change(function () {
        var id = parseInt(PartirPage.el.find('select[name="vehicule"]').val());
        PartirPage.handleHelmetDriverSeats(id);
    });

    this.el.on('click', '.valid.travel2', function () {
        PartirPage.synchroTool = new Object();
        PartirPage.synchroTool.popUpHandler = new Object();
        PartirPage.synchroTool.registred = 0;
        PartirPage.pickupPreComputation();
    });
    
    this.el.on('click', '.valid.travel5', function () {
        PartirPage.prepareTravel(PartirPage.addresses, false);
        Notification.handleNotification();
    });
    
    this.el.on('click', '.valid.travel4', function () {
        var now = new Date();
        if (PartirPage.regularity === 0 & PartirPage.dateMin.getTime() + 600000 < now.getTime())
            alert('Impossible de créer un trajet dans le passé');
        else if (PartirPage.regularity === 0 & PartirPage.isRegular)
            alert('Vous devez cocher au moins un jour');
        else
            PartirPage.goToTravel5();
    });
    
    this.el.on('click', '.registerBackTravel', function () {
        PartirPage.goToBackTravel();
    });

    this.el.on('click', '.backValid', function () {
        if (PartirPage.pickupTimeJourneyForward.getTime() === PartirPage.dateMin.getTime()) {
            alert("Modifiez l'horaire de retour");
            return;
        }
        if (PartirPage.regularity === 0 & PartirPage.isRegular) {
            alert('Vous devez cocher au moins un jour');
            return;
        }
        PartirPage.prepareTravel(PartirPage.addresses, true);
        PartirPage.tooLate = true;
        PartirPage.el.find('.normal').hide();
        PartirPage.el.find('.disclamer').show();
        showPopUp(PartirPage);
    });

    this.el.on('click', '.pass', function () {
        if (PartirPage.waiting) {
            PartirPage.finish();
        } else {
            PartirPage.waiting = true;
            PartirPage.tooLate = true;
            PartirPage.el.find('.normal').hide();
            PartirPage.el.find('.disclamer').show();
            showPopUp(PartirPage);
        }
    });
    
    this.el.on('click', '.unregular', function () {
        if (PartirPage.state !== "backTravel")
            PartirPage.goToTravel4();
        PartirPage.el.find('.dayContainer').show();
        PartirPage.el.find('.weekDaysContainer').hide();
        PartirPage.el.find('.selectedProTab').removeClass('selectedProTab');
        PartirPage.el.find('.unregular').addClass('selectedProTab');
        PartirPage.isRegular = false;
    });
    
    this.el.on('click', '.regular', function () {
        if (PartirPage.state !== "backTravel")
            PartirPage.goToTravel4();
        PartirPage.el.find('.dayContainer').hide();
        PartirPage.el.find('.weekDaysContainer').show();
        PartirPage.el.find('.selectedProTab').removeClass('selectedProTab');
        PartirPage.el.find('.regular').addClass('selectedProTab');
        PartirPage.isRegular = true;
    });
    
    this.el.on('click', '.professional', function () {
        PartirPage.journeyNature= "pro";
        var img = PartirPage.el.find('.selectedLabel').find('img');
        if (img.length !== 0) {
            replaceImgSrc(img.attr("src").substring(0, img.attr("src").length - 5) + "0.svg", img);
        }
        PartirPage.el.find('.selectedLabel').removeClass("selectedLabel");
        PartirPage.el.find('.driver').hide();
        PartirPage.el.find('.passenger').hide();
        PartirPage.el.find('select[name="vehicule"]').append('<option value=' + PartirPage.firmVehicleId + '>Véhicule de société</option>');
        PartirPage.goToTravel1();
    });
    
    this.el.on('click', '.hobby', function () {
        PartirPage.journeyNature= "hobby";
        var img = PartirPage.el.find('.selectedLabel').find('img');
        if (img.length !== 0) {
            replaceImgSrc(img.attr("src").substring(0, img.attr("src").length - 5) + "0.svg", img);
        }
        PartirPage.el.find('.selectedLabel').removeClass("selectedLabel");
        PartirPage.el.find('.driver').hide();
        PartirPage.el.find('.passenger').hide();
        PartirPage.goToTravel1();
        PartirPage.preSelectType();
    });
    
    this.el.on('click', '.commute', function () {
        PartirPage.journeyNature= "commute";
        var img = PartirPage.el.find('.selectedLabel').find('img');
        if (img.length !== 0) {
            replaceImgSrc(img.attr("src").substring(0, img.attr("src").length - 5) + "0.svg", img);
        }
        PartirPage.el.find('.selectedLabel').removeClass("selectedLabel");
        PartirPage.el.find('.driver').hide();
        PartirPage.el.find('.passenger').hide();
        PartirPage.goToTravel1();
        PartirPage.preSelectType();
    });
};

PartirPage.timeOutMin = function (object, type, val, timeLaps) {
    PartirPage.interval = setInterval(function () {
        var num = parseInt(object.parent().find('input').val(), 10);
        if (type === "substract") {
            object.parent().find('input').val(num - val).blur();
        } else {
            object.parent().find('input').val(num + val).blur();
        }
    }, timeLaps);
};

PartirPage.timeOutH = function (object, type) {
    PartirPage.interval = setInterval(function () {
        var num = parseInt(object.parent().find('input').val(), 10);
        if (type === "substract") {
            object.parent().find('input').val(num - 1).blur();
        } else {
            object.parent().find('input').val(num + 1).blur();
        }
    }, 300);
};

PartirPage.timeOutDate = function(type, kind, page) {
    PartirPage.interval = setInterval(function () {
        PartirPage.timeOutDateAction(type, kind, page);
    }, 200);
};

PartirPage.timeOutDateAction = function(type, kind, page) {
    var offset;
    if (type === "substract") offset = -1;
    else offset = 1;
    var day = parseInt(page.el.find("input[name='dayInput']").val(), 10);
    var month = parseInt(page.el.find("input[name='month']").val(), 10);
    var year = parseInt(page.el.find("input[name='year']").val(), 10);
    var date = new Date(Date.UTC(year, month-1, day, 0, 0, 0, 0));
    if (kind === 'year') date.setFullYear((date.getFullYear()+offset));
    else if (kind === 'month') date.setMonth((date.getMonth()+offset));
    else if (kind === 'day') date.setDate((date.getDate()+offset));
    page.el.find("input[name='dayInput']").val(date.getDate());
    page.el.find("input[name='month']").val(date.getMonth() + 1);
    page.el.find("input[name='year']").val(date.getFullYear());
    PartirPage.blurDayMonthYear(page);
};

PartirPage.PreventLetters = function(evt) {
    evt = (evt) ? evt : window.event;
    var charCode = (evt.which) ? evt.which : evt.keyCode;
    if (charCode > 31 && (charCode < 48 || charCode > 57)) {
        return false;
    }
};

PartirPage.pickupPreComputation = function() {
    var addresses = {};
    
    var pickupLat;
    var pickupLong;
    var pickupAddress = PartirPage.el.find(".departure .adress").html();
    if (pickupAddress === 'Ma position') {
        alert('Addresse de départ invalide');
        return;
    }
    if (typeof PartirPage.departureObject !== "undefined") {
        addresses.pickupAddress = pickupAddress;
        if (!!PartirPage.departureObject.geometry) {
            pickupLat = PartirPage.departureObject.geometry.location.lat();
            pickupLong = PartirPage.departureObject.geometry.location.lng();
        } else {
            pickupLat = PartirPage.departureObject.lat;
            pickupLong = PartirPage.departureObject.lng;
        }
        if (pickupLat && pickupLong) {
            addresses.pickupLat = pickupLat;
            addresses.pickupLong = pickupLong;
            PartirPage.dropPreComputation(addresses);
        }
        else { //the user entered a crappy adress, try to solve it anyway
            Geocoding.straightGeocoding(pickupAddress, function (data) {
                if (data === "fail") {
                    alert("L'adresse de départ n'a pas pu être identifiée");
                }
                else {
                    addresses.pickupLat = data.geometry.location.lat();
                    addresses.pickupLong = data.geometry.location.lng();
                    addresses.pickupAddress = data.formatted_address;
                    PartirPage.el.find(".departure .adress").html(data.formatted_address);
                    PartirPage.dropPreComputation(addresses);
                    window.plugins.toast.showShortBottom("Départ : "+ data.formatted_address);
                }
            });
        }
    } else {
        alert("Vous devez préciser un lieu de départ");
    }
};

PartirPage.dropPreComputation = function(addresses) {
    var dropLat;
    var dropLong;
    var dropAddress = PartirPage.el.find(".arrival .adress").html();
    if (dropAddress === 'Ma position') {
        alert("Addresse d'arrivée invalide");
        return;
    }
    if (typeof PartirPage.arrivalObject !== "undefined") {
        addresses.dropAddress = dropAddress;
        if (!!PartirPage.arrivalObject.geometry) {
            dropLat = PartirPage.arrivalObject.geometry.location.lat();
            dropLong = PartirPage.arrivalObject.geometry.location.lng();
        } else {
            dropLat = PartirPage.arrivalObject.lat;
            dropLong = PartirPage.arrivalObject.lng;
        }
        if (dropLat && dropLong) {
            addresses.dropLat = dropLat;
            addresses.dropLong = dropLong;
            if (addresses.dropLat === addresses.pickupLat && addresses.dropLong === addresses.pickupLong) {
                alert("vous avez entré deux adresses identiques");
                return;
            }
            PartirPage.dropAltPreComputation(addresses);
        } else { //the user entered a crappy adress, try to solve it anyway
            Geocoding.straightGeocoding(dropAddress, function (data) {
                if (data === "fail") {
                    alert("L'adresse d'arrivée n'a pas pu être identifiée");
                }
                else {
                    addresses.dropLat = data.geometry.location.lat();
                    addresses.dropLong = data.geometry.location.lng();
                    addresses.dropAddress = data.formatted_address;
                    PartirPage.el.find(".arrival .adress").html(data.formatted_address);
                    if (addresses.dropLat === addresses.pickupLat && addresses.dropLong === addresses.pickupLong) {
                        alert("vous avez entré deux adresses identiques");
                        return;
                    }
                    PartirPage.dropAltPreComputation(addresses);
                    window.plugins.toast.showShortBottom("Arrivée : "+ data.formatted_address);
                }
            });
        }
    } else {
        alert("Vous devez préciser un lieu d'arrivée");
    }
};

PartirPage.dropAltPreComputation = function(addresses) {
    var dropAltLat;
    var dropAltLong;
    var dropAltAddress = PartirPage.el.find(".alt_arrival .adress").html();
    if (dropAltAddress === 'Ma position') {
        alert("Addresse d'arrivée alternative invalide");
        return;
    }
    if (PartirPage.el.find("label[for='radioRolePa']").hasClass('selectedLabel') && !!PartirPage.arrivalAltObject) {
        addresses.dropAltAddress = dropAltAddress;
        if (!!PartirPage.arrivalAltObject.geometry) {
            dropAltLat = PartirPage.arrivalAltObject.geometry.location.lat();
            dropAltLong = PartirPage.arrivalAltObject.geometry.location.lng();
        } else {
            dropAltLat = PartirPage.arrivalAltObject.lat;
            dropAltLong = PartirPage.arrivalAltObject.lng;
        }
        if (dropAltLat && dropAltLong) {
            addresses.dropAltLat = dropAltLat;
            addresses.dropAltLong = dropAltLong;
            if ((addresses.dropAltLat === addresses.pickupLat && addresses.dropAltLong === addresses.pickupLong)
                || (addresses.dropAltLat === addresses.dropLat && addresses.dropAltLong === addresses.dropLong)) {
                alert("vous avez entré deux adresses identiques");
                return;
            }
        }
        else { //the user entered a crappy adress, try to solve it anyway
            Geocoding.straightGeocoding(dropAltAddress, function (data) {
                if (data === "fail") {
                    alert("L'adresse d'arrivée alternative n'a pas pu être identifiée");
                }
                else {
                    addresses.dropAltLat = data.geometry.location.lat();
                    addresses.dropAltLong = data.geometry.location.lng();
                    addresses.dropAltAddress = data.formatted_address;
                    PartirPage.el.find(".alt_arrival .adress").html(data.formatted_address);
                    if ((addresses.dropAltLat === addresses.pickupLat && addresses.dropAltLong === addresses.pickupLong)
                        || (addresses.dropAltLat === addresses.dropLat && addresses.dropAltLong === addresses.dropLong)) {
                        alert("vous avez entré deux adresses identiques");
                        return;
                    }
                    window.plugins.toast.showShortBottom("Arrivée alternative : "+ data.formatted_address);
                }
            });
        }
    }
    PartirPage.addresses = addresses;
    PartirPage.goToTravel3();
};

PartirPage.prepareTravel = function (addresses, retour) {
    if (!retour)
        PartirPage.goToTravel6();
    
    var data = new Object();
    
    //addresses fill
    if (!!retour) {
        data.pickupLat = addresses.dropLat;
        data.pickupLong = addresses.dropLong;
        data.pickupAddress = encodeURIComponent(addresses.dropAddress);
        data.dropLat = addresses.pickupLat;
        data.dropLong = addresses.pickupLong;
        data.dropAddress = encodeURIComponent(addresses.pickupAddress);
    } else {
        data.pickupAddress = encodeURIComponent(addresses.pickupAddress);
        data.pickupLat = addresses.pickupLat;
        data.pickupLong = addresses.pickupLong;
        data.dropLat = addresses.dropLat;
        data.dropLong = addresses.dropLong;
        data.dropAddress = encodeURIComponent(addresses.dropAddress);
        data.dropAltLat = addresses.dropAltLat;
        data.dropAltLong = addresses.dropAltLong;
        data.dropAltAddress = encodeURIComponent(addresses.dropAltAddress);
    }
    
    //date fill
    try { 
        data.pickupTime = PartirPage.dateMin.toISOString();
        var compared = PartirPage.compareDates(PartirPage.dateMin, PartirPage.dateMax);
        if(compared === 0) ;
        else if (compared === -1) {
            data.pickupTimeMax = PartirPage.dateMax.toISOString();
        }
        else {
            PartirPage.dateMax.setDate(PartirPage.dateMax.getDate()+1);
            data.pickupTimeMax = PartirPage.dateMax.toISOString();
        }
    }
    catch(err) {
        alert('Le format de la date de départ est invalide');
        return;
    }
    if (!retour)
        PartirPage.pickupTimeJourneyForward = PartirPage.dateMin;
    if (PartirPage.isRegular)
        data.regularity = PartirPage.regularity;
    else
        data.regularity = 0;
    var rightNow = new Date();
    rightNow.setMonth(1);
    data.timeZone = String(String(rightNow).split("(")[1]).split(")")[0];
    
    if (PartirPage.journeyNature === "pro")
        data.firmId = PartirPage.firmId;
    else if (PartirPage.journeyNature === "commute")
        data.commute = true;
    if (!!retour)
        data.retour = true;
    
    if (PartirPage.el.find("label[for='radioRolePa']").hasClass('selectedLabel') | PartirPage.el.find("label[for='radioRoleBo']").hasClass('selectedLabel')) {
        data.userType = "passenger";
        if (PartirPage.preferences.motoRider) 
            data.helmet = PartirPage.el.find(".passenger input[name='helmet']").prop('checked');
        data.detour = PartirPage.el.find('.passenger select[name="detour"]').val();
        data.passengers = PartirPage.el.find('.passenger select[name="seats"]').val();
        data.luggage = PartirPage.el.find(".passenger input[name='bag']").prop('checked');
        if (!retour) {
            PartirPage.synchroTool.passengerForward = "a";
            PartirPage.sendTravel(data, "passengerForward");
        } else {
            PartirPage.synchroTool.passengerBack = "a";
            PartirPage.sendTravel(data, "passengerBack");
        }
    }
    if (PartirPage.el.find("label[for='radioRolePi']").hasClass('selectedLabel') | PartirPage.el.find("label[for='radioRoleBo']").hasClass('selectedLabel')) {
        data.userType = "driver";
        data.idVehicle = PartirPage.el.find('select[name="vehicule"]').val();
        var vehicle = PartirPage.getDriverVehicle(parseInt(data.idVehicle));
        if (vehicle.type === "moto") 
            data.helmet = PartirPage.el.find(".driver input[name='helmet']").prop('checked');
        else
            delete data.helmet;
        data.detour = PartirPage.el.find('.driver select[name="detour"]').val();
        data.passengers = PartirPage.el.find('.driver select[name="seats"]').val();
        data.luggage = PartirPage.el.find(".driver input[name='bag']").prop('checked');
        if (!retour) {
            PartirPage.synchroTool.driverForward = "a";
            PartirPage.sendTravel(data, "driverForward");
        } else {
            PartirPage.synchroTool.driverBack = "a";
            PartirPage.sendTravel(data, "driverBack");
        }
    }
};

PartirPage.sendTravel = function(data, track){
    serverRequest(
        "/travel",
        "GET",
        function (gotData) {
            PartirPage.sendTravelSuccess(gotData, track, true);
        },
        "send travel data synchro",
        function () {
            PartirPage.sendTravel(data, track);
        },
        data,
        function () {
            PartirPage.sendTravelSuccess(null, track, false);
        },
        function () {
            PartirPage.sendTravelSuccess(null, track, false);
        },
        function () {
            PartirPage.sendTravelSuccess(null, track, false);
        }
    );
};

PartirPage.sendTravelSuccess = function (travelData, track, isSuccess) {
    //acknowlege reception and complete the popUp
    var matches;
    if (isSuccess) {
        PartirPage.synchroTool.registred ++;
        matches = 0<travelData.matches.length?travelData.matches.length:"Aucun";
    }
    switch (track) {
        case "passengerForward":
            PartirPage.synchroTool.passengerForward = "b";
                PartirPage.synchroTool.popUpHandler.passengerForward = true;
            if (isSuccess) {
                PartirPage.synchroTool.popUpHandler.passengerForwardSuccess = true;
                PartirPage.synchroTool.popUpHandler.passengerForwardResult = matches;
                0<travelData.matches.length?PartirPage.synchroTool.popUpHandler.passengerForwardDecoration = "green":PartirPage.synchroTool.popUpHandler.passengerForwardDecoration = "italic";
            }
            break;
        case "passengerBack":
            PartirPage.synchroTool.passengerBack = "b";
                PartirPage.synchroTool.popUpHandler.passengerBack = true;
            if (isSuccess) {
                PartirPage.synchroTool.popUpHandler.passengerBackSuccess = true;
                PartirPage.synchroTool.popUpHandler.passengerBackResult = matches;
                0<travelData.matches.length?PartirPage.synchroTool.popUpHandler.passengerBackDecoration = "green":PartirPage.synchroTool.popUpHandler.passengerBackDecoration = "italic";
            }
            break;
        case "driverForward":
            PartirPage.synchroTool.driverForward = "b";
            PartirPage.synchroTool.popUpHandler.driverForward = true;
            if (isSuccess) {
                PartirPage.synchroTool.popUpHandler.driverForwardSuccess = true;
                PartirPage.synchroTool.popUpHandler.driverForwardResult = matches;
                0<travelData.matches.length?PartirPage.synchroTool.popUpHandler.driverForwardDecoration = "green":PartirPage.synchroTool.popUpHandler.driverForwardDecoration = "italic";
            }
            break;
        case "driverBack":
            PartirPage.synchroTool.driverBack = "b";
            PartirPage.synchroTool.popUpHandler.driverBack = true;
            if (isSuccess) {
                PartirPage.synchroTool.popUpHandler.driverBackSuccess = true;
                PartirPage.synchroTool.popUpHandler.driverBackResult = matches;
                0<travelData.matches.length?PartirPage.synchroTool.popUpHandler.driverBackDecoration = "green":PartirPage.synchroTool.popUpHandler.driverBackDecoration = "italic";
            }
            break;
    }
    
    //check if we are done
    if (track === "passengerForward" | track === "driverForward") {
        if (!!PartirPage.synchroTool.passengerBack | !!PartirPage.synchroTool.driverBack) {
            if (PartirPage.everyTravelCameBack())
                PartirPage.finish();
        } else if ((!PartirPage.synchroTool.passengerForward | PartirPage.synchroTool.passengerForward === "b") &
                (!PartirPage.synchroTool.driverForward | PartirPage.synchroTool.driverForward === "b"))
        {
            if (PartirPage.waiting)
                PartirPage.finish();
            else {
                PartirPage.waiting = true;
                if (PartirPage.synchroTool.registred === 0)
                    PartirPage.backToTravelPage();
            }
        }
    } else if (PartirPage.everyTravelCameBack()) {
        PartirPage.finish();
    }
    
};

PartirPage.everyTravelCameBack = function() {
    if ((!PartirPage.synchroTool.passengerForward | PartirPage.synchroTool.passengerForward === "b") &
        (!PartirPage.synchroTool.driverForward | PartirPage.synchroTool.driverForward === "b") &
        (!PartirPage.synchroTool.passengerBack | PartirPage.synchroTool.passengerBack === "b") &
        (!PartirPage.synchroTool.driverBack | PartirPage.synchroTool.driverBack === "b"))
            return true;
    else
            return false;
};

PartirPage.finish = function () {
    if (PartirPage.synchroTool.registred === 0) {
        PartirPage.backToTravelPage();
        return;
    } else 
        PartirPage.synchroTool.popUpHandler.registered = PartirPage.synchroTool.registred===1?"1 Trajet enregistré":PartirPage.synchroTool.registred+" Trajets enregistrés";
    PartirPage.tooLate = false;
    Partir2Page.getFavorites();
    hidePopUp(PartirPage);
    PartirPage.el.find('.normal').show();
    PartirPage.el.find('.disclamer').hide();
    MyTravels.el.find('.popUp').html(new_travels_recap_template(PartirPage.synchroTool.popUpHandler));
    setTimeout(function() {
        showPopUp(MyTravels);
    },100);
    goToPage("#myTravels");
};

PartirPage.goToTravel0 = function() {
    Menu.scroller(PartirPage);
    PartirPage.el.find('.travel0').show();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel3').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.first').show();
    PartirPage.el.find('.next').hide();
    PartirPage.el.find('.noReturn').hide();
    PartirPage.state = "travel0";
    PartirPage.el.find('select[name="vehicule"] option[value="'+PartirPage.firmVehicleId+'"]').remove();
    Menu.handleJSRendering(PartirPage);
};

PartirPage.goToTravel1 = function() {
    Menu.scroller(PartirPage);
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel3').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.travel1').show();
    if (PartirPage.canPro) {
        PartirPage.el.find('.first').hide();
        PartirPage.el.find('.next').show();
        PartirPage.el.find('.noReturn').hide();
    } else {
        PartirPage.el.find('.first').show();
        PartirPage.el.find('.next').hide();
        PartirPage.el.find('.noReturn').hide();
    }
    PartirPage.state = "travel2";
    PartirPage.el.find('label[for="radioRolePa"]').height(PartirPage.el.find('label').width());
    PartirPage.el.find('label[for="radioRolePi"]').height(PartirPage.el.find('label').width());
    PartirPage.el.find('label[for="radioRoleBo"]').height(PartirPage.el.find('label').width());
};

PartirPage.goToTravel2 = function() {
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel3').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.travel1').show();
    PartirPage.el.find('.travel2').show();
    if (PartirPage.canPro) {
        PartirPage.el.find('.first').hide();
        PartirPage.el.find('.next').show();
        PartirPage.el.find('.noReturn').hide();
    } else {
        PartirPage.el.find('.first').show();
        PartirPage.el.find('.next').hide();
        PartirPage.el.find('.noReturn').hide();
    }
    PartirPage.state = "travel2";
    Menu.scroller(PartirPage,true);
};

PartirPage.goToTravel3 = function() {
    Menu.scroller(PartirPage);
    PartirPage.el.find('.selectedProTab').removeClass('selectedProTab');
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.travel3').show();
    PartirPage.el.find('.first').hide();
    PartirPage.el.find('.next').show();
    PartirPage.el.find('.noReturn').hide();
    PartirPage.state = "travel4";
};

PartirPage.goToTravel4 = function() {
    Menu.scroller(PartirPage);
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.travel3').show();
    PartirPage.el.find('.travel4').show();
    PartirPage.el.find('.first').hide();
    PartirPage.el.find('.next').show();
    PartirPage.el.find('.noReturn').hide();
    PartirPage.state = "travel4";
};

PartirPage.goToTravel5 = function() {
    Menu.scroller(PartirPage);
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel3').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.travel5').show();
    PartirPage.el.find('.first').hide();
    PartirPage.el.find('.next').show();
    PartirPage.el.find('.noReturn').hide();
    PartirPage.state = "travel5";
};

PartirPage.goToTravel6 = function() {
    Menu.scroller(PartirPage);
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel3').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.backTravel').hide();
    PartirPage.el.find('.travel6').show();
    PartirPage.el.find('.first').hide();
    PartirPage.el.find('.next').hide();
    PartirPage.el.find('.noReturn').show();
    PartirPage.state = "travel6";
};

PartirPage.goToBackTravel = function() {
    Menu.scroller(PartirPage);
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel3').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.backTravel').show();
    PartirPage.el.find('.first').hide();
    PartirPage.el.find('.next').show();
    PartirPage.el.find('.noReturn').hide();
    PartirPage.state = "backTravel";
};

PartirPage.backToTravelPage = function() {
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.backTravel').hide();
    PartirPage.el.find('.travel3').show();
    PartirPage.el.find('.travel4').show();
    PartirPage.el.find('.first').hide();
    PartirPage.el.find('.next').show();
    PartirPage.el.find('.noReturn').hide();
    PartirPage.state = "travel4";
    PartirPage.waiting = false;
    setTimeout(function(){
        PartirPage.tooLate = false;
        hidePopUp(PartirPage);
    },500);
    Notification.handleNotification();
    Menu.scroller(PartirPage);
};

PartirPage.fillDate = function () {
    var date = new Date();
    var day = parseInt(PartirPage.el.find("input[name='dayInput']").val(), 10);
    var month = parseInt(PartirPage.el.find("input[name='month']").val(), 10);
    var year = parseInt(PartirPage.el.find("input[name='year']").val(), 10);
    var hourMin = parseInt(PartirPage.el.find("input[name='hourMin']").val(), 10);
    var hourMax = parseInt(PartirPage.el.find("input[name='hourMax']").val(), 10);
    var minutesMin = parseInt(PartirPage.el.find("input[name='minutesMin']").val(), 10);
    var minutesMax = parseInt(PartirPage.el.find("input[name='minutesMax']").val(), 10);

    PartirPage.dateMin = new Date(year, month-1, day, hourMin, minutesMin, 0, 0);
    PartirPage.dateMax = new Date(year, month-1, day, hourMax, minutesMax, 0, 0);

    if (minutesMin < 10) minutesMin = "0" + minutesMin;
    if (minutesMax < 10) minutesMax = "0" + minutesMax;
    if (hourMin < 10) hourMin = "0" + hourMin;
    if (hourMax < 10) hourMax = "0" + hourMax;
    if (day < 10) day = "0" + day;
    if (month < 10) month = "0" + month;
    
    if (hourMin !== hourMax || minutesMin !== minutesMax) {
        PartirPage.el.find('.departureTimeMin').html("<span class='normalColour'>Entre </span>" + hourMin + ":" + minutesMin);
        PartirPage.el.find('.departureTimeMax').html("<span class='normalColour'> et </span>" + hourMax + ":" + minutesMax);
    } else {
        PartirPage.el.find('.departureTimeMin').html("<span class='normalColour'>À </span>" + hourMin + ":" + minutesMin);
        PartirPage.el.find('.departureTimeMax').html("");
    }

    if (date.getDate() === parseInt(day, 10) && (date.getMonth() + 1) === parseInt(month, 10) && date.getFullYear() === year)
        PartirPage.el.find('.day').html("Aujourd'hui");
    else
        PartirPage.el.find('.day').html("Le " + day + "/" + month + "/" + year);

};

PartirPage.initDate = function () {
    var date = new Date();
    var moduloMin = date.getMinutes() % 5;
    if (moduloMin !== 0) {
        date = new Date(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes() + 5 - moduloMin);
    }
    
    var dayNum = date.getDate();
    if (dayNum < 10) dayNum = "0"+dayNum;
    var monthNum = date.getMonth() + 1;
    if (monthNum < 10) monthNum = "0"+monthNum;
    var dayH = date.getHours();
    if (dayH < 10) dayH = "0"+dayH;
    var dayM = date.getMinutes();
    if (dayM < 10) dayM = "0"+dayM;    
    PartirPage.el.find("input[name='dayInput']").val(dayNum);
    PartirPage.el.find("input[name='month']").val(monthNum);
    PartirPage.el.find("input[name='year']").val(date.getFullYear());
    PartirPage.el.find("input[name='hourMin']").val(dayH);
    PartirPage.el.find("input[name='hourMax']").val(dayH);
    PartirPage.el.find("input[name='minutesMin']").val(dayM);
    PartirPage.el.find("input[name='minutesMax']").val(dayM);
    PartirPage.fillDate();
};

PartirPage.computeRegularity = function(page) {
    var i = 0;
    if (page.el.find("input[value='lun']").parent().hasClass('selectedLabel')) {
        i += 1;
    }
    if (page.el.find("input[value='mar']").parent().hasClass('selectedLabel')) {
        i += 2;
    }
    if (page.el.find("input[value='mer']").parent().hasClass('selectedLabel')) {
        i += 2 * 2;
    }
    if (page.el.find("input[value='jeu']").parent().hasClass('selectedLabel')) {
        i += 2 * 2 * 2;
    }
    if (page.el.find("input[value='ven']").parent().hasClass('selectedLabel')) {
        i += 2 * 2 * 2 * 2;
    }
    if (page.el.find("input[value='sam']").parent().hasClass('selectedLabel')) {
        i += 2 * 2 * 2 * 2 * 2;
    }
    if (page.el.find("input[value='dim']").parent().hasClass('selectedLabel')) {
        i += 2 * 2 * 2 * 2 * 2 * 2;
    }
    
    return i;
};

PartirPage.getVehicles = function () {
    serverRequest(
        "/travel/defaultPrefs",
        "GET",
        PartirPage.getVehiclesSuccess,
        "get vehicles PartirPage",
        PartirPage.getVehicles,
        null
    );
};

PartirPage.getVehiclesSuccess = function (data) {
    if (typeof data.firm === "undefined") {
        PartirPage.canPro = false;
        PartirPage.goToTravel1();
        delete PartirPage.firmId;
    } else {
        PartirPage.firmId = data.firm;
        PartirPage.canPro = true;
        PartirPage.firmVehicleId = data.firmVehicleId;
        PartirPage.goToTravel0();
    }
    PartirPage.vehicles = JSON.parse(data.vehicles);
    PartirPage.fillInVehicles();
    PartirPage.preferences = JSON.parse(data.preferences);
    if(data.transport === 'MOTO' || data.transport === 'BOTH') PartirPage.preferences.motoRider = true;
    if (!PartirPage.canPro)
        PartirPage.preSelectType();
    Partir2Page.getFavorites();
    Partir3Page.getFavorites();
};

PartirPage.preSelectType = function() {
    if (PartirPage.el.find('select[name="vehicule"]').html() === "")
        PartirPage.el.find('label[for="radioRolePa"]').trigger('touchstart').trigger('touchend');
};

PartirPage.fillInVehicles = function () {
    PartirPage.el.find('select[name="vehicule"]').html("");
    for (var i = 0; i < PartirPage.vehicles.length; i++) {
        if (PartirPage.vehicles[i].idvehicle !== PartirPage.firmVehicleId)
            PartirPage.el.find('select[name="vehicule"]').append('<option value=' + PartirPage.vehicles[i].idvehicle + '>' + escapeXml(PartirPage.vehicles[i].name) + '</option>');
    }
};

PartirPage.fillInPreferences = function (role) {
    if (role === "driver" | role === "both") {
        if (PartirPage.canPro & PartirPage.journeyNature === "pro") {
            PartirPage.el.find('.driver select[name="vehicule"]').val(PartirPage.firmVehicleId);
            PartirPage.handleHelmetDriverSeats(PartirPage.firmVehicleId);
        } else if (typeof PartirPage.preferences.vehicleIdvehicle !== 'undefined'){
            var id = PartirPage.preferences.vehicleIdvehicle.idvehicle;
            PartirPage.el.find('.driver select[name="vehicule"]').val(id);
            PartirPage.handleHelmetDriverSeats(id);
        } else {
            var id = parseInt(PartirPage.el.find('.driver select[name="vehicule"]').val());
            PartirPage.handleHelmetDriverSeats(id);
        }
        PartirPage.el.find('.driver select[name="detour"]').val(PartirPage.preferences.detourDriver);
        PartirPage.el.find('.driver input[name="bag"]').prop('checked', PartirPage.preferences.luggageDriver);
        PartirPage.el.find('.driver input[name="helmet"]').prop('checked',PartirPage.preferences.helmetDriver);
    }
    if (role === "passenger" | role === "both") {
        if (PartirPage.preferences.motoRider) PartirPage.el.find('.passenger .helmet').show();
        else PartirPage.el.find('.passenger .helmet').hide();
        PartirPage.el.find('.passenger select[name="seats"]').val('1');
        PartirPage.el.find('.passenger select[name="detour"]').val(PartirPage.preferences.detourPassenger);
        PartirPage.el.find('.passenger input[name="bag"]').prop('checked', PartirPage.preferences.luggagePassenger);
        PartirPage.el.find('.passenger input[name="helmet"]').prop('checked',PartirPage.preferences.helmetPassenger);
    }
};

//Affiche la page
PartirPage.render = function () {
    if (PartirPage.reload === true) {
        showLoading();
        PartirPage.el.find(".both").show();
        PartirPage.reset();
        this.el.addClass("shown");
        PartirPage.getVehicles();
        PartirPage.reload = false;
    } else {
        this.el.addClass("shown");
        Menu.scroller(PartirPage, true);
    }
    PartirPage.TimeLaps = 0;
};

PartirPage.reset = function () {
    PartirPage.backToTravelPage();
    PartirPage.regularity = 0;
    PartirPage.initDate();
    delete PartirPage.departureObject;
    delete PartirPage.arrivalAltObject;
    delete PartirPage.arrivalObject;
    PartirPage.el.find('select[name="vehicule"]').html("");
    var img = PartirPage.el.find('.selectedLabel').find('img');
    if (img.length !== 0) {
        replaceImgSrc(img.attr("src").substring(0, img.attr("src").length - 5) + "0.svg", img);
    }
    PartirPage.el.find('.selectedLabel').removeClass("selectedLabel");
    PartirPage.el.find('.selectedProTab').removeClass("selectedProTab");
    PartirPage.el.find('.driver').hide();
    PartirPage.el.find('.travel0').hide();
    PartirPage.el.find('.travel1').hide();
    PartirPage.el.find('.passenger').hide();
    PartirPage.el.find('.travel2').hide();
    PartirPage.el.find('.travel3').hide();
    PartirPage.el.find('.travel4').hide();
    PartirPage.el.find('.travel5').hide();
    PartirPage.el.find('.travel6').hide();
    PartirPage.el.find('.first').show();
    PartirPage.el.find('.next').hide();
    PartirPage.el.find('.noReturn').hide();
    
    if (window.localStorage.getArray("partir3Favorites").length > 0)
        PartirPage.el.find('.star').show();
    else
        PartirPage.el.find('.star').hide();
    PartirPage.el.find('.departure .adress').html('Départ');
    PartirPage.el.find('.arrival .adress').html('Destination');
    PartirPage.el.find('.alt_arrival .adress').html('Destination alternative');
    PartirPage.el.find(".adress").addClass('grey');
    PartirPage.reload = true;
    delete PartirPage.addresses;
    delete PartirPage.synchroTool;
    PartirPage.waiting = false;
    delete PartirPage.journeyNature;
    if (!localStorage.partir2Tuto)
        Partir2Page.displayTuto = true;
};

PartirPage.handleHelmetDriverSeats = function(id) {
    var vehicle = PartirPage.getDriverVehicle(id);
    if (vehicle.type === "moto") PartirPage.el.find('.driver .helmet').show();
    else PartirPage.el.find('.driver .helmet').hide();
    PartirPage.el.find('.driver select[name="seats"]').val(vehicle.freeSeats);
};

PartirPage.getDriverVehicle = function(id) {
    var result = $.grep(PartirPage.vehicles, function (e) {
        return e.idvehicle === id;
    });
    return result[0];
};

PartirPage.compareDates = function(a,b) {
    // Compare two dates (could be of any type supported by the convert
    // function above) and returns:
    //  -1 : if a < b
    //   0 : if a = b
    //   1 : if a > b
    // NaN : if a or b is an illegal date
    // NOTE: The code inside isFinite does an assignment (=).
    return (
        isFinite(a=PartirPage.convertDates(a).valueOf()) &&
        isFinite(b=PartirPage.convertDates(b).valueOf()) ?
        (a>b)-(a<b) :
        NaN
    );
};
    
PartirPage.convertDates = function(d) {
    // Converts the date in d to a date-object. The input can be:
    //   a date object: returned without modification
    //  an array      : Interpreted as [year,month,day]. NOTE: month is 0-11.
    //   a number     : Interpreted as number of milliseconds
    //                  since 1 Jan 1970 (a timestamp) 
    //   a string     : Any format supported by the javascript engine, like
    //                  "YYYY/MM/DD", "MM/DD/YYYY", "Jan 31 2009" etc.
    //  an object     : Interpreted as an object with year, month and date
    //                  attributes.  **NOTE** month is 0-11.
    return (
        d.constructor === Date ? d :
        d.constructor === Array ? new Date(d[0],d[1],d[2]) :
        d.constructor === Number ? new Date(d) :
        d.constructor === String ? new Date(d) :
        typeof d === "object" ? new Date(d.year,d.month,d.date) :
        NaN
    );
};

PartirPage.addMinAddH = function(object, isHour) {
    clearTimeout(PartirPage.timer);
    clearInterval(PartirPage.interval);
    var num = parseInt(object.parent().find('input').val(), 10);
    if (isHour)
        object.parent().find('input').val(num + 1).blur();
    else {
        var modulo = 5 - num % 5;
        if (modulo !== 0)
            object.parent().find('input').val(num + modulo).blur();
        else
            object.parent().find('input').val(num + 5).blur();
    }
    PartirPage.timer = setTimeout(function(){
    if (object.hasClass('addMin')) PartirPage.timeOutMin(object, "plus", 5, 300);
    else if (object.hasClass('addCent')) PartirPage.timeOutMin(object, "plus", 5, 100);
    else PartirPage.timeOutH(object, "plus");
    },300);
    object.one('touchend', function () {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
    });
};

PartirPage.subMinSubH = function(object, isHour) {
    clearTimeout(PartirPage.timer);
    clearInterval(PartirPage.interval);
    var num = parseInt(object.parent().find('input').val(), 10);
    if (isHour)
        object.parent().find('input').val(num - 1).blur();
    else {
        var modulo = num % 5;
        if (modulo !== 0)
            object.parent().find('input').val(num - modulo).blur();
        else
            object.parent().find('input').val(num - 5).blur();
    }
    PartirPage.timer = setTimeout(function(){
    if (object.hasClass('substractMin')) PartirPage.timeOutMin(object, "substract", 5, 300);
    else if (object.hasClass('substractCent')) PartirPage.timeOutMin(object, "substract", 5, 100);
    else PartirPage.timeOutH(object, "substract");
    },300);
    object.one('touchend', function () {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
    });
};

PartirPage.addDayAddMonthAddYear = function(page, object) {
    clearTimeout(PartirPage.timer);
    clearInterval(PartirPage.interval);
    var kind;
    if (object.hasClass('addYear')) kind = 'year';
    else if (object.hasClass('addMonth')) kind = 'month';
    else if (object.hasClass('addDay')) kind = 'day';
    PartirPage.timeOutDateAction("plus", kind, page);
    PartirPage.timer = setTimeout(function(){
    PartirPage.timeOutDate("plus", kind, page);
    },300);
    object.one('touchend', function () {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
    });
};

PartirPage.subDaySubMonthSubYear = function(page, object) {
    clearTimeout(PartirPage.timer);
    clearInterval(PartirPage.interval);
    var kind;
    if (object.hasClass('substractYear')) kind = 'year';
    else if (object.hasClass('substractMonth')) kind = 'month';
    else if (object.hasClass('substractDay')) kind = 'day';
    PartirPage.timeOutDateAction("substract", kind, page);
    PartirPage.timer = setTimeout(function(){
    PartirPage.timeOutDate("substract", kind, page);
    },300);
    object.one('touchend', function () {
        clearTimeout(PartirPage.timer);
        clearInterval(PartirPage.interval);
    });
};

PartirPage.blurDayMonthYear = function(page) {
    if (page.el.find("input[name='dayInput']").val() === "")
        page.el.find("input[name='dayInput']").val("01");
    if (page.el.find("input[name='month']").val() === "")
        page.el.find("input[name='month']").val("01");
    if (page.el.find("input[name='year']").val() === "")
        page.el.find("input[name='year']").val("2015");
    var day = parseInt(page.el.find("input[name='dayInput']").val(), 10);
    var month = parseInt(page.el.find("input[name='month']").val(), 10);
    var year = parseInt(page.el.find("input[name='year']").val(), 10);
    var date = new Date(Date.UTC(year, month-1, day, 0, 0, 0, 0));
    var dayNum = date.getDate();
    if (dayNum < 10) dayNum = "0"+dayNum;
    var monthNum = date.getMonth() + 1;
    if (monthNum < 10) monthNum = "0"+monthNum;
    page.el.find("input[name='dayInput']").val(dayNum);
    page.el.find("input[name='month']").val(monthNum);
    page.el.find("input[name='year']").val(date.getFullYear());
};

PartirPage.blurHminHmax = function(page, object) {
    if (object.val() === "")
        object.val("01");
    if (parseInt(object.val(), 10) > 23) {
        object.val('00');
    } else if (parseInt(object.val(), 10) < 0) {
        object.val(23);
    }
    if (object.attr('name') === 'hourMin') {
        PartirPage.backToTimeLaps(page);
    } else { //Prevent the timeLaps from being greater than 10
        PartirPage.controlTimeLaps(page);
        PartirPage.TimeLaps = PartirPage.computeTimeLaps(page);
    }
    PartirPage.handleZeros(page);
};

PartirPage.blurMminMmax = function(page, object) {
    if (object.val() === "")
        object.val("01");
    if (parseInt(object.val(), 10) > 59) {
        object.val('00');
        if (object.attr('name') === 'minutesMin') {
            var hMin = page.el.find("input[name='hourMin']").val();
            if (hMin === '23') page.el.find("input[name='hourMin']").val('00');
            else page.el.find("input[name='hourMin']").val(parseInt(hMin, 10) + 1);
        }
        else {
            var hMax = page.el.find("input[name='hourMax']").val();
            if (hMax === '23') page.el.find("input[name='hourMax']").val('00');
            else page.el.find("input[name='hourMax']").val(parseInt(hMax, 10) + 1);
        }
    } else if (parseInt(object.val(), 10) < 0) {
        object.val(55);
        if (object.attr('name') === 'minutesMin') {
            var hMin = page.el.find("input[name='hourMin']").val();
            if (hMin === '00') page.el.find("input[name='hourMin']").val(23);
            else page.el.find("input[name='hourMin']").val(parseInt(hMin, 10) - 1);
        }
        else {
            var hMax = page.el.find("input[name='hourMax']").val();
            if (hMax === '00') page.el.find("input[name='hourMax']").val(23);
            else page.el.find("input[name='hourMax']").val(parseInt(hMax, 10) - 1);
        }
    }

    if (object.attr('name') === 'minutesMin') {
        PartirPage.backToTimeLaps(page);
    } else { //Prevent the timeLaps from being greater than 10
        PartirPage.controlTimeLaps(page);
        PartirPage.TimeLaps = PartirPage.computeTimeLaps(page);
    }

    PartirPage.handleZeros(page);
};

PartirPage.computeTimeLaps = function(page) {
    var hourMin = parseInt(page.el.find("input[name='hourMin']").val(), 10);
    var hourMax = parseInt(page.el.find("input[name='hourMax']").val(), 10);
    var minutesMin = parseInt(page.el.find("input[name='minutesMin']").val(), 10);
    var minutesMax = parseInt(page.el.find("input[name='minutesMax']").val(), 10);
    var dateMin = new Date(115, 1, 1, hourMin, minutesMin, 0, 0);
    var dateMax = new Date(115, 1, 1, hourMax, minutesMax, 0, 0);

    return dateMax.getTime() - dateMin.getTime();
};

PartirPage.backToTimeLaps = function(page) {
    var hourMin = parseInt(page.el.find("input[name='hourMin']").val(), 10);
    var minutesMin = parseInt(page.el.find("input[name='minutesMin']").val(), 10);
    var date = new Date(115, 1, 1, hourMin, minutesMin, 0, 0);
    date.setTime(date.getTime() + PartirPage.TimeLaps);
    
    page.el.find('input[name="hourMax"]').val(date.getHours());
    page.el.find("input[name='minutesMax']").val(date.getMinutes());
};

PartirPage.controlTimeLaps = function(page) {
    var timeLaps = PartirPage.computeTimeLaps(page);
    if ((-21600000 < timeLaps & timeLaps < 0) | timeLaps > 57600000) {
        page.el.find('input[name="hourMax"]').val(page.el.find("input[name='hourMin']").val());
        page.el.find("input[name='minutesMax']").val(page.el.find("input[name='minutesMin']").val());
    } else if (timeLaps > 36000000 | (-50400000 < timeLaps & timeLaps < 0)) {
        page.el.find('input[name="hourMax"]').val(parseInt(page.el.find('input[name="hourMin"]').val(), 10) + 10);
        var hMaxRes = parseInt(page.el.find('input[name="hourMax"]').val(), 10); 
        if (hMaxRes > 23)
            page.el.find('input[name="hourMax"]').val(hMaxRes - 24);
        page.el.find("input[name='minutesMax']").val(page.el.find("input[name='minutesMin']").val());
    }
};

PartirPage.handleZeros = function(page) {
    var value = parseInt(page.el.find('input[name="hourMax"]').val(), 10);
    if (value < 10) page.el.find('input[name="hourMax"]').val("0"+value);
    value = parseInt(page.el.find('input[name="hourMin"]').val(), 10);
    if (value < 10) page.el.find('input[name="hourMin"]').val("0"+value);
    value = parseInt(page.el.find('input[name="minutesMin"]').val(), 10);
    if (value < 10) page.el.find('input[name="minutesMin"]').val("0"+value); 
    value = parseInt(page.el.find('input[name="minutesMax"]').val(), 10);
    if (value < 10) page.el.find('input[name="minutesMax"]').val("0"+value);
};
